﻿Imports System.Math
Public Class frmEnvironnement

    Private Sub frmEnvironnement_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        If PlanCont.Count = 1 Then
            'onglet Durabilité
            BtnMoinsExpo.Visible = False : BtnPlusExpo.Visible = False : ChkbEnvTtesTravees.Visible = False : ChkbHarmoEnrobage.Visible = False
        End If
        'onglet Durabilité
        BtnMoinsExpo.Visible = False
        'onglet Résistance sismique
        TC1.TabPages.RemoveAt(5) 'provisoire en attendant de rendre cet onglet opérationnel daans les prochains modules
        'Appel au module affichage
        Call Affichage()
    End Sub

    Private Sub BtnOK_Click(sender As Object, e As EventArgs) Handles BtnOK.Click
        Dim Verif As Boolean = True
        Call Lecture(Verif)
        If Verif = False Then Exit Sub
        Call Verification(Verif)
        If Verif = False Then Exit Sub
        Me.Dispose()
        Me.Close()
    End Sub
    Private Sub BtnAnnuler_Click(sender As Object, e As EventArgs) Handles BtnAnnuler.Click
        Me.Dispose()
        Me.Close()
    End Sub
    Private Sub Lecture(ByRef Verif As Boolean)
        Dim i As Integer
        Dim msg As String = String.Empty
        Try
            ' Onglet ELU
            If RbtnElastiqueRedistribution.Checked = True Then
                Aff.Redistrib_limit = True
                If gestionderreur(txtDelta) = True Then
                    Aff.δ = CDbl(txtDelta.Text)
                Else
                    msg = msg & Environment.NewLine & "Valeur de redistribution non renseignée." : Verif = False
                End If
            Else
                Aff.Redistrib_limit = False
            End If

            If ChkbEcretage.Checked = True Then Aff.Ecretage_Moment = True Else Aff.Ecretage_Moment = False
            Select Case PlanCont(0).modele_calcul
                Case 1 '->plancher unidirectionnel
                    If Chkb15M0.Checked = True Then Aff.Reprise_M0_1_porteur = True Else Aff.Reprise_M0_1_porteur = False
                    If Chkb_EncastPartiel.Checked = True Then Aff.EncastPartiel_1_porteur = True Else Aff.EncastPartiel_1_porteur = False

                Case 2 '->plancher bidirectionnel
                    If Chkb15M0_2Porteur.Checked = True Then Aff.Reprise_M0_2_porteur = True Else Aff.Reprise_M0_2_porteur = False
                    If ChkTransHAsup.Checked = True Then Aff.HA_Trans_Appui = True Else Aff.HA_Trans_Appui = False
                    For Each dalle As Plancher In PlanCont
                        With dalle
                            If gestionderreur(txtNu_eff) = True Then
                                .ν_eff = CDbl(txtNu_eff.Text)
                            Else
                                msg = msg & Environment.NewLine & "travée n°" & (PlanCont.IndexOf(dalle) + 1).ToString & ": Coefficient de Poisson pour le calcul des efforts et contraintes non renseigné." : Verif = False
                            End If
                            If gestionderreur(txtNu_fl) = True Then
                                .ν_fl = CDbl(txtNu_fl.Text)
                            Else
                                msg = msg & Environment.NewLine & "travée n°" & (PlanCont.IndexOf(dalle) + 1).ToString & ": Coefficient de Poisson pour le calcul des flèches non renseigné." : Verif = False
                            End If
                            .Rang = CInt(NudRang.Value)
                            .Taille = CInt(NudMaille.Value) / 100
                        End With
                    Next
            End Select
            'Onglet ELS
            '->Contrainte
            If RbtnForcerN.Checked = True Then
                aci.n_Forcer_Cont = True
                If gestionderreur(txtnCont) = True Then
                    aci.n_Cont = CDbl(txtnCont.Text)
                Else
                    msg = msg & Environment.NewLine & ": Coefficient d'équivalence N contraintes non renseigné." : Verif = False
                End If
            Else
                aci.n_Forcer_Cont = False
                If gestionderreur(txtRHCont) = True Then
                    Aff.RH = CInt(txtRHCont.Text)
                Else
                    msg = msg & Environment.NewLine & ": Taux hygrométrie contrainte non renseigné." : Verif = False
                End If
                If gestionderreur(txtT0Cont) = True Then
                    Aff.t0 = CInt(txtT0Cont.Text)
                Else
                    msg = msg & Environment.NewLine & ": Chargement age initial contrainte non renseigné." : Verif = False
                End If
                Aff.tinf = CbTinfCont.SelectedIndex
                If CbTinfCont.SelectedIndex = -1 Then
                    msg = msg & Environment.NewLine & ": Chargement age final contrainte non renseigné." : Verif = False
                End If
            End If
            '->Contrainte Plancher Prédalle
            If PlanCont.Item(0).Prefa = True Then
                For Each dalle As Plancher In PlanCont
                    If ChkbCalculContraintePredalle.Checked = True Then dalle.Prefa_Contrainte = True Else dalle.Prefa_Contrainte = False
                Next
            End If
            '->Flèche
            If RbtnNforcerFleche.Checked = True Then
                aci.n_Forcer_Fl = True
                If gestionderreur(txtnFl) = True Then
                    aci.n_Fl = CDbl(txtnFl.Text)
                Else
                    msg = msg & Environment.NewLine & ": Coefficient d'équivalence N flèches non renseignée." : Verif = False
                End If
            Else
                aci.n_Forcer_Fl = False
                If gestionderreur(txtRHFl) = True Then
                    Aff.RH_Fl = CInt(txtRHFl.Text)
                Else
                    msg = msg & Environment.NewLine & ": Taux hygrométrie flèches non renseigné." : Verif = False
                End If
                If gestionderreur(txtT0Fl) = True Then
                    Aff.t0_Fl = CInt(txtT0Fl.Text)
                Else
                    msg = msg & Environment.NewLine & ": Chargement age initial flèches non renseigné." : Verif = False
                End If
                Aff.tinf_Fl = CbTinfFl.SelectedIndex
                If CbTinfFl.SelectedIndex = -1 Then
                    msg = msg & Environment.NewLine & ": Chargement age final flèches non renseigné." : Verif = False
                End If
            End If
            If PlanCont.Item(0).Prefa = True Then
                For Each dalle As Plancher In PlanCont
                    If gestionderreur(txtPrefa_t) = True Then
                        dalle.Prefa_t = CInt(txtPrefa_t.Text)
                    Else
                        msg = msg & Environment.NewLine & ": age chargement dalle préfa non renseigné." : Verif = False : Exit For
                    End If
                    If Chkb_Prefa_fragile.Checked = True Then dalle.Prefa_fragile = True Else dalle.Prefa_fragile = False
                Next
            End If
            'Onglet Effort Tranchant__________________________________________________________________________________________________
            If ChkbDecal_ET_Charge_Appui.Checked = True Then Aff.MinorationQ_ET = True Else Aff.MinorationQ_ET = False
            If ChkbDecal_ET_Charge_UR.Checked = True Then Aff.Decalage_ET = True Else Aff.Decalage_ET = False
            'Onglet Environnement_____________________________________________________________________________________________________________________________
            i = CInt(LblnbTrav.Text)
            Call Lecture_Onglet_Durabilite(i, Verif)
            'Onglet Résistance au feu____________________________________________________________________________________________________________________________
            i = CInt(lblFeuNumTrav.Text)
            Call Lecture_Onglet_Feu(i, Verif)
        Catch ex As Exception
            MessageBox.Show("Module Lecture" & Environment.NewLine & "Erreur: " & Environment.NewLine & ex.Message, "Formulaire Modélisation",
                          MessageBoxButtons.OK, MessageBoxIcon.Warning, MessageBoxDefaultButton.Button1)
        End Try

        If Verif = False Then MessageBox.Show(msg, "Modélisation - Onglets ELU/ELS", MessageBoxButtons.OK, MessageBoxIcon.Error)

    End Sub
    ''' <summary>Lecture de l'onglet durabilité </summary>
    ''' <param name="i">i = n° de travée</param>
    ''' <param name="verif"> variable prenant la valeur False si une erreur bloquante s'est produite pendant la lecture</param>
    Private Sub Lecture_Onglet_Durabilite(ByVal i As Integer, ByRef Verif As Boolean)
        Dim j, j1 As Integer
        Dim msg As String = "L'enrobage nominal excède la limite haute ou basse autorisée par l'EN1992-1-1:" & Environment.NewLine
        Dim msg1 As String = String.Empty
        If ChkbEnrobage.Checked = True Then
            If ChkbEnvTtesTravees.Checked = True Then 'enrobage forcé

                For j = 1 To PlanCont.Count
                    j1 = 0
                    With PlanCont.Item(j - 1)
                        .Enrobage = True
                        If gestionderreur(TxtenrInf) = True Then
                            .enrInf = CDbl(TxtenrInf.Text) / 100
                            If .enrInf < 0.01 Or .enrInf > 0.05 Then
                                msg = msg + "  - travée " & j.ToString("#") & " - enrobage nominal inférieur = " & (.enrInf * 100).ToString("#.0") & " cm."
                                j1 = 1
                            End If
                        Else
                            msg1 = msg1 & Environment.NewLine & "Travée n°" & j.ToString & " - Enrobage inférieur non renseigné." : Verif = False
                        End If
                        If gestionderreur(TxtenrLat) = True Then
                            .enrLat = CDbl(TxtenrLat.Text) / 100
                            If .enrLat < 0.01 Or .enrLat > 0.05 Then
                                msg = msg + "  - travée " & j.ToString("#") & " - enrobage nominal latéral = " & (.enrLat * 100).ToString("#.0") & " cm."
                                j1 = 1
                            End If
                        Else
                            msg1 = msg1 & Environment.NewLine & "Travée n°" & j.ToString & " - Enrobage latéral non renseigné." : Verif = False
                        End If
                        If gestionderreur(TxtEnrSup) = True Then
                            .enrSup = CDbl(TxtEnrSup.Text) / 100
                            If .enrSup < 0.01 Or .enrSup > 0.05 Then
                                msg = msg + "  - travée " & j.ToString("#") & " - enrobage nominal supérieur = " & (.enrSup * 100).ToString("#.0") & " cm."
                                j1 = 1
                            End If
                        Else
                            msg1 = msg1 & Environment.NewLine & "Travée n°" & j.ToString & " - Enrobage supérieur non renseigné." : Verif = False
                        End If
                        Dim result As DialogResult
                        If j1 = 1 Then result = MessageBox.Show(msg & Environment.NewLine & "Voulez-vous modifier les valeurs?", "Enrobage", MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1)
                        If result = DialogResult.Yes Then Verif = False : Exit Sub
                    End With
                Next
            Else
                PlanCont.Item(i - 1).Enrobage = True
                If gestionderreur(TxtenrInf) = True Then
                    PlanCont.Item(i - 1).enrInf = CDbl(TxtenrInf.Text) / 100
                Else
                    msg1 = msg1 & Environment.NewLine & "Travée n°" & i.ToString & " - Enrobage inférieur non renseigné." : Verif = False
                End If
                If gestionderreur(TxtenrLat) = True Then
                    PlanCont.Item(i - 1).enrLat = CDbl(TxtenrLat.Text) / 100
                Else
                    msg1 = msg1 & Environment.NewLine & "Travée n°" & i.ToString & " - Enrobage latéral non renseigné." : Verif = False
                End If
                If gestionderreur(TxtEnrSup) = True Then
                    PlanCont.Item(i - 1).enrSup = CDbl(TxtEnrSup.Text) / 100
                Else
                    msg1 = msg1 & Environment.NewLine & "Travée n°" & i.ToString & " - Enrobage supérieur non renseigné." : Verif = False
                End If
            End If
        Else
            '--> enrobage calulé suivant la classe d'exposition
            If ChkbEnvTtesTravees.Checked = True Then
                '--> enrobage identique sur l'ensemble des travées
                For j = 1 To PlanCont.Count
                    With PlanCont.Item(j - 1)
                        Dim Coche_Expo As Boolean = False
                        Call remise_a_0_trave_durabilite(j)
                        If ChkbX0.Checked = True Then
                            .X0 = True : Coche_Expo = True
                        Else
                            If RbtnXc1.Checked = True Then .XC1 = True : Coche_Expo = True
                            If RbtnXc2.Checked = True Then .XC2 = True : Coche_Expo = True
                            If RbtnXc3.Checked = True Then .XC3 = True : Coche_Expo = True
                            If RbtnXc4.Checked = True Then .XC4 = True : Coche_Expo = True
                            If RbtnXd1.Checked = True Then .XD1 = True : Coche_Expo = True
                            If RbtnXd2.Checked = True Then .XD2 = True : Coche_Expo = True
                            If RbtnXd3.Checked = True Then .XD3 = True : Coche_Expo = True
                            If RbtnXs1.Checked = True Then .XS1 = True : Coche_Expo = True
                            If RbtnXs2.Checked = True Then .XS2 = True : Coche_Expo = True
                            If RbtnXs3.Checked = True Then .XS3 = True : Coche_Expo = True
                            If RbtnXf1.Checked = True Then .XF1 = True : Coche_Expo = True
                            If RbtnXf2.Checked = True Then .XF2 = True : Coche_Expo = True
                            If RbtnXf3.Checked = True Then .XF3 = True : Coche_Expo = True
                            If RbtnXf4.Checked = True Then .XF4 = True : Coche_Expo = True
                            If RbtnXa1.Checked = True Then .XA1 = True : Coche_Expo = True
                            If RbtnXa2.Checked = True Then .XA2 = True : Coche_Expo = True
                            If RbtnXa3.Checked = True Then .XA3 = True : Coche_Expo = True
                        End If
                        .Enrobage = False
                        If Coche_Expo = False Then
                            MessageBox.Show("Aucune classe d'exposition n'a été cochée !", "Module lecture de données", MessageBoxButtons.OK, MessageBoxIcon.Error)
                            Verif = False
                        End If
                    End With
                Next
            Else
                With PlanCont.Item(i - 1)
                    Call Remise_a_0_trave_durabilite(i) 'pour éviter toute confusion avec des données précédement entrées.
                    Dim Coche_Expo As Boolean = False
                    If ChkbX0.Checked = True Then
                        .X0 = True : Coche_Expo = True
                    Else
                        If RbtnXc1.Checked = True Then .XC1 = True : Coche_Expo = True
                        If RbtnXc2.Checked = True Then .XC2 = True : Coche_Expo = True
                        If RbtnXc3.Checked = True Then .XC3 = True : Coche_Expo = True
                        If RbtnXc4.Checked = True Then .XC4 = True : Coche_Expo = True
                        If RbtnXd1.Checked = True Then .XD1 = True : Coche_Expo = True
                        If RbtnXd2.Checked = True Then .XD2 = True : Coche_Expo = True
                        If RbtnXd3.Checked = True Then .XD3 = True : Coche_Expo = True
                        If RbtnXs1.Checked = True Then .XS1 = True : Coche_Expo = True
                        If RbtnXs2.Checked = True Then .XS2 = True : Coche_Expo = True
                        If RbtnXs3.Checked = True Then .XS3 = True : Coche_Expo = True
                        If RbtnXf1.Checked = True Then .XF1 = True : Coche_Expo = True
                        If RbtnXf2.Checked = True Then .XF2 = True : Coche_Expo = True
                        If RbtnXf3.Checked = True Then .XF3 = True : Coche_Expo = True
                        If RbtnXf4.Checked = True Then .XF4 = True : Coche_Expo = True
                        If RbtnXa1.Checked = True Then .XA1 = True : Coche_Expo = True
                        If RbtnXa2.Checked = True Then .XA2 = True : Coche_Expo = True
                        If RbtnXa3.Checked = True Then .XA3 = True : Coche_Expo = True
                    End If
                    .Enrobage = False
                    If Coche_Expo = False Then
                        MessageBox.Show("Aucune classe d'exposition n'a été cochée !", "Module lecture de données", MessageBoxButtons.OK, MessageBoxIcon.Error)
                        Verif = False
                    End If
                End With
            End If
            'durée d'utilisation du projet
            Aff.Duree = CbDuree.SelectedIndex
            If CbDuree.SelectedIndex = -1 Then
                MessageBox.Show("Aucune classe d'exposition n'a été cochée !", "Module lecture de données", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Verif = False
            End If
            If CbDuree.SelectedIndex = 0 Or CbDuree.SelectedIndex = 1 Then
                If MessageBox.Show("La durée du projet sélectionnée est inférieure à 50 ans." & Environment.NewLine & "Validez-vous cette donnée?", "Module lecture de données", MessageBoxButtons.YesNo,
                                   MessageBoxIcon.Error) = DialogResult.No Then
                    Verif = False
                End If
            End If
        End If
        'harmonisation enrobage
        If PlanCont.Count = 1 Then
            'on ne fait rien - cela n'a aucune importance
        Else
            If ChkbHarmoEnrobage.Checked = True Then Aff.Harmonisation_Enrobage = True Else Aff.Harmonisation_Enrobage = False
        End If
        If Verif = False Then MessageBox.Show(msg1, "Modélisation - Onglet Durabilité", MessageBoxButtons.OK, MessageBoxIcon.Error)
    End Sub
    ''' <summary>Remise à 0 de la classe d'exposition pour toutes les travées </summary>
    ''' <param name="j">j = n° de travée</param>
    Private Sub Remise_a_0_trave_durabilite(ByVal j As Integer)
        With PlanCont.Item(j - 1)
            .X0 = False
            .XC1 = False
            .XC2 = False
            .XC3 = False
            .XC4 = False
            .XD1 = False
            .XD2 = False
            .XD3 = False
            .XS1 = False
            .XS2 = False
            .XS3 = False
            .XF1 = False
            .XF2 = False
            .XF3 = False
            .XF4 = False
            .XA1 = False
            .XA2 = False
            .XA3 = False
        End With
    End Sub
    Private Sub Lecture_Onglet_Feu(ByVal i As Integer, ByRef Verif As Boolean)
        Dim msg As String = String.Empty
        If ChkbFeuTtesTravees.Checked = True Then
            For i = 1 To PlanCont.Count
                With PlanCont.Item(i - 1)
                    Select Case CbFeu.SelectedIndex
                        Case -1, 0
                            .Feu_REI = 0
                        Case 1 '30mn
                            .Feu_REI = 1
                        Case 2 '60mn
                            .Feu_REI = 2
                        Case 3 '90mn
                            .Feu_REI = 3
                        Case 4 '2h
                            .Feu_REI = 4
                            'Case 5 '3h
                            '    Aff.REI = 5
                            'Case 6 '4h
                            '    Aff.REI = 6
                    End Select
                    If .Feu_REI >= 1 Then 'supérieur ou égal à 30 mn
                        If gestionderreur(txtFeu_EpCarrelage) = True Then
                            .feu_EpCarrelage = CDbl(txtFeu_EpCarrelage.Text) / 100
                        Else
                            msg = msg & Environment.NewLine & "Epaisseur de carrelage non renseignée." : Verif = False
                        End If
                    End If
                End With
            Next
        Else
            With PlanCont.Item(i - 1)
                Select Case CbFeu.SelectedIndex
                    Case -1, 0
                        .Feu_REI = 0
                    Case 1 '30mn
                        .Feu_REI = 1
                    Case 2 '60mn
                        .Feu_REI = 2
                    Case 3 '90mn
                        .Feu_REI = 3
                    Case 4 '2h
                        .Feu_REI = 4
                        'Case 5 '3h
                        '    Aff.REI = 5
                        'Case 6 '4h
                        '    Aff.REI = 6
                End Select
                If .Feu_REI >= 1 Then 'supérieur ou égal à 30 mn
                    If gestionderreur(txtFeu_EpCarrelage) = True Then
                        .feu_EpCarrelage = CDbl(txtFeu_EpCarrelage.Text) / 100
                    Else
                        msg = msg & Environment.NewLine & "Epaisseur de carrelage non renseignée." : Verif = False
                    End If
                End If
            End With
        End If
        If Verif = False Then MessageBox.Show(msg, "Modélisation - Onglet Feu", MessageBoxButtons.OK, MessageBoxIcon.Error)
    End Sub
    Private Sub Verification(ByRef Verif As Boolean)
        Dim msg As String = String.Empty
        If RbtnElastiqueRedistribution.Checked = True Then
            If Aff.δ < 0.7 Then
                msg = msg + "coefficient de redistribution δ < 0,7" + Environment.NewLine
                Verif = False
            End If
        End If
        If aci.n_Forcer_Cont = True Then
            If aci.n_Cont < 2 Then
                msg = msg + "coefficient d'équivalence n < 2 - Calcul contraintes" + Environment.NewLine
                Verif = False
            End If
        End If
        If aci.n_Forcer_Fl = True Then
            If aci.n_Fl < 2 Then
                msg = msg + "coefficient d'équivalence n < 2 - Calcul Flèche" + Environment.NewLine
                Verif = False
            End If
        End If
        If Verif = False Then MessageBox.Show(msg, "Eurocode 2: Environnement", MessageBoxButtons.OK, MessageBoxIcon.Warning)
    End Sub
    Private Function gestionderreur(ByVal e As System.Windows.Forms.TextBox, Optional ByRef Result As Double = 0) As Boolean
        'If e.Text = String.Empty Then
        '    EP1.SetError(e, "le champ n'a pas été renseigné!!")
        '    gestionderreur = False
        'Else
        If Not Double.TryParse(e.Text, Result) Then
            If String.IsNullOrEmpty(e.Text) Then
                EP1.SetError(e, "le champ est vide, il n'a pas été renseigné!!")
                gestionderreur = False
            Else
                ' ElseIf Not IsNumeric(CDbl(e.Text)) Then
                EP1.SetError(e, "le champ n'est pas une valeur numérique !!")
                gestionderreur = False
            End If
        Else
            EP1.SetError(e, "") ' Clear the error.
            gestionderreur = True
        End If
    End Function
    Private Sub Affichage()
        For Each TB As Control In Me.Controls
            If TypeOf (TB) Is TextBox Then TB.Text = ""
        Next

        'onglet modélisation

        If Aff.Redistrib_limit = True Then
            RbtnElastiqueRedistribution.Checked = True
            txtDelta.Text = Aff.δ.ToString
        Else
            txtDelta.Text = "" : txtDelta.Enabled = False
        End If
        If Aff.Ecretage_Moment = True Then ChkbEcretage.Checked = True Else ChkbEcretage.Checked = False
        Select Case PlanCont(0).modele_calcul
            Case 1 '->plancher unidirectionnel
                GbPorteur_2sens.Visible = False
                If Aff.Reprise_M0_1_porteur = True Then Chkb15M0.Checked = True Else Chkb15M0.Checked = False
                If Aff.EncastPartiel_1_porteur = True Then Chkb_EncastPartiel.Checked = True Else Chkb_EncastPartiel.Checked = False

            Case 2 '->plancher bidirectionnel
                GbPorteur_1sens.Visible = False
                If Aff.Reprise_M0_2_porteur = True Then Chkb15M0_2Porteur.Checked = True Else Chkb15M0_2Porteur.Checked = False
                If Aff.HA_Trans_Appui = True Then ChkTransHAsup.Checked = True Else ChkTransHAsup.Checked = False
                txtNu_eff.Text = PlanCont.Item(0).ν_eff.ToString("#0.00")
                txtNu_fl.Text = PlanCont.Item(0).ν_fl.ToString("#0.00")
                NudRang.Value = PlanCont.Item(0).Rang
                NudMaille.Value = CInt(Truncate(PlanCont.Item(0).Taille * 100))

        End Select
        'Onglet ELS
        '-> contraintes
        If aci.n_Forcer_Cont = True Then
            RbtnForcerN.Checked = True : txtnCont.Text = aci.n_Cont.ToString() '"#0.00")
        Else
            RbtnEq720Cont.Checked = True
            txtRHCont.Text = Aff.RH.ToString("#") : txtT0Cont.Text = Aff.t0.ToString
            CbTinfCont.Text = CbTinfCont.Items(Aff.tinf).ToString
        End If
        '-> flèche
        If aci.n_Forcer_Fl = True Then
            RbtnNforcerFleche.Checked = True : txtnFl.Text = aci.n_Fl.ToString("#0.00")
        Else
            RbtnEq720Fleche.Checked = True
            txtRHFl.Text = Aff.RH_Fl.ToString("#") : txtT0Fl.Text = Aff.t0_Fl.ToString
            CbTinfFl.Text = CbTinfFl.Items(Aff.tinf_Fl).ToString
        End If
        If PlanCont.Item(0).Prefa = True Then
            Gb_Prefa_t.Visible = True
            txtPrefa_t.Text = PlanCont.Item(0).Prefa_t.ToString 'le même pour toute les dalles
            If PlanCont.Item(0).Prefa_fragile = True Then Chkb_Prefa_fragile.Checked = True Else Chkb_Prefa_fragile.Checked = False
            ChkbCalculContraintePredalle.Visible = True : BtnHlpChkbCalculContraintePredalle.Visible = True
            If PlanCont.Item(0).Prefa_Contrainte = True Then ChkbCalculContraintePredalle.Checked = True Else ChkbCalculContraintePredalle.Checked = False
        Else
            Gb_Prefa_t.Visible = False
            ChkbCalculContraintePredalle.Visible = False : BtnHlpChkbCalculContraintePredalle.Visible = False
        End If
        'Onglet Effort Tranchant_________________________________________________________________________________________________________
        If Aff.MinorationQ_ET = True Then ChkbDecal_ET_Charge_Appui.Checked = True Else ChkbDecal_ET_Charge_Appui.Checked = False
        If Aff.Decalage_ET = True Then ChkbDecal_ET_Charge_UR.Checked = True Else ChkbDecal_ET_Charge_UR.Checked = False
        'Onglet Durabilité_____________________________________________________________________________________________________________________________
        LblnbTrav.Text = "1"
        Affichage_Onglet_Durabilite(1)
        'Onglet Résistance au feu____________________________________________________________________________________________________________________________
        lblFeuNumTrav.Text = "1"
        Affichage_Onglet_Feu(1)
        'Onglet Résistance au seisme_____________________________________________________________
        Cbsismique.Text = Cbsismique.Items(0).ToString
    End Sub
    Private Sub RbtnElastiqueRedistribution_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnElastiqueRedistribution.CheckedChanged
        If RbtnElastiqueRedistribution.Checked = True Then
            txtDelta.Enabled = True : txtDelta.Focus()
        Else
            txtDelta.Text = "" : txtDelta.Enabled = False
        End If
    End Sub


    Private Sub Affichage_Onglet_Durabilite(ByVal i As Integer)

        If PlanCont.Item(i - 1).Enrobage = True Then
            ChkbEnrobage.Checked = True
            TxtenrInf.Text = (PlanCont.Item(i - 1).enrInf * 100).ToString("#0.0")
            TxtenrLat.Text = (PlanCont.Item(i - 1).enrLat * 100).ToString("#0.0")
            TxtEnrSup.Text = (PlanCont.Item(i - 1).enrSup * 100).ToString("#0.0")
            ChkbX0.Checked = False : RbtnXc1.Checked = False : RbtnXc2.Checked = False : RbtnXc3.Checked = False : RbtnXc4.Checked = False
            RbtnXd1.Checked = False : RbtnXd2.Checked = False : RbtnXd3.Checked = False : RbtnXs1.Checked = False : RbtnXs2.Checked = False : RbtnXs3.Checked = False
            RbtnXf1.Checked = False : RbtnXf2.Checked = False : RbtnXf3.Checked = False : RbtnXf4.Checked = False
            RbtnXa1.Checked = False : RbtnXa2.Checked = False : RbtnXa3.Checked = False
            GBExposition.Enabled = False
        Else
            GBExposition.Enabled = True
            With PlanCont.Item(i - 1)
                If .X0 = True Then
                    ChkbX0.Checked = True
                Else
                    ChkbX0.Checked = False
                    If .XC1 = True Then RbtnXc1.Checked = True
                    If .XC2 = True Then RbtnXc2.Checked = True
                    If .XC3 = True Then RbtnXc3.Checked = True
                    If .XC4 = True Then RbtnXc4.Checked = True
                    If .XD1 = True Then RbtnXd1.Checked = True
                    If .XD2 = True Then RbtnXd2.Checked = True
                    If .XD3 = True Then RbtnXd3.Checked = True
                    If .XS1 = True Then RbtnXs1.Checked = True
                    If .XS2 = True Then RbtnXs2.Checked = True
                    If .XS3 = True Then RbtnXs3.Checked = True
                    If .XF1 = True Then RbtnXf1.Checked = True
                    If .XF2 = True Then RbtnXf2.Checked = True
                    If .XF3 = True Then RbtnXf3.Checked = True
                    If .XF4 = True Then RbtnXf4.Checked = True
                    If .XA1 = True Then RbtnXa1.Checked = True
                    If .XA2 = True Then RbtnXa2.Checked = True
                    If .XA3 = True Then RbtnXa3.Checked = True
                End If
            End With
            'durée d'utilisation du projet
            Select Case Aff.Duree
                Case 0 '10 ans
                    CbDuree.Text = CbDuree.Items(0).ToString
                Case 1 '25 ans
                    CbDuree.Text = CbDuree.Items(1).ToString
                Case 2 '50 ans
                    CbDuree.Text = CbDuree.Items(2).ToString
                Case 3 '100 ans
                    CbDuree.Text = CbDuree.Items(3).ToString
            End Select
        End If
        'harmonisation enrobage
        If PlanCont.Count = 1 Then
            ChkbHarmoEnrobage.Visible = False
        Else
            ChkbHarmoEnrobage.Visible = True
            If Aff.Harmonisation_Enrobage = True Then ChkbHarmoEnrobage.Checked = True Else ChkbHarmoEnrobage.Checked = False
        End If
    End Sub

    Private Sub Affichage_Onglet_Feu(ByVal i As Integer)
        'ChkbFeuTtesTravees.Checked = True Then
        With PlanCont.Item(i - 1)
            Select Case .Feu_REI
                Case -1, 0
                    CbFeu.Text = CbFeu.Items(0).ToString '    Aucun
                Case 1
                    CbFeu.Text = CbFeu.Items(1).ToString '    R30
                Case 2
                    CbFeu.Text = CbFeu.Items(2).ToString '   R60
                Case 3
                    CbFeu.Text = CbFeu.Items(3).ToString '   R90
                Case 4
                    CbFeu.Text = CbFeu.Items(4).ToString '    R120
            End Select
            If .Feu_REI >= 1 Then 'supérieur ou égal à 30 mn
                txtFeu_EpCarrelage.Text = (.feu_EpCarrelage * 100).ToString("#0.0") 'm ->cm
            Else
                txtFeu_EpCarrelage.Text = "0"
            End If
        End With
    End Sub
    Private Sub Initialisation_Onglet_Environnement()
        TxtenrInf.Text = String.Empty
        TxtenrLat.Text = String.Empty
        TxtEnrSup.Text = String.Empty
        ChkbX0.Checked = False : RbtnXc1.Checked = False : RbtnXc2.Checked = False : RbtnXc3.Checked = False : RbtnXc4.Checked = False
        RbtnXd1.Checked = False : RbtnXd2.Checked = False : RbtnXd3.Checked = False : RbtnXs1.Checked = False : RbtnXs2.Checked = False : RbtnXs3.Checked = False
        RbtnXf1.Checked = False : RbtnXf2.Checked = False : RbtnXf3.Checked = False : RbtnXf4.Checked = False
        RbtnXa1.Checked = False : RbtnXa2.Checked = False : RbtnXa3.Checked = False
        GBExposition.Enabled = True
    End Sub

#Region "Gestion Onglet ELS"
    Private Sub RbtnForcerN_CheckedChanged_1(sender As Object, e As EventArgs) Handles RbtnForcerN.CheckedChanged
        If RbtnForcerN.Checked = True Then
            txtRHCont.Text = "" : txtT0Cont.Text = "" : txtRHCont.Enabled = False : txtT0Cont.Enabled = False : CbTinfCont.Enabled = False
            txtnCont.Enabled = True : txtnCont.Focus()
        End If
    End Sub

    Private Sub RbtnEq720Cont_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnEq720Cont.CheckedChanged
        If RbtnEq720Cont.Checked = True Then
            txtRHCont.Enabled = True : txtT0Cont.Enabled = True : CbTinfCont.Enabled = True : txtRHCont.Focus()
            txtnCont.Text = "" : txtnCont.Enabled = False
        End If
    End Sub

    Private Sub RbtnNforcerFleche_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnNforcerFleche.CheckedChanged
        If RbtnNforcerFleche.Checked = True Then
            txtRHFl.Text = "" : txtT0Fl.Text = "" : txtRHFl.Enabled = False : txtT0Fl.Enabled = False : CbTinfFl.Enabled = False
            txtnFl.Enabled = True : txtnFl.Focus()
        End If
    End Sub

    Private Sub RbtnEq720Fleche_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnEq720Fleche.CheckedChanged
        If RbtnEq720Fleche.Checked = True Then
            txtRHFl.Enabled = True : txtT0Fl.Enabled = True : CbTinfFl.Enabled = True : txtRHFl.Focus()
            txtnFl.Text = "" : txtnFl.Enabled = False
        End If
    End Sub
#End Region

#Region "Gestion Onglet Durabilité"
    Private Sub BtnPlusExpo_Click(sender As Object, e As EventArgs) Handles BtnPlusExpo.Click
        Dim i As Integer
        Dim Verif As Boolean = True
        i = CInt(LblnbTrav.Text)   'car la collection commence à 0
        Lecture_Onglet_Durabilite(i, Verif)
        i = i + 1
        BtnMoinsExpo.Visible = True
        If i > PlanCont.Count Then
            BtnPlusExpo.Visible = False
            Exit Sub
        End If
        LblnbTrav.Text = CStr(i)
        Affichage_Onglet_Durabilite(i)
    End Sub

    Private Sub BtnMoinsExpo_Click(sender As Object, e As EventArgs) Handles BtnMoinsExpo.Click
        Dim i As Integer
        Dim Verif As Boolean = True
        i = CInt(LblnbTrav.Text)   'car la collection commence à 0
        Lecture_Onglet_Durabilite(i, True)
        i = i - 1
        BtnPlusExpo.Visible = True
        If i <= 0 Then
            i = 1
            BtnMoinsExpo.Visible = False
        End If
        LblnbTrav.Text = CStr(i)
        Affichage_Onglet_Durabilite(i)
    End Sub
    Private Sub ChkbEnrobage_CheckedChanged(sender As Object, e As EventArgs) Handles ChkbEnrobage.CheckedChanged
        If ChkbEnrobage.Checked = True Then
            ChkbX0.Checked = False : RbtnXc1.Checked = False : RbtnXc2.Checked = False : RbtnXc3.Checked = False : RbtnXc4.Checked = False
            RbtnXd1.Checked = False : RbtnXd2.Checked = False : RbtnXd3.Checked = False : RbtnXs1.Checked = False : RbtnXs2.Checked = False : RbtnXs3.Checked = False
            RbtnXf1.Checked = False : RbtnXf2.Checked = False : RbtnXf3.Checked = False : RbtnXf4.Checked = False
            RbtnXa1.Checked = False : RbtnXa2.Checked = False : RbtnXa3.Checked = False
            GBExposition.Enabled = False
            TxtenrInf.Enabled = True : TxtenrLat.Enabled = True : TxtEnrSup.Enabled = True : TxtenrInf.Focus()
        Else
            TxtenrInf.Text = String.Empty : TxtenrLat.Text = String.Empty : TxtEnrSup.Text = String.Empty
            TxtenrInf.Enabled = False : TxtenrLat.Enabled = False : TxtEnrSup.Enabled = False
            GBExposition.Enabled = True
        End If
    End Sub
    Private Sub ChkbX0_CheckedChanged(sender As Object, e As EventArgs) Handles ChkbX0.CheckedChanged
        If ChkbX0.Checked = True Then
            RbtnXc1.Checked = False
            RbtnXc2.Checked = False
            RbtnXc3.Checked = False
            RbtnXc4.Checked = False
            RbtnXd1.Checked = False
            RbtnXd2.Checked = False
            RbtnXd3.Checked = False
            RbtnXs1.Checked = False
            RbtnXs2.Checked = False
            RbtnXs3.Checked = False
            RbtnXf1.Checked = False
            RbtnXf2.Checked = False
            RbtnXf3.Checked = False
            RbtnXf4.Checked = False
            RbtnXa1.Checked = False
            RbtnXa2.Checked = False
            RbtnXa3.Checked = False
            GbCarbo.Enabled = False
            GbChimique.Enabled = False
            GbChlorure.Enabled = False
            GbGel.Enabled = False
            GbMer.Enabled = False
        Else
            GbCarbo.Enabled = True
            GbChimique.Enabled = True
            GbChlorure.Enabled = True
            GbGel.Enabled = True
            GbMer.Enabled = True
        End If
    End Sub

    Private Sub BtnCERIB_Click(sender As Object, e As EventArgs) Handles BtnCERIB.Click
        Try
            Dim KEY As Microsoft.Win32.RegistryKey = My.Computer.Registry.ClassesRoot.OpenSubKey("acroPDF.PDF")
            If KEY Is Nothing Then
                MessageBox.Show("Impossible d'accèder à Acrobat Reader!" & Environment.NewLine & "Lecture Classes d'exposition CERIB abandonnée.", Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Exit Sub
            End If
            Dim SousDossier1 As String = My.Application.Info.DirectoryPath 'répertoire dans lequel se trouve le logiciel Plancher BA
            Dim startInfo As New ProcessStartInfo("AcroRd32.exe") '("word.exe")
            startInfo.WindowStyle = ProcessWindowStyle.Normal
            startInfo.Arguments = SousDossier1 & "\Les Classes d'exposition CERIB FIB.pdf"
            Process.Start(startInfo.Arguments)
        Catch ex As Exception
            Dim msg As String
            msg = "Impossible d'afficher le document du CERIB" & Environment.NewLine + "Vérifiez que le document se trouve bien dans le répertoire du logiciel!" & Environment.NewLine &
                "Exception: " + ex.Message & ex.StackTrace
            MessageBox.Show(msg, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub

#End Region

#Region "Gestion Onglet Feu"
    Private Sub BtnFeuTravSuivante_Click(sender As Object, e As EventArgs) Handles BtnFeuTravSuivante.Click
        Dim Verif As Boolean = True
        Dim i As Integer
        i = CInt(lblFeuNumTrav.Text)
        Call Lecture_Onglet_Feu(i, Verif)
        If Verif = False Then Exit Sub
        i = i + 1
        BtnFeuTravPrécédente.Visible = True
        If i > PlanCont.Count Then
            i = PlanCont.Count
            BtnFeuTravSuivante.Visible = False
        End If
        lblFeuNumTrav.Text = i.ToString
        Affichage_Onglet_Feu(i)
    End Sub

    Private Sub BtnFeuTravPrécédente_Click(sender As Object, e As EventArgs) Handles BtnFeuTravPrécédente.Click
        Dim Verif As Boolean = True
        Dim i As Integer
        i = CInt(lblFeuNumTrav.Text)
        Call Lecture_Onglet_Feu(i, Verif)
        If Verif = False Then Exit Sub
        i = i - 1
        BtnFeuTravSuivante.Visible = True
        If i = 0 Then
            i = 1
            BtnFeuTravPrécédente.Visible = False
        End If
        lblFeuNumTrav.Text = i.ToString
        Affichage_Onglet_Feu(i)

    End Sub

    Private Sub ChkbFeuTtesTravees_CheckedChanged(sender As Object, e As EventArgs) Handles ChkbFeuTtesTravees.CheckedChanged
        If ChkbFeuTtesTravees.Checked = True Then
            BtnFeuTravSuivante.Visible = False : BtnFeuTravPrécédente.Visible = False
            lblFeuNumTrav.Text = "1"
            Affichage_Onglet_Feu(1)
        Else
            BtnFeuTravSuivante.Visible = True : BtnFeuTravPrécédente.Visible = True
        End If
    End Sub
#End Region

#Region "Bouton d'Aide"
    Private Sub BtnHlpEnv_Click(sender As Object, e As EventArgs) Handles BtnHlpEnv.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 7
        frm1.Show()
    End Sub
    Private Sub BtnHlpDecalageET_Click_1(sender As Object, e As EventArgs) Handles BtnHlpDecalageET.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 4
        frm1.Show()
    End Sub
    Private Sub BtnHlpRedistribution_Click(sender As Object, e As EventArgs) Handles BtnHlpRedistribution.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 8
        frm1.Show()
    End Sub
    Private Sub BtnHlpEcretage_Click(sender As Object, e As EventArgs)
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 9
        frm1.Show()
    End Sub
    Private Sub BtnHlp15M0_Click(sender As Object, e As EventArgs) Handles BtnHlp15M0.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 10
        frm1.Show()
    End Sub
    Private Sub BtnHlpCoefn_Click(sender As Object, e As EventArgs) Handles BtnHlpCoefnCont.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 13
        frm1.Show()
    End Sub

    Private Sub BtnHlpCoefnFl_Click(sender As Object, e As EventArgs) Handles BtnHlpCoefnFl.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 14
        frm1.Show()
    End Sub
    Private Sub BtnHlpIncendieCarrelage_Click(sender As Object, e As EventArgs) Handles BtnHlpIncendieCarrelage.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 21
        frm1.Show()
    End Sub
    Private Sub BtnHlpIncendie_Click(sender As Object, e As EventArgs) Handles BtnHlpIncendie.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 22
        frm1.Show()
    End Sub

    Private Sub BtnHlpPorteur2sens_Click(sender As Object, e As EventArgs) Handles BtnHlpPorteur2sens.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 24
        frm1.Show()
    End Sub
    Private Sub BtnHlpDegression_Click(sender As Object, e As EventArgs) Handles BtnHlpDegression.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 27
        frm1.Show()
    End Sub
    Private Sub BtnHlpChkbCalculContraintePredalle_Click(sender As Object, e As EventArgs) Handles BtnHlpChkbCalculContraintePredalle.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 30
        frm1.Show()
    End Sub
    Private Sub BtnHlpFleche_Predal_Click(sender As Object, e As EventArgs) Handles BtnHlpFleche_Predal.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 31
        frm1.Show()
    End Sub
#End Region

#Region "Gestion des textbox: pb point virgule, signe -, etc. ..."
#Region "Onglet ELU"
    Private Sub txtDelta_KeyPress(sender As Object, e As KeyPressEventArgs) Handles txtDelta.KeyPress
        Call Gestion_Keypress(e, txtDelta, True, False)
    End Sub

    Private Sub txtNu_fl_KeyPress(sender As Object, e As KeyPressEventArgs) Handles txtNu_fl.KeyPress
        Call Gestion_Keypress(e, txtNu_fl, True, False)
    End Sub

    Private Sub txtNu_eff_KeyPress(sender As Object, e As KeyPressEventArgs) Handles txtNu_eff.KeyPress
        Call Gestion_Keypress(e, txtNu_eff, True, False)
    End Sub
#End Region

#Region "Onglet ELS"
    Private Sub txtnCont_KeyPress(sender As Object, e As KeyPressEventArgs) Handles txtnCont.KeyPress
        Call Gestion_Keypress(e, txtnCont, True, False)
    End Sub

    Private Sub txtRHCont_KeyPress(sender As Object, e As KeyPressEventArgs) Handles txtRHCont.KeyPress
        Call Gestion_Keypress(e, txtRHCont, True, True)
    End Sub

    Private Sub txtT0Cont_KeyPress(sender As Object, e As KeyPressEventArgs) Handles txtT0Cont.KeyPress
        Call Gestion_Keypress(e, txtT0Cont, True, True)
    End Sub
    Private Sub txtnfl_KeyPress(sender As Object, e As KeyPressEventArgs) Handles txtnFl.KeyPress
        Call Gestion_Keypress(e, txtnFl, True, False)
    End Sub

    Private Sub txtRHfl_KeyPress(sender As Object, e As KeyPressEventArgs) Handles txtRHFl.KeyPress
        Call Gestion_Keypress(e, txtRHFl, True, True)
    End Sub

    Private Sub txtT0fl_KeyPress(sender As Object, e As KeyPressEventArgs) Handles txtT0Fl.KeyPress
        Call Gestion_Keypress(e, txtT0Fl, True, True)
    End Sub
    Private Sub txtPrefa_t_KeyPress(sender As Object, e As KeyPressEventArgs) Handles txtPrefa_t.KeyPress
        Call Gestion_Keypress(e, txtPrefa_t, True, True)
    End Sub
#End Region

#Region "Onglet Durabilité"
    Private Sub txtenrInf_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtenrInf.KeyPress
        Call Gestion_Keypress(e, TxtenrInf, True, False)
    End Sub

    Private Sub txtenrLat_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtenrLat.KeyPress
        Call Gestion_Keypress(e, TxtenrLat, True, False)
    End Sub

    Private Sub txtEnrSup_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtEnrSup.KeyPress
        Call Gestion_Keypress(e, TxtEnrSup, True, False)
    End Sub
#End Region
    Private Sub txtFeu_EpCarrelage_KeyPress(sender As Object, e As KeyPressEventArgs) Handles txtFeu_EpCarrelage.KeyPress
        Call Gestion_Keypress(e, txtFeu_EpCarrelage, True, False)
    End Sub

#End Region

End Class