﻿Imports System.Drawing.Drawing2D
Public Class frmGeodalle
    Dim Tr_Xa(10, 10), Tr_Ya(10, 10), Tr_Lx(10, 10), Tr_Ly(10, 10) As Double
    Dim Tr_Cloison(10, 10) As Boolean
    Dim Tr_Chevetre(10, 10) As Integer
    Dim nbTremie(10) As Integer
    Private Sub frmGeodalle_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        If PlanCont.Count >= 1 Then
            BtnMoins.Visible = False : BtnPlus.Visible = False
            Affichage(0)
        Else
            Initialisation()
            TxtNom.Focus()  '  
        End If
    End Sub

    Private Sub Initialisation()
        Nud1.Value = 1
        rbtn1sens.Checked = True
        BtnMoins.Hide()
        'onglet Dimensions
        TxtNom.Text = String.Empty
        TxtLx.Text = String.Empty ' Dess_dalle.Lx = CDbl(TxtLx.Text)
        TxtLy.Text = String.Empty ' Dess_dalle.Ly = CDbl(TxtLy.Text)
        TxtEp.Text = String.Empty
        ChkbIsostatique.Checked = False
        ChkbPlancherPrefa.Checked = True : ChkbPlancherPrefa.Checked = False 'juste pour activer l'onglet Prédalle
        'onglet Appuis
        ChkbAppui_Même_Largeur.Checked = False : ChkbAppui_Même_Largeur.Checked = False
        TxtL_AppH.Text = String.Empty
        TxtL_AppB.Text = String.Empty
        TxtL_AppD.Text = String.Empty
        TxtL_AppG.Text = String.Empty
        GbAppuiBas.Visible = True : GbAppuiDroit.Visible = True : GbAppuiHaut.Visible = True
        rbtnG_Ma.Checked = False : rbtnG_Beton.Checked = False
        rbtnD_Ma.Checked = False : rbtnD_Beton.Checked = False
        rbtnH_Ma.Checked = False : rbtnH_Beton.Checked = False
        rbtnB_Ma.Checked = False : rbtnB_Beton.Checked = False
        ChkbMonolithAppui.Checked = False
        'Onglet Prédalle
        TxtEpPredal.Text = String.Empty
        Txt_Prefa_Esp.Text = String.Empty
        Txt_Prefa_L.Text = String.Empty
        RbtnEtaiSans.Checked = False : RbtnEtaiAvec.Checked = False
        txt_Prefa_Letai.Text = String.Empty : txt_Prefa_Letai.Enabled = False
        Rbtn_LisseRive_Sans.Checked = False
        Rbtn_LisseRive_Avec.Checked = False
        TxtSansLisse_RepGauche.Text = String.Empty : TxtSansLisse_RepGauche.Enabled = False
        TxtSansLisse_RepDroit.Text = String.Empty : TxtSansLisse_RepDroit.Enabled = False
        TxtAvecLisse_RepGauche.Text = String.Empty : TxtAvecLisse_RepGauche.Enabled = False
        TxtAvecLisse_RepDroit.Text = String.Empty : TxtAvecLisse_RepDroit.Enabled = False
        RbtnRepos_TabA3.Checked = False : RbtnRepos_Valeur.Checked = False
        RbtnEtatLisse.Checked = False : RbtnEtatRugueux.Checked = False
        ChkbAffichePredal.Checked = True

        'Onglet Trémie
        For Each ctrl As Control In TC1.TabPages.Item(3).Controls
            ctrl.Visible = False
        Next
        BtnPlusTrémie.Visible = False
        LblTremieNum1.Visible = True
        LblTremieNum1.Text = "Aucune trémie"
        btnTremieSuppression.Visible = False
        BtnTremieAjout.Visible = True
    End Sub
    Private Sub Affichage(ByVal i As Integer)
        Nud1.Value = PlanCont.Count
        If i < 0 Or i > PlanCont.Count - 1 Then Exit Sub
        With PlanCont.Item(i)
            'Onglet dimensions et général
            If .modele_calcul = 2 Then Rbtn2sens.Checked = True Else rbtn1sens.Checked = True
            TxtNom.Text = .Nom
            TxtLx.Text = .Lx.ToString("#0.00") ' Dess_dalle.Lx = CDbl(TxtLx.Text)
            TxtLy.Text = .Ly.ToString("#0.00") ' Dess_dalle.Ly = CDbl(TxtLy.Text)
            TxtEp.Text = (.H * 100).ToString("#0.0")
            If .Isostatique = True Then ChkbIsostatique.Checked = True Else ChkbIsostatique.Checked = False
            If .Prefa = True Then ChkbPlancherPrefa.Checked = True Else ChkbPlancherPrefa.Checked = False
            'Onglet appuis
            If .LappB = .LappH And .LappG = .LappD And .LappG = .LappH Then
                ChkbAppui_Même_Largeur.Checked = True
            Else
                ChkbAppui_Même_Largeur.Checked = False
            End If
            TxtL_AppH.Text = (.LappH * 100).ToString("#0.0")
            TxtL_AppB.Text = (.LappB * 100).ToString("#0.0")
            TxtL_AppD.Text = (.LappD * 100).ToString("#0.0")
            TxtL_AppG.Text = (.LappG * 100).ToString("#0.0")
            If .AppuiB = .AppuiH And .AppuiG = .AppuiD And .AppuiG = .AppuiH Then
                ChkbAppui_Même_Type.Checked = True
            Else
                ChkbAppui_Même_Type.Checked = False
            End If
            Select Case .AppuiG
                Case 1 'Béton
                    rbtnG_Beton.Checked = True
                Case 2 'Maçonnerie
                    rbtnG_Ma.Checked = True
                Case 3 'autre

            End Select
            Select Case .AppuiD
                Case 1 'Béton
                    rbtnD_Beton.Checked = True
                Case 2 'Maçonnerie
                    rbtnD_Ma.Checked = True
                Case 3 'autre

            End Select
            Select Case .AppuiH
                Case 1 'Béton
                    rbtnH_Beton.Checked = True
                Case 2 'Maçonnerie
                    rbtnH_Ma.Checked = True
                Case 3 'autre

            End Select
            Select Case .AppuiB
                Case 1 'Béton
                    rbtnB_Beton.Checked = True
                Case 2 'Maçonnerie
                    rbtnB_Ma.Checked = True
                Case 3 'autre

            End Select
            If .App_Monolith = True Then ChkbMonolithAppui.Checked = True Else ChkbMonolithAppui.Checked = False
            'Onglet Prédalle
            If .Prefa = True Then
                TxtEpPredal.Text = (.Prefa_h * 100).ToString("#0")
                Txt_Prefa_L.Text = .Prefa_L.ToString("#0.000")
                Txt_Prefa_Esp.Text = (.Prefa_esp * 100).ToString("#0.0")
                If Aff.Affich_Predal = True Then ChkbAffichePredal.Checked = True Else ChkbAffichePredal.Checked = False
                If .Prefa_etai = True Then
                    RbtnEtaiAvec.Checked = True
                    txt_Prefa_Letai.Text = .Prefa_etai_L.ToString("#0.00")
                Else
                    RbtnEtaiSans.Checked = True
                End If
                Select Case .Prefa_ReposLisse
                    Case 1 'Avec lisse de rive
                        Rbtn_LisseRive_Avec.Checked = True
                        TxtAvecLisse_RepGauche.Text = (.Prefa_ReposG * 100).ToString("#0.0")
                        TxtAvecLisse_RepDroit.Text = (.Prefa_ReposD * 100).ToString("#0.0")
                    Case 2 'Sans lisse de rive + repos suivant Tab A3
                        Rbtn_LisseRive_Sans.Checked = True
                        RbtnRepos_TabA3.Checked = True
                    Case 3 'Sans lisse de rive + repos suivant valeurs forcées
                        Rbtn_LisseRive_Sans.Checked = True
                        RbtnRepos_Valeur.Checked = True
                        TxtSansLisse_RepGauche.Text = (.Prefa_ReposG * 100).ToString("#0.0")
                        TxtSansLisse_RepDroit.Text = (.Prefa_ReposD * 100).ToString("#0.0")
                End Select
                If .Prefa_Reprise = 1 Then RbtnEtatLisse.Checked = True Else RbtnEtatRugueux.Checked = True
                If Aff.Affich_Predal = True Then ChkbAffichePredal.Checked = True
            Else
                TxtEpPredal.Text = "0"
                TxtSansLisse_RepGauche.Text = "0.00"
            End If
            'Onglet trémie
            If ._Tremie.Count > 0 Then
                'affichage de la trémie n1 = index 0
                For Each ctrl As Control In TC1.TabPages.Item(3).Controls
                    ctrl.Visible = True
                Next
                BtnMoinsTremie.Visible = False
                If ._Tremie.Count = 1 Then BtnPlusTrémie.Visible = False
                LblTremieNum1.Text = "Trémie n°" : LblTremieNum2.Text = "1"
                TxtXA.Text = ._Tremie.Item(0)._xA.ToString("#0.00")
                TxtYA.Text = ._Tremie.Item(0)._yA.ToString("#0.00")
                TxtTremieLx.Text = ._Tremie.Item(0)._Lx.ToString("#0.00")
                TxtTremieLy.Text = ._Tremie.Item(0)._Ly.ToString("#0.00")
                If ._Tremie.Item(0)._Cloison = True Then ChkbCloisonBordureTremie.Checked = True Else ChkbCloisonBordureTremie.Checked = False
                If ._Tremie.Item(0)._type_chevetre = 1 Then ChkbChevetre.Checked = True Else ChkbChevetre.Checked = False
            Else
                For Each ctrl As Control In TC1.TabPages.Item(3).Controls
                    ctrl.Visible = False
                Next
                BtnTremieAjout.Visible = True
                LblTremieNum1.Visible = True
                LblTremieNum1.Text = "Aucune trémie"
            End If
        End With

    End Sub
    Private Sub BtnMoins_Click(sender As Object, e As EventArgs) Handles BtnMoins.Click
        Dim verif As Boolean = True
        Dim i As Integer
        'lecture des données renseignées
        Call Lecture_Données(verif)
        If verif = False Then Exit Sub
        lblDalle.Text = (CInt(lblDalle.Text) - 1).ToString
        i = CInt(lblDalle.Text)
        If CInt(lblDalle.Text) = 1 Then
            BtnMoins.Visible = False
            If Nud1.Value > 1 Then BtnPlus.Visible = True
        End If
        Call Affichage(i - 1)
    End Sub
    Private Sub BtnPlus_Click(sender As Object, e As EventArgs) Handles BtnPlus.Click
        Dim verif As Boolean = True
        Dim i As Integer
        i = CInt(lblDalle.Text)
        'suppression de l'affichage du btnPlus
        If i + 1 = CInt(Nud1.Value) Then BtnPlus.Visible = False
        If i <= CInt(Nud1.Value) Then
            'lecture des données renseignées
            Call Lecture_Données(verif)
            If verif = False Then Exit Sub
            If CInt(Nud1.Value) > 1 Then BtnMoins.Visible = True
        End If
        If i < CInt(Nud1.Value) Then
            lblDalle.Text = (i + 1).ToString
            If i + 1 <= PlanCont.Count Then
                Call Affichage(i)
            Else
                'Nouvelle travée renseignée
                'nettoyage des données précédement entrées
                'onglet dimensions
                TxtNom.Text = ""
                TxtLx.Text = ""
                If i >= 1 Then
                    TxtLy.Text = PlanCont(i - 1).Ly.ToString("#0.00") ' on conserve la valeur de la travée précédente
                    TxtEp.Text = (PlanCont(i - 1).H * 100).ToString("#0.0") ' on conserve la valeur de la travée précédente
                Else
                    TxtLy.Text = ""
                    TxtEp.Text = ""
                End If
                If PlanCont(i - 1).Isostatique = True Then ' on conserve la valeur de la travée précédente
                    ChkbIsostatique.Checked = True
                Else
                    ChkbIsostatique.Checked = False
                End If
                'onglet appuis
                ' on conserve les valeurs de la travée précédente
                ChkbAppui_Même_Largeur.Checked = False
                TxtL_AppH.Text = (PlanCont(i - 1).LappH * 100).ToString("#0.0")
                TxtL_AppB.Text = (PlanCont(i - 1).LappB * 100).ToString("#0.0")
                TxtL_AppD.Text = ""
                TxtL_AppG.Text = (PlanCont(i - 1).LappD * 100).ToString("#0.0")
                ChkbAppui_Même_Type.Checked = False
                Select Case PlanCont.Item(i - 1).AppuiD
                    Case 1
                        rbtnG_Beton.Checked = True
                    Case 2
                        rbtnG_Ma.Checked = True

                End Select
                Select Case PlanCont.Item(i - 1).AppuiH
                    Case 1
                        rbtnH_Beton.Checked = True
                    Case 2
                        rbtnH_Ma.Checked = True

                End Select
                Select Case PlanCont.Item(i - 1).AppuiB
                    Case 1
                        rbtnB_Beton.Checked = True
                    Case 2
                        rbtnB_Ma.Checked = True

                End Select
                rbtnD_Beton.Checked = False : rbtnD_Ma.Checked = True
                'Onglet prédalle
                If PlanCont(i - 1).Prefa = True Then ' on conserve la valeur de la travée précédente
                    TxtEpPredal.Text = (PlanCont(i - 1).Prefa_h * 100).ToString("#0")
                    Txt_Prefa_L.Text = (PlanCont(i - 1).Prefa_L).ToString("#0.000")
                    Txt_Prefa_Esp.Text = (PlanCont(i - 1).Prefa_esp * 100).ToString("#0.00")
                    If PlanCont(i - 1).Prefa_etai = True Then RbtnEtaiAvec.Checked = True Else RbtnEtaiSans.Checked = True
                    Select Case PlanCont(i - 1).Prefa_ReposLisse
                        Case 1
                            Rbtn_LisseRive_Avec.Checked = True
                            TxtAvecLisse_RepGauche.Text = (PlanCont(i - 1).Prefa_ReposG * 100).ToString("#0.0")
                            TxtAvecLisse_RepDroit.Text = (PlanCont(i - 1).Prefa_ReposD * 100).ToString("#0.0")
                        Case 2
                            Rbtn_LisseRive_Sans.Checked = True
                            RbtnRepos_TabA3.Checked = True
                        Case 3
                            Rbtn_LisseRive_Sans.Checked = True
                            RbtnRepos_Valeur.Checked = True
                            TxtSansLisse_RepGauche.Text = (PlanCont(i - 1).Prefa_ReposG * 100).ToString("#0.0")
                            TxtSansLisse_RepDroit.Text = (PlanCont(i - 1).Prefa_ReposD * 100).ToString("#0.0")
                    End Select
                    If PlanCont(i - 1).Prefa_Reprise = 1 Then RbtnEtatLisse.Checked = True Else RbtnEtatRugueux.Checked = True
                Else
                    TxtEpPredal.Text = String.Empty
                    Txt_Prefa_Esp.Text = String.Empty
                    Txt_Prefa_L.Text = String.Empty
                    RbtnEtaiSans.Checked = False : RbtnEtaiAvec.Checked = False
                    txt_Prefa_Letai.Text = String.Empty : txt_Prefa_Letai.Enabled = False
                    Rbtn_LisseRive_Sans.Checked = False
                    Rbtn_LisseRive_Avec.Checked = False
                    TxtSansLisse_RepGauche.Text = String.Empty : TxtSansLisse_RepGauche.Enabled = False
                    TxtSansLisse_RepDroit.Text = String.Empty : TxtSansLisse_RepDroit.Enabled = False
                    TxtAvecLisse_RepGauche.Text = String.Empty : TxtAvecLisse_RepGauche.Enabled = False
                    TxtAvecLisse_RepDroit.Text = String.Empty : TxtAvecLisse_RepDroit.Enabled = False
                    RbtnRepos_TabA3.Checked = False : RbtnRepos_Valeur.Checked = False
                    RbtnEtatLisse.Checked = False : RbtnEtatRugueux.Checked = False
                    ChkbAffichePredal.Checked = True
                End If
                'Onglet trémie
                For Each ctrl As Control In TC1.TabPages.Item(3).Controls
                    ctrl.Visible = False
                Next
                LblTremieNum1.Visible = True
                LblTremieNum1.Text = "Aucune trémie"
                BtnTremieAjout.Visible = True
            End If
        End If
    End Sub
    Private Sub Lecture_Données_Nouveau_Plancher(ByRef Dalle1 As Plancher, ByRef Verif As Boolean)
        Dim msg As String = String.Empty
        Dim i1, j As Integer
        i1 = CInt(lblDalle.Text)
        If rbtn1sens.Checked Then Dalle1.modele_calcul = 1 Else Dalle1.modele_calcul = 2

        '___________________________________________________________________________________________________________________________________________________
        'Onglet Dimensions
        If TxtNom.Text <> String.Empty Then
            Dalle1.Nom = TxtNom.Text
            EP1.SetError(TxtNom, "") ' Clear the error.
        Else
            EP1.SetError(TxtNom, "le champ n'a pas été renseigné!!")
            msg = msg & Environment.NewLine & "Nom de la dalle n°" & i1.ToString & " non renseigné." : Verif = False
        End If
        If ChkbIsostatique.Checked = True Then Dalle1.Isostatique = True Else Dalle1.Isostatique = False
        If ChkbPlancherPrefa.Checked = True Then Dalle1.Prefa = True Else Dalle1.Prefa = False
        If gestionderreur(TxtLx) = True Then
            Dalle1.Lx = CDbl(TxtLx.Text)
        Else
            msg = msg & Environment.NewLine & "Dimension suivant x dalle n°" & i1.ToString & " non renseignée."
            Verif = False
        End If
        If gestionderreur(TxtLy) = True Then
            Dalle1.Ly = CDbl(TxtLy.Text)
        Else
            msg = msg & Environment.NewLine & "Dimension suivant y dalle n°" & i1.ToString & " non renseignée."
            Verif = False
        End If
        If gestionderreur(TxtEp) = True Then
            Dalle1.H = CDbl(TxtEp.Text) / 100
        Else
            msg = msg & Environment.NewLine & "Hauteur de la dalle n°" & i1.ToString & " non renseignée."
            Verif = False
        End If

        '__________________________________________________________________________________________________________________________________________
        'Onglet appuis
        If gestionderreur(TxtL_AppG) = True Then
            Dalle1.LappG = CDbl(TxtL_AppG.Text) / 100
        Else
            msg = msg & Environment.NewLine & "Largeur appui gauche dalle n°" & i1.ToString & " non renseignée."
            Verif = False
        End If
        If ChkbAppui_Même_Largeur.Checked = True Then
            Dalle1.LappB = Dalle1.LappG : Dalle1.LappH = Dalle1.LappG : Dalle1.LappD = Dalle1.LappG
        Else
            'Lecture de toutes les valeurs d'appuis
            If gestionderreur(TxtL_AppH) = True Then
                Dalle1.LappH = CDbl(TxtL_AppH.Text) / 100
            Else
                msg = msg & Environment.NewLine & "Largeur appui haut dalle n°" & i1.ToString & " non renseignée."
                Verif = False
            End If
            If gestionderreur(TxtL_AppB) = True Then
                Dalle1.LappB = CDbl(TxtL_AppB.Text) / 100
            Else
                msg = msg & Environment.NewLine & "Largeur appui bas dalle n°" & i1.ToString & " non renseignée."
                Verif = False
            End If
            If gestionderreur(TxtL_AppD) = True Then
                Dalle1.LappD = CDbl(TxtL_AppD.Text) / 100
            Else
                msg = msg & Environment.NewLine & "Largeur appui droit dalle n°" & i1.ToString & " non renseignée."
                Verif = False
            End If
        End If
        If rbtnG_Beton.Checked = True Then
            Dalle1.AppuiG = 1 'Béton
        ElseIf rbtnG_Ma.Checked = True Then
            Dalle1.AppuiG = 2 'Maçonnerie
        Else
            msg = msg & Environment.NewLine & "type d'appui gauche dalle n°" & i1.ToString & " non renseignée."
            Verif = False
        End If
        If ChkbAppui_Même_Type.Checked = True Then
            Dalle1.AppuiB = Dalle1.AppuiG : Dalle1.AppuiH = Dalle1.AppuiG : Dalle1.AppuiD = Dalle1.AppuiG
        Else
            If rbtnD_Beton.Checked = True Then
                Dalle1.AppuiD = 1 'Béton
            ElseIf rbtnD_Ma.Checked = True Then
                Dalle1.AppuiD = 2 'Maçonnerie
            Else
                msg = msg & Environment.NewLine & "type d'appui droit dalle n°" & i1.ToString & " non renseignée."
                Verif = False
            End If
            If rbtnH_Beton.Checked = True Then
                Dalle1.AppuiH = 1 'Béton
            ElseIf rbtnH_Ma.Checked = True Then
                Dalle1.AppuiH = 2 'Maçonnerie
            Else
                msg = msg & Environment.NewLine & "type d'appui haut dalle n°" & i1.ToString & " non renseignée."
                Verif = False
            End If
            If rbtnB_Beton.Checked = True Then
                Dalle1.AppuiB = 1 'Béton
            ElseIf rbtnB_Ma.Checked = True Then
                Dalle1.AppuiB = 2 'Maçonnerie

            Else
                msg = msg & Environment.NewLine & "type d'appui bas dalle n°" & i1.ToString & " non renseignée."
                Verif = False
            End If
        End If
        If ChkbMonolithAppui.Checked = True Then Dalle1.App_Monolith = True Else Dalle1.App_Monolith = False
        '____________________________________________________________________________________________________________________
        'Onglet Prédalle
        If Dalle1.Prefa = True Then
            If ChkbAffichePredal.Checked = True Then Aff.Affich_Predal = True Else Aff.Affich_Predal = False
            If TxtEpPredal.Text = String.Empty Then TxtEpPredal.Text = "0" : Dalle1.Prefa = False
            If gestionderreur(TxtEpPredal) = True And CDbl(TxtEpPredal.Text) >= 5 Then
                Dalle1.Prefa_h = CDbl(TxtEpPredal.Text) / 100
                Dalle1.Prefa = True
                'largeur préférentielle
                If gestionderreur(Txt_Prefa_L) = True Then
                    Dalle1.Prefa_L = CDbl(Txt_Prefa_L.Text)
                Else
                    msg = msg & Environment.NewLine & "Largeur préférentielle de la prédalle travée n°" & i1.ToString & " non renseignée."
                    Verif = False
                End If
                'espace entre prédalles
                If gestionderreur(Txt_Prefa_Esp) = True Then
                    Dalle1.Prefa_esp = CDbl(Txt_Prefa_Esp.Text) / 100
                Else
                    msg = msg & Environment.NewLine & "Espacement entre prédalles travée n°" & i1.ToString & " non renseigné."
                    Verif = False
                End If
                'étaiement prédalles
                If RbtnEtaiAvec.Checked = True Then Dalle1.Prefa_etai = True Else Dalle1.Prefa_etai = False
                If Dalle1.Prefa_etai = True Then
                    If gestionderreur(txt_Prefa_Letai) = True Then
                        Dalle1.Prefa_etai_L = CDbl(txt_Prefa_Letai.Text)
                    Else
                        msg = msg & Environment.NewLine & "Distance entre étaies travée n°" & i1.ToString & " non renseigné."
                        Verif = False
                    End If
                Else
                    Dalle1.Prefa_etai_L = 0
                End If
                'repos sur appuis porteurs
                If Rbtn_LisseRive_Avec.Checked = True Then
                    Dalle1.Prefa_ReposLisse = 1
                    If gestionderreur(TxtAvecLisse_RepGauche) = True Then
                        Dalle1.Prefa_ReposG = CDbl(TxtAvecLisse_RepGauche.Text) / 100
                    Else
                        msg = msg & Environment.NewLine & "Repos prédalle sur appui gauche travée n°" & i1.ToString & " non renseigné."
                        Verif = False
                    End If
                    If gestionderreur(TxtAvecLisse_RepDroit) = True Then
                        Dalle1.Prefa_ReposD = CDbl(TxtAvecLisse_RepDroit.Text) / 100
                    Else
                        msg = msg & Environment.NewLine & "Repos prédalle sur appui droit travée n°" & i1.ToString & " non renseigné."
                        Verif = False
                    End If
                Else
                    If RbtnRepos_TabA3.Checked = True Then
                        Dalle1.Prefa_ReposLisse = 2 'les valeurs de repos seront calculés dans le module  Private Sub Verification_Repos_Appui_Predalle(ByRef rtf As To_Rtf.RtfAnsiTextWriter)
                    Else
                        Dalle1.Prefa_ReposLisse = 3
                        If gestionderreur(TxtSansLisse_RepGauche) = True Then
                            Dalle1.Prefa_ReposG = CDbl(TxtSansLisse_RepGauche.Text) / 100
                        Else
                            msg = msg & Environment.NewLine & "Repos prédalle sur appui gauche travée n°" & i1.ToString & " non renseigné."
                            Verif = False
                        End If
                        If gestionderreur(TxtSansLisse_RepDroit) = True Then
                            Dalle1.Prefa_ReposD = CDbl(TxtSansLisse_RepDroit.Text) / 100
                        Else
                            msg = msg & Environment.NewLine & "Repos prédalle sur appui droit travée n°" & i1.ToString & " non renseigné."
                            Verif = False
                        End If
                    End If
                End If
                'Etat de surface de la prédalle
                If RbtnEtatLisse.Checked = True Then Dalle1.Prefa_Reprise = 1 Else Dalle1.Prefa_Reprise = 2 'RbtnEtatRugueux.Checked = True

                If ChkbAffichePredal.Checked = True Then Aff.Affich_Predal = True
            Else
                Dalle1.Prefa = False
                msg = msg & Environment.NewLine & "Hauteur de la prédalle travée n°" & i1.ToString & " non renseignée et/ou hauteur insuffisante ( 5 cm minimum suivant CPT)."
                Verif = False
            End If
        End If
        '__________________________________________________________________________________________________________________________________________________________________
        'Onglet Trémie
        If LblTremieNum2.Visible = True And CInt(LblTremieNum2.Text) >= 1 Then
            Dim trem As New Tremie
            For j = 1 To 10
                If Tr_Lx(i1, j) > 0.1 And Tr_Ly(i1, j) > 0.1 Then
                    trem._xA = Tr_Xa(i1, j) : trem._yA = Tr_Ya(i1, j) : trem._Lx = Tr_Lx(i1, j) : trem._Ly = Tr_Ly(i1, j)
                    If Tr_Cloison(i1, j) = True Then trem._Cloison = True Else trem._Cloison = False
                    If Tr_Chevetre(i1, j) = 1 Then trem._type_chevetre = 1 Else trem._type_chevetre = 2
                    Dalle1._Tremie.Add(trem)
                Else
                    Exit For
                End If
            Next
            trem = Nothing
            Call Lecture_Onglet_Tremie_Direct(Dalle1, i1, msg, Verif)
        Else

        End If

        If Verif = False Then MessageBox.Show(msg, "Géométrie", MessageBoxButtons.OK, MessageBoxIcon.Error)

    End Sub
    Private Sub Lecture_Données_Ancien_Plancher(ByVal i As Integer, ByRef Verif As Boolean)
        Dim msg As String = String.Empty
        Dim i1, j As Integer
        i1 = CInt(lblDalle.Text)
        With PlanCont.Item(i)
            Select Case .modele_calcul
                Case 1
                    If rbtn1sens.Checked = False Then .modele_calcul = 2
                Case 2
                    If Rbtn2sens.Checked = False Then .modele_calcul = 1
            End Select
            '___________________________________________________________________________________________________________________________________________________
            'Onglet Dimensions
            .Prefa = False
            If TxtNom.Text <> String.Empty Then
                .Nom = TxtNom.Text
                EP1.SetError(TxtNom, "") ' Clear the error.
            Else
                EP1.SetError(TxtNom, "le champ n'a pas été renseigné!!")
                msg = msg & Environment.NewLine & "Nom de la dalle n°" & i1.ToString & " non renseigné." : Verif = False
            End If
            If ChkbIsostatique.Checked = True Then .Isostatique = True Else .Isostatique = False
            If ChkbPlancherPrefa.Checked = True Then .Prefa = True Else .Prefa = False
            If gestionderreur(TxtLx) = True Then
                .Lx = CDbl(TxtLx.Text)
            Else
                msg = msg & Environment.NewLine & "Dimension suivant x dalle n°" & i1.ToString & " non renseignée."
                Verif = False
            End If
            If gestionderreur(TxtLy) = True Then
                .Ly = CDbl(TxtLy.Text)
            Else
                msg = msg & Environment.NewLine & "Dimension suivant y dalle n°" & i1.ToString & " non renseignée."
                Verif = False
            End If
            If gestionderreur(TxtEp) = True Then
                .H = CDbl(TxtEp.Text) / 100
            Else
                msg = msg & Environment.NewLine & "Hauteur de la dalle n°" & i1.ToString & " non renseignée."
                Verif = False
            End If

            '__________________________________________________________________________________________________________________________________________
            'Onglet appuis
            If gestionderreur(TxtL_AppG) = True Then
                .LappG = CDbl(TxtL_AppG.Text) / 100
            Else
                msg = msg & Environment.NewLine & "Largeur appui gauche dalle n°" & i1.ToString & " non renseignée."
                Verif = False
            End If
            If ChkbAppui_Même_Largeur.Checked = True Then
                .LappB = .LappG : .LappH = .LappG : .LappD = .LappG
            Else
                'Lecture de toutes les valeurs d'appuis
                If gestionderreur(TxtL_AppH) = True Then
                    .LappH = CDbl(TxtL_AppH.Text) / 100
                Else
                    msg = msg & Environment.NewLine & "Largeur appui haut dalle n°" & i1.ToString & " non renseignée."
                    Verif = False
                End If
                If gestionderreur(TxtL_AppB) = True Then
                    .LappB = CDbl(TxtL_AppB.Text) / 100
                Else
                    msg = msg & Environment.NewLine & "Largeur appui bas dalle n°" & i1.ToString & " non renseignée."
                    Verif = False
                End If
                If gestionderreur(TxtL_AppD) = True Then
                    .LappD = CDbl(TxtL_AppD.Text) / 100
                Else
                    msg = msg & Environment.NewLine & "Largeur appui droit dalle n°" & i1.ToString & " non renseignée."
                    Verif = False
                End If
            End If
            If rbtnG_Beton.Checked = True Then
                .AppuiG = 1 'Béton
            ElseIf rbtnG_Ma.Checked = True Then
                .AppuiG = 2 'Maçonnerie
            Else
                msg = msg & Environment.NewLine & "type d'appui gauche dalle n°" & i1.ToString & " non renseignée."
                Verif = False
            End If
            If ChkbAppui_Même_Type.Checked = True Then
                .AppuiB = .AppuiG : .AppuiH = .AppuiG : .AppuiD = .AppuiG
            Else
                If rbtnD_Beton.Checked = True Then
                    .AppuiD = 1 'Béton
                ElseIf rbtnD_Ma.Checked = True Then
                    .AppuiD = 2 'Maçonnerie
                Else
                    msg = msg & Environment.NewLine & "type d'appui droit dalle n°" & i1.ToString & " non renseignée."
                    Verif = False
                End If
                If rbtnH_Beton.Checked = True Then
                    .AppuiH = 1 'Béton
                ElseIf rbtnH_Ma.Checked = True Then
                    .AppuiH = 2 'Maçonnerie
                Else
                    msg = msg & Environment.NewLine & "type d'appui haut dalle n°" & i1.ToString & " non renseignée."
                    Verif = False
                End If
                If rbtnB_Beton.Checked = True Then
                    .AppuiB = 1 'Béton
                ElseIf rbtnB_Ma.Checked = True Then
                    .AppuiB = 2 'Maçonnerie
                Else
                    msg = msg & Environment.NewLine & "type d'appui bas dalle n°" & i1.ToString & " non renseignée."
                    Verif = False
                End If
            End If
            If ChkbMonolithAppui.Checked = True Then .App_Monolith = True Else .App_Monolith = False
            '____________________________________________________________________________________________________________________
            'Onglet Prédalle
            If .Prefa = True Then
                If ChkbAffichePredal.Checked = True Then Aff.Affich_Predal = True Else Aff.Affich_Predal = False
                If TxtEpPredal.Text = String.Empty Then TxtEpPredal.Text = "0" : .Prefa = False
                If gestionderreur(TxtEpPredal) = True And CDbl(TxtEpPredal.Text) >= 5 Then
                    .Prefa_h = CDbl(TxtEpPredal.Text) / 100
                    .Prefa = True
                    'largeur préférentielle
                    If gestionderreur(Txt_Prefa_L) = True Then
                        .Prefa_L = CDbl(Txt_Prefa_L.Text)
                    Else
                        msg = msg & Environment.NewLine & "Largeur préférentielle de la prédalle travée n°" & i1.ToString & " non renseignée."
                        Verif = False
                    End If
                    'espace entre prédalles
                    If gestionderreur(Txt_Prefa_Esp) = True Then
                        .Prefa_esp = CDbl(Txt_Prefa_Esp.Text) / 100
                    Else
                        msg = msg & Environment.NewLine & "Espacement entre prédalles travée n°" & i1.ToString & " non renseigné."
                        Verif = False
                    End If
                    'étaiement prédalles
                    If RbtnEtaiAvec.Checked = True Then .Prefa_etai = True Else .Prefa_etai = False
                    If .Prefa_etai = True Then
                        If gestionderreur(txt_Prefa_Letai) = True Then
                            .Prefa_etai_L = CDbl(txt_Prefa_Letai.Text)
                        Else
                            msg = msg & Environment.NewLine & "Distance entre étaies travée n°" & i1.ToString & " non renseigné."
                            Verif = False
                        End If
                    Else
                        .Prefa_etai_L = 0
                    End If
                    'repos sur appuis porteurs
                    If Rbtn_LisseRive_Avec.Checked = True Then
                        .Prefa_ReposLisse = 1
                        If gestionderreur(TxtAvecLisse_RepGauche) = True Then
                            .Prefa_ReposG = CDbl(TxtAvecLisse_RepGauche.Text) / 100
                        Else
                            msg = msg & Environment.NewLine & "Repos prédalle sur appui gauche travée n°" & i1.ToString & " non renseigné."
                            Verif = False
                        End If
                        If gestionderreur(TxtAvecLisse_RepDroit) = True Then
                            .Prefa_ReposD = CDbl(TxtAvecLisse_RepDroit.Text) / 100
                        Else
                            msg = msg & Environment.NewLine & "Repos prédalle sur appui droit travée n°" & i1.ToString & " non renseigné."
                            Verif = False
                        End If
                    Else
                        If RbtnRepos_TabA3.Checked = True Then
                            .Prefa_ReposLisse = 2 'les valeurs de repos seront calculés dans le module ....
                        Else
                            .Prefa_ReposLisse = 3
                            If gestionderreur(TxtSansLisse_RepGauche) = True Then
                                .Prefa_ReposG = CDbl(TxtSansLisse_RepGauche.Text) / 100
                            Else
                                msg = msg & Environment.NewLine & "Repos prédalle sur appui gauche travée n°" & i1.ToString & " non renseigné."
                                Verif = False
                            End If
                            If gestionderreur(TxtSansLisse_RepDroit) = True Then
                                .Prefa_ReposD = CDbl(TxtSansLisse_RepDroit.Text) / 100
                            Else
                                msg = msg & Environment.NewLine & "Repos prédalle sur appui droit travée n°" & i1.ToString & " non renseigné."
                                Verif = False
                            End If
                        End If
                    End If
                    'Etat de surface de la prédalle
                    If RbtnEtatLisse.Checked = True Then .Prefa_Reprise = 1 Else .Prefa_Reprise = 2 'RbtnEtatRugueux.Checked = True

                    If ChkbAffichePredal.Checked = True Then Aff.Affich_Predal = True
                Else
                    .Prefa = False
                    msg = msg & Environment.NewLine & "Hauteur de la prédalle travée n°" & i1.ToString & " non renseignée et/ou hauteur insuffisante ( 5 cm minimum suivant CPT)."
                    Verif = False
                End If
            End If


            '__________________________________________________________________________________________________________________________________________________________________
            'Onglet Trémie
            If LblTremieNum2.Visible = True And CInt(LblTremieNum2.Text) >= 1 Then
                'je lis et j'affecte ce qui a été renseigné directement
                Call Lecture_Onglet_Tremie_Direct(PlanCont.Item(i), i1, msg, Verif)
            End If
            Dim trem As New Tremie
            For j = 1 To 10
                If Tr_Lx(i1, j) > 0.05 Then
                    trem._xA = Tr_Xa(i1, j) : trem._yA = Tr_Ya(i1, j) : trem._Lx = Tr_Lx(i1, j) : trem._Ly = Tr_Ly(i1, j)
                    If Tr_Cloison(i1, j) = True Then trem._Cloison = True Else trem._Cloison = False
                    If Tr_Chevetre(i1, j) = 1 Then trem._type_chevetre = 1 Else trem._type_chevetre = 2
                    ._Tremie.Add(trem)
                Else
                    Exit For
                End If
            Next
            trem = Nothing

        End With
        'Verification avant renvoi
        If Verif = False Then
            MessageBox.Show(msg, "Géométrie", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End If
    End Sub
    Private Sub Lecture_Données(ByRef Verif As Boolean)
        Dim Dalle1 As New Plancher
        Dim msg As String = String.Empty
        Dim i1 As Integer
        i1 = CInt(lblDalle.Text)
        'Ajout à la collection PlanCont
        If i1 > PlanCont.Count Then
            'ajout de la dalle
            Lecture_Données_Nouveau_Plancher(Dalle1, Verif) 'PlanCont.Add(Dalle1)
            If Verif = False Then Exit Sub
            'ajout de la dalle
            PlanCont.Add(Dalle1)
            Dalle1 = Nothing
        Else
            'remplacement des données géométrique sur la travée existante
            Lecture_Données_Ancien_Plancher(i1 - 1, Verif)
        End If
        Pb.Invalidate()
    End Sub
    Private Sub Lecture_Onglet_Tremie_Direct(ByVal dalle As Plancher, ByVal i1 As Integer, ByRef msg As String, ByRef Verif As Boolean)
        Dim i, j As Integer
        Dim Trem As New Tremie
        'Lecture des données affichées
        If gestionderreur(TxtXA) = True Then
            Trem._xA = CDbl(TxtXA.Text)
        Else
            msg = msg & Environment.NewLine & "Cote x du point A pour la trémie n°" & j.ToString & " de la dalle n°" & i1.ToString & " non renseignée."
            Verif = False
        End If
        If gestionderreur(TxtYA) = True Then
            Trem._yA = CDbl(TxtYA.Text)
        Else
            msg = msg & Environment.NewLine & "Cote y du point A pour la trémie n°" & j.ToString & " de la dalle n°" & i1.ToString & " non renseignée."
            Verif = False
        End If
        If gestionderreur(TxtTremieLx) = True Then
            Trem._Lx = CDbl(TxtTremieLx.Text)
        Else
            msg = msg & Environment.NewLine & "Dimension Lx de la trémie n°" & j.ToString & " de la dalle n°" & i1.ToString & " non renseignée."
            Verif = False
        End If
        If gestionderreur(TxtTremieLy) = True Then
            Trem._Ly = CDbl(TxtTremieLy.Text)
        Else
            msg = msg & Environment.NewLine & "Dimension Ly de la trémie n°" & j.ToString & " de la dalle n°" & i1.ToString & " non renseignée."
            Verif = False
        End If
        If ChkbCloisonBordureTremie.Checked = True Then Trem._Cloison = True Else Trem._Cloison = False
        If ChkbChevetre.Checked = True Then Trem._type_chevetre = 1 Else Trem._type_chevetre = 2
        If Verif = False Then Exit Sub
        'entrée des données dans la collection
        j = CInt(LblTremieNum2.Text)
        With dalle
            'vérification qu'une trémie identique n'ait pas été déjà renseignée.
            If j > 1 Then
                For i = 1 To ._Tremie.Count
                    If ._Tremie.Item(i - 1)._xA = Trem._xA And ._Tremie.Item(i - 1)._yA = Trem._yA And ._Tremie.Item(i - 1)._Lx = Trem._Lx And ._Tremie.Item(i - 1)._Ly = Trem._Ly _
                        And ._Tremie.Item(i - 1)._Cloison = Trem._Cloison Then
                        'And ._Tremie.Item(i - 1)._type_chevetre = Trem._type_chevetre: pas de test sur cette partie, à voir en exploitation si nécessaire
                        Exit Sub
                    End If
                Next
            End If
            'trémie non déjà renseigné
            If j > ._Tremie.Count Then
                'ajout de la trémie
                ._Tremie.Add(Trem)
            Else
                If ._Tremie.Item(j - 1)._xA <> Trem._xA Then ._Tremie.Item(j - 1)._xA = Trem._xA
                If ._Tremie.Item(j - 1)._yA <> Trem._yA Then ._Tremie.Item(j - 1)._yA = Trem._yA
                If ._Tremie.Item(j - 1)._Lx <> Trem._Lx Then ._Tremie.Item(j - 1)._Lx = Trem._Lx
                If ._Tremie.Item(j - 1)._Ly <> Trem._Ly Then ._Tremie.Item(j - 1)._Ly = Trem._Ly
                If ._Tremie.Item(j - 1)._Cloison <> Trem._Cloison Then ._Tremie.Item(j - 1)._Cloison = Trem._Cloison
                If ._Tremie.Item(j - 1)._type_chevetre <> Trem._type_chevetre Then
                    Select Case Trem._type_chevetre
                        Case 1
                            Trem._type_chevetre = 2 : ChkbChevetre.Checked = False
                        Case 2
                            ._Tremie.Item(j - 1)._type_chevetre = 2 'forçage du chevêtre dans ce cas
                    End Select

                End If
            End If
        End With
        Trem = Nothing
    End Sub
    Public Sub MonPct_Paint(sender As Object, e As PaintEventArgs) Handles Pb.Paint
        Dim g As Graphics = e.Graphics
        If PlanCont.Count >= 1 Then
            Call Affichage_Geometrie_Dalle(g)
        Else
            g.Clear(Color.White)
        End If
    End Sub
    Private Sub Affichage_Geometrie_Dalle(ByVal g As Graphics)
        Dim h, w, i, j As Integer
        Dim x, x1, y As Single
        Dim P1, P2, Or_x, Or_y, Zoom As Double
        Dim msg As String
        Dim wf As SizeF
        g.Clear(Color.White) 'efface le dessin précédent
        Dim myPen As New Pen(Color.Black, 1)
        Dim myPen2 As New Pen(Color.Black, 2)
        Dim myPenRed As New Pen(Color.Red, 1)
        Dim myPenGrey As New Pen(Color.LightGray, 1)
        Dim myFont As New Font("Times New Roman", 8, FontStyle.Regular)
        Dim myFont2 As New Font("Times New Roman", 12, FontStyle.Bold)
        h = Pb.Height
        w = Pb.Width
        'repère OXY
        'flèche verticale
        g.DrawLine(myPen, CSng(10), CSng(h - 5), CSng(10), CSng(h - 100)) 'n 
        g.DrawLine(myPen, CSng(5), CSng(h - 95), CSng(10), CSng(h - 100)) 'n 
        g.DrawLine(myPen, CSng(15), CSng(h - 95), CSng(10), CSng(h - 100)) 'n 
        g.DrawString("Y", myFont, Brushes.Black, CSng(15), CSng(h - 100))
        'flèche horizontale
        g.DrawLine(myPen, CSng(5), CSng(h - 10), CSng(100), CSng(h - 10)) 'n 
        g.DrawLine(myPen, CSng(95), CSng(h - 5), CSng(100), CSng(h - 10)) 'n 
        g.DrawLine(myPen, CSng(95), CSng(h - 15), CSng(100), CSng(h - 10)) 'n 
        g.DrawString("X", myFont, Brushes.Black, CSng(105), CSng(h - 20))
        'détermination du zoom
        P2 = PlanCont(0).LappH + PlanCont(0).Ly + PlanCont(0).LappB
        P1 = 0
        Dim i_dalle As New Plancher
        For Each i_dalle In PlanCont
            P1 = P1 + i_dalle.LappG + i_dalle.Lx
        Next
        Zoom = (w - 200) / (P1 + PlanCont(PlanCont.Count - 1).LappD)
        If Zoom * P2 > (h - 200) Then
            Zoom = (h - 200) / P2
        End If
        Or_x = 100 : Or_y = PlanCont(0).LappH

        If PlanCont.Count >= 1 Then
            'cotation verticale
            g.DrawLine(myPen, CSng(75), CInt(Or_y * Zoom) + 100,
                           CSng(75), CInt((Or_y + PlanCont.Item(0).Ly + PlanCont.Item(0).LappH + PlanCont.Item(0).LappB) * Zoom) + 100) 'n
            g.DrawLine(myPen, CSng(70), CInt(Or_y * Zoom) + 100, CSng(80), CInt(Or_y * Zoom) + 100) 'n
            g.DrawLine(myPen, CSng(70), CInt((Or_y + PlanCont.Item(0).LappH) * Zoom) + 100, CSng(80),
                           CInt((Or_y + PlanCont.Item(0).LappH) * Zoom) + 100) 'n
            g.DrawLine(myPen, CSng(70), CInt((Or_y + PlanCont.Item(0).Ly + PlanCont.Item(0).LappH) * Zoom) + 100, CSng(80),
                           CInt((Or_y + PlanCont.Item(0).Ly + PlanCont.Item(0).LappH) * Zoom) + 100) 'n
            g.DrawLine(myPen, CSng(70), CInt((Or_y + PlanCont.Item(0).Ly + PlanCont.Item(0).LappH + PlanCont.Item(0).LappB) * Zoom) + 100, CSng(80),
                           CInt((Or_y + PlanCont.Item(0).Ly + PlanCont.Item(0).LappH + PlanCont.Item(0).LappB) * Zoom) + 100) 'n
            msg = (PlanCont.Item(0).LappH * 100).ToString("#") : wf = g.MeasureString(msg, myFont)
            g.DrawString(msg, myFont, Brushes.Black, CSng(68 - wf.Width), CInt((Or_y) * Zoom) + 100)
            msg = (PlanCont.Item(0).Ly * 100).ToString("#") : wf = g.MeasureString(msg, myFont)
            g.DrawString(msg, myFont, Brushes.Black, CSng(68 - wf.Width), CInt((Or_y + PlanCont.Item(0).Ly / 2 + PlanCont.Item(0).LappH) * Zoom) + 100)
            msg = (PlanCont.Item(0).LappB * 100).ToString("#") : wf = g.MeasureString(msg, myFont)
            g.DrawString(msg, myFont, Brushes.Black, CSng(68 - wf.Width), CInt((Or_y + PlanCont.Item(0).Ly + PlanCont.Item(0).LappH) * Zoom) + 100)
            '  cotation horizontale
            y = CInt((Or_y + PlanCont.Item(0).Ly + PlanCont.Item(0).LappH + PlanCont.Item(0).LappB) * Zoom) + 125
            g.DrawLine(myPen, CSng(Or_x), y, CInt((PlanCont.Item(0).LappG * Zoom) + Or_x), y) 'n
            g.DrawLine(myPen, CInt(Or_x), y - 5, CInt(Or_x), y + 5) 'n
            g.DrawLine(myPen, CInt((PlanCont.Item(0).LappG) * Zoom + Or_x), y - 5, CInt((PlanCont.Item(0).LappG) * Zoom + Or_x), y + 5) 'n
            msg = (PlanCont.Item(0).LappG * 100).ToString("#") : wf = g.MeasureString(msg, myFont)
            g.DrawString(msg, myFont, Brushes.Black, CInt(Or_x), y + 10)

        End If


        For Each i_dalle In PlanCont
            'dessin des dalles
            Dim Gpath As New GraphicsPath
            Dim d_Ox, d_Oy, d_Lx, d_Ly As Integer
            P1 = 0
            For i = 1 To PlanCont.IndexOf(i_dalle)
                P1 = P1 + i_dalle.LappG + i_dalle.Lx
            Next
            P1 = P1 + PlanCont(PlanCont.IndexOf(i_dalle)).LappD
            Or_x = P1 : Or_y = PlanCont(0).LappH
            '100 pixels correspond à la marge
            d_Ox = CInt(Or_x * Zoom) + 100 : d_Oy = CInt(Or_y * Zoom) + 100
            d_Lx = CInt(i_dalle.Lx * Zoom) : d_Ly = CInt(i_dalle.Ly * Zoom)
            Dim rect1 As Rectangle
            rect1 = New Rectangle(d_Ox, d_Oy, d_Lx, d_Ly)
            Gpath.AddRectangle(rect1)
            g.DrawPath(myPen2, Gpath)
            'dessin des côtes
            y = CInt((Or_y + PlanCont.Item(0).Ly + PlanCont.Item(0).LappH + PlanCont.Item(0).LappB) * Zoom) + 125
            x = CSng(CInt(Or_x * Zoom) + 100)
            x1 = x + CSng(CInt(i_dalle.Lx * Zoom))
            g.DrawLine(myPen, x1, y + 5, x1, y - 5) 'n
            msg = (PlanCont.Item(PlanCont.IndexOf(i_dalle)).Lx * 100).ToString("#") : wf = g.MeasureString(msg, myFont) 'Lx
            g.DrawString(msg, myFont, Brushes.Black, x + CSng(CInt(i_dalle.Lx / 2 * Zoom)) - wf.Width, y + 10)
            x1 = x + CSng(CInt((i_dalle.Lx + PlanCont.Item(PlanCont.IndexOf(i_dalle)).LappD) * Zoom))
            g.DrawLine(myPen, x, y, x1, y) 'n
            g.DrawLine(myPen, x1, y + 5, x1, y - 5) 'n
            msg = (PlanCont.Item(PlanCont.IndexOf(i_dalle)).LappD * 100).ToString("#") : wf = g.MeasureString(msg, myFont) 'LappD
            g.DrawString(msg, myFont, Brushes.Black, x + CSng(CInt(i_dalle.Lx * Zoom)), y + 10)

            x = CSng(CInt(Or_x * Zoom) + 150) : y = CSng(CInt(Or_y * Zoom) + 150)
            g.DrawString(i_dalle.Nom, myFont2, Brushes.Black, x, y) 'Nom de la dalle

        Next
        Dim i_appui As New Plancher
        If PlanCont(0).LappB > 0.04 Then
            Dim Gpath As New GraphicsPath
            Dim Lx, Ly As Double
            Dim d_Ox, d_Oy, d_Lx, d_Ly As Integer
            Or_x = 0 : Or_y = PlanCont(0).LappH : Lx = PlanCont(0).LappG : Ly = PlanCont(0).Ly
            '100 pixels correspond à la marge
            d_Ox = CInt(Or_x * Zoom) + 100 : d_Oy = CInt(Or_y * Zoom) + 100
            d_Lx = CInt(Lx * Zoom) : d_Ly = CInt(Ly * Zoom)
            Dim rect1 As Rectangle
            rect1 = New Rectangle(d_Ox, d_Oy, d_Lx, d_Ly)
            Gpath.AddRectangle(rect1)
            g.DrawPath(myPen2, Gpath)
        End If
        For Each i_dalle In PlanCont
            Dim Lx, Ly As Double
            Or_x = 100 : P1 = 0
            For i = 1 To PlanCont.IndexOf(i_dalle)
                P1 = P1 + i_dalle.LappG + i_dalle.Lx
            Next
            P1 = P1 + PlanCont(PlanCont.IndexOf(i_dalle)).LappD
            For j = 1 To 3
                Select Case j
                    Case 1 'appui haut
                        Or_x = P1 : Or_y = 0 : Lx = i_dalle.Lx + i_dalle.LappD : Ly = i_dalle.LappH
                    Case 2 'appui bas
                        Or_x = P1 : Or_y = i_dalle.LappH + i_dalle.Ly : Lx = i_dalle.Lx + i_dalle.LappD : Ly = i_dalle.LappB
                    Case 3 'appui droit
                        Or_x = P1 + i_dalle.Lx : Or_y = i_dalle.LappH : Lx = i_dalle.LappD : Ly = i_dalle.Ly
                End Select
                Dim Gpath As New GraphicsPath
                Dim d_Ox, d_Oy, d_Lx, d_Ly As Integer
                '100 pixels correspond à la marge
                d_Ox = CInt(Or_x * Zoom) + 100 : d_Oy = CInt(Or_y * Zoom) + 100
                d_Lx = CInt(Lx * Zoom) : d_Ly = CInt(Ly * Zoom)
                Dim rect1 As Rectangle
                rect1 = New Rectangle(d_Ox, d_Oy, d_Lx, d_Ly)
                Gpath.AddRectangle(rect1)
                g.DrawPath(myPen2, Gpath)
            Next
        Next
        i_appui = Nothing : i_dalle = Nothing

    End Sub
    Private Function gestionderreur(ByVal e As System.Windows.Forms.TextBox, Optional ByRef result As Double = 0) As Boolean
        If Not Double.TryParse(e.Text, result) Then
            If String.IsNullOrEmpty(e.Text) Then
                EP1.SetError(e, "le champ est vide, il n'a pas été renseigné!!")
                gestionderreur = False
            Else
                EP1.SetError(e, "le champ n'est pas une valeur numérique !!")
                gestionderreur = False
            End If
        Else
            EP1.SetError(e, "") ' Clear the error.
            gestionderreur = True
        End If
    End Function

    Private Sub AfficherDalle_Click(sender As Object, e As EventArgs) Handles BtnAfficherDalle.Click
        Dim i1 As Integer
        Dim Verif As Boolean = True
        i1 = CInt(lblDalle.Text)
        If i1 > PlanCont.Count Then
            Call Lecture_Données(Verif)
            If Verif = False Then Exit Sub
            Pb.Refresh()
        Else
            Pb.Refresh()
        End If
        'Dim f As New Form2
        'f.Show()
    End Sub
    Private Sub BtnSuppression_Click(sender As Object, e As EventArgs) Handles BtnSuppression.Click
        Dim i As Integer
        i = CInt(lblDalle.Text)
        Try
            'Suppression de la 1ière ou de la dernière
            PlanCont.RemoveAt(i - 1)
            'Suppression de la travée dans la combinaison correspondante

            lblDalle.Text = "1"
            Call Affichage(0)
            Pb.Invalidate() 'pour forcer le dessin des dalles
        Catch ex As Exception
            MessageBox.Show("Suppression de dalle:" & Environment.NewLine & "Problème lors de la suppression de dalle!" & Environment.NewLine & "Erreur: " & Environment.NewLine & ex.Message,
                            "Formulaire Géométrie", MessageBoxButtons.OK, MessageBoxIcon.Warning, MessageBoxDefaultButton.Button1)
        End Try
    End Sub
    Private Sub Verification_generale(ByRef verif As Boolean)
        Dim msg As String = String.Empty
        verif = True
        Dim dalle As New Plancher
        For Each dalle In PlanCont
            With dalle
                If .Nom = "" Then
                    msg = msg & Environment.NewLine & "Le nom de la dalle n'est pas précisée pour la dalle n°" & (PlanCont.IndexOf(dalle) + 1).ToString 'base 0!
                    verif = False
                End If
                If .H = 0 Then
                    msg = msg & Environment.NewLine & "La hauteur de la dalle n'est pas précisée pour la dalle n°" & (PlanCont.IndexOf(dalle) + 1).ToString 'base 0!
                    verif = False
                End If
                If .H < 0.12 Then
                    msg = msg & Environment.NewLine & "La hauteur de la dalle est insuffisante pour la dalle n°" & (PlanCont.IndexOf(dalle) + 1).ToString & " : h= " & (.H * 100).ToString & " cm." 'base 0!
                    verif = False
                End If
                If .Lx < 1 Then
                    msg = msg & Environment.NewLine & "La dimension Lx de la dalle n'est pas indiquée ou trop faible pour la dalle n°" & (PlanCont.IndexOf(dalle) + 1).ToString & "."
                    verif = False
                End If
                If .Ly < 1 Then
                    msg = msg & Environment.NewLine & "La dimension Ly de la dalle n'est pas indiquée ou trop faible pour la dalle n°" & (PlanCont.IndexOf(dalle) + 1).ToString & "."
                    verif = False
                End If
                If .Prefa = True Then
                    If .Prefa_h < 0.05 Then
                        msg = msg & Environment.NewLine & "L'épaisseur de la prédalle est trop faible pour la dalle n°" & (PlanCont.IndexOf(dalle) + 1).ToString & " (= " & (.Prefa_h * 100).ToString & " cm.), " &
                                                "le minimum étant de 5 cm."
                        verif = False
                    End If

                End If
                If (.AppuiG > 2 OrElse .AppuiG < 1) OrElse (.AppuiD > 2 OrElse .AppuiD < 1) OrElse (.AppuiB > 2 OrElse .AppuiB < 1) OrElse (.AppuiH > 2 OrElse .AppuiH < 1) Then
                    msg = msg & Environment.NewLine & "Un appui n'a pas été défini pour la dalle n°" & (PlanCont.IndexOf(dalle) + 1).ToString & "."
                    verif = False
                End If
                If ((.AppuiG > 2 OrElse .AppuiG < 1) OrElse (.AppuiD > 2 OrElse .AppuiD < 1)) And ._Tremie.Count >= 1 Then
                    msg = msg & Environment.NewLine & "Il n'est pas autorisé de trémie pour les dalles en console. Supprimer la trémie pour la dalle n°" & (PlanCont.IndexOf(dalle) + 1).ToString & "."
                    verif = False
                End If

            End With
        Next

        If verif = False Then
            MessageBox.Show("Défaut d'entrée de données:" & Environment.NewLine & msg, "Formulaire Géométrie", MessageBoxButtons.OK, MessageBoxIcon.Warning, MessageBoxDefaultButton.Button1)
        Else
            For Each dalle In PlanCont
                If rbtn1sens.Checked = True Then
                    dalle.modele_calcul = 1
                Else
                    dalle.modele_calcul = 2
                End If
            Next
        End If
        'If l(1) > 12 Or ly(1) > 12 Then
        '    msg = "La portée d'un élément et de ses appuis est supérieure à 12 m." & vbCrLf & _
        '          "Cela excède les limites du logiciel !!! ."
        '    MsgBox(msg, MsgBoxStyle.Critical, Me.Text)
        '    verif = False
        '    Exit Sub
        'End If

        'If l(1) > ly(1) Then
        '    msg = "La distance entre appuis suivant X doit être inférieure ou égale" & vbCrLf &
        '    "à la distance entre appuis suivant Y. Modifiez les données !"
        '    MsgBox(msg, MsgBoxStyle.Critical, Me.Text)
        '    verif = False
        '    Exit Sub
        'End If

        'If RbtnArt1.Checked <> True And RbtnArt2.Checked <> True Then
        '    msg = "Aucune indication n'a été fournie sur l'articulation des appuis (léger encastrement" & vbCrLf &
        '          " des appuis ou articulation parfaitement libre)! Indiquez une articulation !!! ."
        '    MsgBox(msg, MsgBoxStyle.Information, Me.Text) ' Affiche le message.
        '    verif = False
        'End If



        'If geom = 0 Then
        '    msg = "Le type de construction de dalle (dalle pleine ou prédalle) n'a pas été indiqué."
        '    MsgBox(msg, MsgBoxStyle.Information, Me.Text) ' Affiche le message.
        '    verif = False
        'End If
        '--------> Trémie
        'For 1 = 1 To nbtrav
        'If Long_Tr(1) > 0.6 Then

        '    msg = "La longueur de la trémie pour la travée doit être inférieure à 60 cm." & vbCrLf &
        '    "Modifiez la dimension."
        '    MsgBox(msg, MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, Me.Text)
        '    verif = False
        '    Exit Sub
        'End If
        'If Larg_Tr(1) > 0.6 Then

        '    msg = "La largeur de la trémie pour la travée doit être inférieure à 60 cm." & vbCrLf &
        '    "Modifiez la dimension."
        '    MsgBox(msg, MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, Me.Text)
        '    verif = False
        '    Exit Sub
        'End If
        '----> coefficient de ventilation des moments: vérification suivant A.8.2,32
        Dim coef As Double
        'If Pm0X < 0.75 Then
        '    msg = "Le coefficient de réduction du moment en travée en X est inférieur à 0,75" & vbCrLf &
        '          "Ce coefficient ne respecte pas les conditions imposées par l'article A.8.2,32" & vbCrLf &
        '          "du BAEL 99. Modifiez la valeur de ce coefficient."
        '    MsgBox(msg, MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, Me.Text)
        '    verif = False : Exit Sub
        'End If
        'coef = Pm0X + (PgmX + PdmX) / 2
        'If coef < 1.25 And Pm0X <> 1 Then
        '    'le cas pourrait se présenter d'avoir une isostaticité dans un sens et une hyperstaticité dans l'autre sens
        '    Dim F1 As String
        '    F1 = Format(coef, "0.00")
        '    msg = "Le coefficient de fermeture des moments suivant X doit être supérieur à 1,25. Les" & vbCrLf &
        '          "valeurs indiquées ne permettent pas d'atteindre ce seuil, la sommation est égale à " & F1 & "." & vbCrLf &
        '    "Modifiez la valeur des coefficients."
        '    MsgBox(msg, MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, Me.Text)
        '    verif = False : Exit Sub
        'End If
        'If Pm0Y < 0.75 Then
        '    msg = "Le coefficient de réduction du moment en travée en Y est inférieur à 0,75" & vbCrLf &
        '          "Ce coefficient ne respecte pas les conditions imposées par l'article A.8.2,32" & vbCrLf &
        '          "du BAEL 99. Modifiez la valeur de ce coefficient."
        '    MsgBox(msg, MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, Me.Text)
        '    verif = False : Exit Sub
        'End If
        'coef = Pm0Y + (PhmY + PbmY) / 2
        'If coef < 1.25 And Pm0Y <> 1 Then
        '    Dim F1 As String
        '    F1 = Format(coef, "0.00")
        '    msg = "Le coefficient de fermeture des moments suivant Y doit être supérieur à 1,25. Les" & vbCrLf &
        '          "valeurs indiquées ne permettent pas d'atteindre ce seuil, la sommation est égale à " & F1 & "." & vbCrLf &
        '    "Modifiez la valeur des coefficients."
        '    MsgBox(msg, MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, Me.Text)
        '    verif = False : Exit Sub
        'End If
        '-> Vérification des conditions géométriques pour un portage dans les 2 sens
        Dim alpha As Double
        'alpha = l(1) / ly(1)
        'If alpha < 0.4 Then
        '    Dim F_alpha As String
        '    F_alpha = Format(alpha, "0.##0")
        '    msg = "Le rapport des portées est inférieur à 0,4 (= " & F_alpha & "). La dalle" & vbCrLf &
        '          "sera calculée comme portant dans un seul sens: celui de la petite portée"
        '    MsgBox(msg, MsgBoxStyle.Information, Me.Text)
        '    type_calcul = 2
        'End If

    End Sub
    Private Sub BtnOK_Click(sender As Object, e As EventArgs) Handles BtnOK.Click
        Dim Verif As Boolean = True
        Try
            Call Lecture_Données(Verif)
            If Verif = False Then Exit Sub
            Call Verification_generale(Verif)
            If Verif = False Then Exit Sub
            Me.Close()
            Me.Dispose()
            Me.Finalize()
        Catch ex As Exception
            MessageBox.Show("Erreur: " & Environment.NewLine & ex.Message, "Formulaire Géométrie", MessageBoxButtons.OK, MessageBoxIcon.Warning, MessageBoxDefaultButton.Button1)
        End Try

    End Sub
    Private Sub BtnAnnuler_Click(sender As Object, e As EventArgs) Handles BtnAnnuler.Click
        Me.Dispose()
        Me.Finalize()
    End Sub

    Private Sub ChkbPlancherPrefa_CheckedChanged(sender As Object, e As EventArgs) Handles ChkbPlancherPrefa.CheckedChanged
        If ChkbPlancherPrefa.Checked Then
            ChkbAffichePredal.Enabled = True
            TxtEpPredal.Enabled = True
            Txt_Prefa_L.Enabled = True
            Txt_Prefa_Esp.Enabled = True
            'étaiement prédalles
            GbMiseenOeuvre_Predal.Enabled = True
            'repos sur appuis porteurs
            GbAppuis_Porteurs.Enabled = True
            'Etat de surface de la prédalle
            RbtnEtatRugueux.Checked = True
        Else
            ChkbAffichePredal.Checked = False : ChkbAffichePredal.Enabled = False
            TxtEpPredal.Text = String.Empty : TxtEpPredal.Enabled = False
            Txt_Prefa_L.Text = String.Empty : Txt_Prefa_L.Enabled = False
            Txt_Prefa_Esp.Text = String.Empty : Txt_Prefa_Esp.Enabled = False
            'étaiement prédalles
            GbMiseenOeuvre_Predal.Enabled = False
            'repos sur appuis porteurs
            GbAppuis_Porteurs.Enabled = False
            'Etat de surface de la prédalle
            GbSurf_Predal.Enabled = False : RbtnEtatLisse.Checked = False : RbtnEtatRugueux.Checked = False
        End If
    End Sub

#Region "Onglet Appui: Lecture Ecriture"
    Private Sub ChkbAppui_Même_Type_CheckedChanged(sender As Object, e As EventArgs) Handles ChkbAppui_Même_Type.CheckedChanged
        If ChkbAppui_Même_Type.Checked = True Then
            rbtnG_Beton.Enabled = True : rbtnG_Ma.Enabled = True
            GbAppuiBas.Visible = False : GbAppuiDroit.Visible = False : GbAppuiHaut.Visible = False
        Else
            rbtnG_Beton.Enabled = True : rbtnG_Ma.Enabled = True
            GbAppuiBas.Visible = True : GbAppuiDroit.Visible = True : GbAppuiHaut.Visible = True
        End If
    End Sub
    Private Sub ChkbAppui_Même_Largeur_CheckedChanged(sender As Object, e As EventArgs) Handles ChkbAppui_Même_Largeur.CheckedChanged
        If ChkbAppui_Même_Largeur.Checked = True Then
            TxtL_AppB.Text = String.Empty : TxtL_AppD.Text = String.Empty : TxtL_AppH.Text = String.Empty
            TxtL_AppB.Enabled = False : TxtL_AppD.Enabled = False : TxtL_AppH.Enabled = False
        Else
            TxtL_AppB.Enabled = True : TxtL_AppD.Enabled = True : TxtL_AppH.Enabled = True
        End If
    End Sub
#End Region

#Region "Gestion GroupeBox Etaiement"
    Private Sub RbtnEtaiSans_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnEtaiSans.CheckedChanged
        If RbtnEtaiSans.Checked = True Then
            txt_Prefa_Letai.Text = String.Empty : txt_Prefa_Letai.Enabled = False
        End If
    End Sub
    Private Sub RbtnEtaiAvec_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnEtaiAvec.CheckedChanged
        If RbtnEtaiAvec.Checked = True Then
            txt_Prefa_Letai.Enabled = True : txt_Prefa_Letai.Focus()
        End If
    End Sub
#End Region

#Region "Gestion GroupBox Lisse de rive"
    Private Sub Rbtn_LisseRive_Avec_CheckedChanged(sender As Object, e As EventArgs) Handles Rbtn_LisseRive_Avec.CheckedChanged
        If Rbtn_LisseRive_Avec.Checked = True Then
            TxtAvecLisse_RepGauche.Enabled = True : TxtAvecLisse_RepDroit.Enabled = True
            TxtAvecLisse_RepGauche.Focus()
            GbRepos.Enabled = False
            RbtnRepos_TabA3.Checked = False
            RbtnRepos_Valeur.Checked = False
            TxtSansLisse_RepGauche.Text = String.Empty : TxtSansLisse_RepGauche.Enabled = False
            TxtSansLisse_RepDroit.Text = String.Empty : TxtSansLisse_RepDroit.Enabled = False
        End If
    End Sub
    Private Sub Rbtn_LisseRive_Sans_CheckedChanged(sender As Object, e As EventArgs) Handles Rbtn_LisseRive_Sans.CheckedChanged
        If Rbtn_LisseRive_Sans.Checked = True Then
            GbRepos.Enabled = True
            TxtAvecLisse_RepGauche.Text = String.Empty : TxtAvecLisse_RepGauche.Enabled = False
            TxtAvecLisse_RepDroit.Text = String.Empty : TxtAvecLisse_RepDroit.Enabled = False
        End If
    End Sub
    Private Sub RbtnRepos_TabA3_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnRepos_TabA3.CheckedChanged
        If RbtnRepos_TabA3.Checked = True Then
            TxtSansLisse_RepGauche.Text = String.Empty : TxtSansLisse_RepGauche.Enabled = False
            TxtSansLisse_RepDroit.Text = String.Empty : TxtSansLisse_RepDroit.Enabled = False
        End If
    End Sub
    Private Sub RbtnRepos_Valeur_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnRepos_Valeur.CheckedChanged
        If RbtnRepos_Valeur.Checked = True Then
            TxtSansLisse_RepDroit.Enabled = True
            TxtSansLisse_RepGauche.Enabled = True : TxtSansLisse_RepGauche.Focus()
        End If
    End Sub
#End Region

#Region "Gestion de la lecture et de l'affichage de l'onglet Trémie"
    Private Sub BtnTremieAjout_Click(sender As Object, e As EventArgs) Handles BtnTremieAjout.Click
        Dim Verif As Boolean = True
        Dim msg As String = String.Empty
        Dim i, j As Integer
        j = CInt(lblDalle.Text)

        If LblTremieNum2.Visible = False Then
            '1ier affichage
            For Each ctrl As Control In TC1.TabPages.Item(3).Controls
                ctrl.Visible = True
            Next
            BtnMoinsTremie.Visible = False : BtnPlusTrémie.Visible = False
            LblTremieNum1.Text = "Trémie n°"
            LblTremieNum2.Text = "1"
            Call Affichage_Onglet_Tremie_Neutre()
        Else
            'lecture de la trémie déjà renseigné et passage à la trémie suivante
            i = CInt(LblTremieNum2.Text)
            Call Lecture_Onglet_Tremie_Indirect(msg, Verif)
            If Verif = False Then
                MessageBox.Show(msg, "Géométrie: lecture onglet trémie", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Exit Sub
            End If
            i = i + 1
            If i > 10 Then MessageBox.Show(msg, "Le nombre de trémies est limité à 10 par travée.", MessageBoxButtons.OK, MessageBoxIcon.Exclamation) : Exit Sub
            btnTremieSuppression.Visible = True
            BtnMoinsTremie.Visible = True
            LblTremieNum2.Text = i.ToString
            If Tr_Lx(j, i) >= 0.1 And Tr_Ly(j, i) >= 0.1 Then
                Call Affichage_Onglet_Tremie(j, i)
            Else
                Call Affichage_Onglet_Tremie_Neutre()
            End If
        End If
    End Sub

    Private Sub btnTremieSuppression_Click(sender As Object, e As EventArgs) Handles btnTremieSuppression.Click
        Dim Verif As Boolean = True
        Dim msg As String = String.Empty
        Dim i, j As Integer
        i = CInt(LblTremieNum2.Text)
        j = CInt(lblDalle.Text)
        If i = 1 Then
            'vérification que cette trémie a déjà été intégré dans le plancher
            If PlanCont.Count >= j Then
                Select Case PlanCont.Item(j - 1)._Tremie.Count
                    Case 0
                        'aucune trémie - je ne fais rien de particulier
                        For Each ctrl As Control In TC1.TabPages.Item(3).Controls : ctrl.Visible = False : Next : LblTremieNum1.Visible = True : LblTremieNum1.Text = "Aucune trémie"
                        BtnTremieAjout.Visible = True : BtnHlpTremie.Visible = True : nbTremie(j) = 0
                    Case 1
                        'je supprime la seule trémie existante
                        For Each ctrl As Control In TC1.TabPages.Item(3).Controls : ctrl.Visible = False : Next : LblTremieNum1.Visible = True : LblTremieNum1.Text = "Aucune trémie"
                        BtnTremieAjout.Visible = True : BtnHlpTremie.Visible = True : nbTremie(j) = 0
                        Call Erase_Tremie(j)
                    Case 2
                        'je supprime une trémie mais une autre existe
                        PlanCont.Item(j - 1)._Tremie.RemoveAt(i - 1) : nbTremie(j) = 1
                        i = 1 : LblTremieNum2.Text = i.ToString : BtnPlusTrémie.Visible = False : BtnMoinsTremie.Visible = False
                        Call Affichage_Onglet_Tremie(j, i)
                    Case Else
                        'je supprime une trémie mais d'autres existent
                        PlanCont.Item(j - 1)._Tremie.RemoveAt(i - 1) : nbTremie(j) = PlanCont.Item(j - 1)._Tremie.Count
                        i = 1 : LblTremieNum2.Text = i.ToString : BtnPlusTrémie.Visible = True : BtnMoinsTremie.Visible = False
                        Call Affichage_Onglet_Tremie(j, i)
                End Select

            Else
                nbTremie(j) -= 1
                If nbTremie(j) = -1 Then nbTremie(j) = 0
                'cette trémie n'a pas encore été intégrée dans le plancher
                If nbTremie(j) = 0 Then
                        'initialisation du programme - aucune travée n'a encore été renseignée
                        'aucune trémie - je ne fais rien de particulier
                        For Each ctrl As Control In TC1.TabPages.Item(3).Controls : ctrl.Visible = False : Next : LblTremieNum1.Visible = True : LblTremieNum1.Text = "Aucune trémie"
                    BtnTremieAjout.Visible = True : BtnHlpTremie.Visible = True
                    Tr_Xa(j, 1) = 0 : Tr_Ya(j, 1) = 0 : Tr_Lx(j, 1) = 0 : Tr_Ly(j, 1) = 0 : Tr_Cloison(j, 1) = False : Tr_Chevetre(j, 1) = 2
                Else

                        'remise à zero des valeurs et nouvelle affectation par rotation circulaire
                        For k = i To 9
                            Tr_Xa(j, k) = Tr_Xa(j, k + 1) : Tr_Ya(j, k) = Tr_Ya(j, k + 1) : Tr_Lx(j, k) = Tr_Lx(j, k + 1) : Tr_Ly(j, k) = Tr_Ly(j, k + 1) : Tr_Cloison(j, k) = Tr_Cloison(j, k + 1) : Tr_Chevetre(j, k) = Tr_Chevetre(j, k + 1)
                        Next
                        Tr_Xa(j, 10) = 0 : Tr_Ya(j, 10) = 0 : Tr_Lx(j, 10) = 0 : Tr_Ly(j, 10) = 0 : Tr_Cloison(j, 10) = False : Tr_Chevetre(j, 10) = 2
                        Call Affichage_Onglet_Tremie(j, i)
                    End If
                End If
                Else
            'vérification que cette trémie a déjà été intégré dans le plancher
            If PlanCont.Count >= j Then
                Select Case PlanCont.Item(j - 1)._Tremie.Count
                    Case 0
                        'aucune trémie - je ne fais rien de particulier
                        For Each ctrl As Control In TC1.TabPages.Item(3).Controls : ctrl.Visible = False : Next : LblTremieNum1.Visible = True : LblTremieNum1.Text = "Aucune trémie"
                        BtnTremieAjout.Visible = True : BtnHlpTremie.Visible = True : nbTremie(j) = 0
                    Case 1
                        'je supprime la seule trémie existante
                        For Each ctrl As Control In TC1.TabPages.Item(3).Controls : ctrl.Visible = False : Next : LblTremieNum1.Visible = True : LblTremieNum1.Text = "Aucune trémie"
                        BtnTremieAjout.Visible = True : BtnHlpTremie.Visible = True : nbTremie(j) = 0
                        Call Erase_Tremie(j)
                    Case 2
                        'je supprime une trémie mais une autre existe
                        PlanCont.Item(j - 1)._Tremie.RemoveAt(i - 1) : nbTremie(j) = 1
                        i = 1 : LblTremieNum2.Text = i.ToString : BtnPlusTrémie.Visible = False : BtnMoinsTremie.Visible = False
                        Call Affichage_Onglet_Tremie(j, i)
                    Case Else
                        'je supprime une trémie mais d'autres existent
                        PlanCont.Item(j - 1)._Tremie.RemoveAt(i - 1) : nbTremie(j) = PlanCont.Item(j - 1)._Tremie.Count
                        i = 1 : LblTremieNum2.Text = i.ToString : BtnPlusTrémie.Visible = True : BtnMoinsTremie.Visible = False
                        Call Affichage_Onglet_Tremie(j, i)
                End Select
            Else

                Dim k As Integer
                'remise à zero des valeurs et nouvelle affectation par rotation circulaire
                For k = i To 9
                    Tr_Xa(j, k) = Tr_Xa(j, k + 1) : Tr_Ya(j, k) = Tr_Ya(j, k + 1) : Tr_Lx(j, k) = Tr_Lx(j, k + 1) : Tr_Ly(j, k) = Tr_Ly(j, k + 1) : Tr_Cloison(j, k) = Tr_Cloison(j, k + 1) : Tr_Chevetre(j, k) = Tr_Chevetre(j, k + 1)
                Next
                Tr_Xa(j, 10) = 0 : Tr_Ya(j, 10) = 0 : Tr_Lx(j, 10) = 0 : Tr_Ly(j, 10) = 0 : Tr_Cloison(j, 10) = False : Tr_Chevetre(j, 10) = 2
                i = i - 1 : LblTremieNum2.Text = i.ToString
                nbTremie(j) -= 1
                Call Affichage_Onglet_Tremie(j, i)
            End If
        End If
        If i = 1 Then BtnMoinsTremie.Visible = False
        If nbTremie(j) = 1 Then BtnPlusTrémie.Visible = False
        LblNbTemie.Text = "Nombre total de trémies: " & nbTremie(j).ToString
    End Sub

    Private Sub BtnPlusTrémie_Click(sender As Object, e As EventArgs) Handles BtnPlusTrémie.Click
        Dim Verif As Boolean = True
        Dim msg As String = String.Empty
        Dim i, j As Integer
        j = CInt(lblDalle.Text)
        If LblTremieNum2.Visible = False Then
            For Each ctrl As Control In TC1.TabPages.Item(3).Controls
                ctrl.Visible = True
            Next
            LblTremieNum1.Text = "Trémie n°"
            LblTremieNum2.Text = "1"
            If PlanCont.Count >= j AndAlso PlanCont.Item(j - 1)._Tremie.Count >= 1 Then
                nbTremie(j) = PlanCont.Item(j - 1)._Tremie.Count
                LblNbTemie.Text = "Nombre total de trémies: " & nbTremie(j).ToString

                With PlanCont.Item(j - 1)._Tremie.Item(0)
                    Tr_Xa(j, 1) = ._xA : Tr_Ya(j, 1) = ._yA : Tr_Lx(j, 1) = ._Lx : Tr_Ly(j, 1) = ._Ly : Tr_Cloison(j, 1) = ._Cloison : Tr_Chevetre(j, 1) = ._type_chevetre
                End With
                Call Affichage_Onglet_Tremie(j, 1)
            Else
                Call Affichage_Onglet_Tremie_Neutre()
                nbTremie(j) = 1
                LblNbTemie.Text = "Nombre total de trémies: " & nbTremie(j).ToString
            End If

        Else
            i = CInt(LblTremieNum2.Text)
            Call Lecture_Onglet_Tremie_Indirect(msg, Verif)
            If Verif = False Then
                MessageBox.Show(msg, "Géométrie: lecture onglet trémie", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Exit Sub
            End If
            BtnMoinsTremie.Visible = True
            i = i + 1
            If i > 10 Then Exit Sub
            If i > nbTremie(j) Then Exit Sub
            If i = nbTremie(j) Then BtnPlusTrémie.Visible = False
            LblTremieNum2.Text = i.ToString

            'Affichage de la trémie suivante

            If PlanCont.Count >= j AndAlso PlanCont.Item(j - 1)._Tremie.Count >= i Then
                nbTremie(j) = PlanCont.Item(j - 1)._Tremie.Count
                LblNbTemie.Text = "Nombre total de trémies: " & nbTremie(j).ToString
                Call Affichage_Onglet_Tremie_validé(j, i)

            Else
                'pas de validation particulière car cela a déjà été validé
                Call Affichage_Onglet_Tremie(j, i)
            End If

        End If
    End Sub
    Private Sub BtnMoinsTremie_Click(sender As Object, e As EventArgs) Handles BtnMoinsTremie.Click
        Dim Verif As Boolean = True
        Dim msg As String = String.Empty
        Dim i, j As Integer
        i = CInt(LblTremieNum2.Text)
        j = CInt(lblDalle.Text)

        Lecture_Onglet_Tremie_Indirect(msg, Verif)
        If Verif = False Then
            MessageBox.Show(msg, "Géométrie: lecture onglet trémie", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        Else
            If nbTremie(j) < i Then nbTremie(j) = i
            LblNbTemie.Text = "Nombre total de trémies: " & nbTremie(j).ToString
        End If
            i = i - 1
        LblTremieNum2.Text = i.ToString
        Call Affichage_Onglet_Tremie(j, i)
        If i = 1 Then
            BtnMoinsTremie.Visible = False
            If PlanCont.Count >= j AndAlso PlanCont.Item(j - 1)._Tremie.Count > i Then
                BtnPlusTrémie.Visible = True
            Else
                If nbTremie(j) > i Then BtnPlusTrémie.Visible = True
                Call Affichage_Onglet_Tremie(j, i)
            End If
        Else
            BtnMoinsTremie.Visible = True
            If PlanCont.Count >= j AndAlso PlanCont.Item(j - 1)._Tremie.Count >= i Then
                BtnPlusTrémie.Visible = True
            Else
                If Tr_Lx(j, i) >= 0.1 And Tr_Ly(j, i) >= 0.1 Then Call Affichage_Onglet_Tremie(j, i)
                If nbTremie(j) > i Then BtnPlusTrémie.Visible = True
            End If
        End If

    End Sub
    Private Sub Lecture_Onglet_Tremie_Indirect(ByRef msg As String, ByRef Verif As Boolean)
        Dim i, j, chevetre As Integer
        Dim xA, yA, T_Lx, T_Ly As Double
        Dim Cloison As Boolean = False
        i = CInt(lblDalle.Text)
        'Lecture des données affichées
        If gestionderreur(TxtXA) = True Then
            xA = CDbl(TxtXA.Text)
        Else
            msg = msg & Environment.NewLine & "Cote x du point A pour la trémie n°" & j.ToString & " de la dalle n°" & i.ToString & " non renseignée."
            Verif = False
        End If
        If gestionderreur(TxtYA) = True Then
            yA = CDbl(TxtYA.Text)
        Else
            msg = msg & Environment.NewLine & "Cote y du point A pour la trémie n°" & j.ToString & " de la dalle n°" & i.ToString & " non renseignée."
            Verif = False
        End If
        If gestionderreur(TxtTremieLx) = True Then
            T_Lx = CDbl(TxtTremieLx.Text)
        Else
            msg = msg & Environment.NewLine & "Dimension Lx de la trémie n°" & j.ToString & " de la dalle n°" & i.ToString & " non renseignée."
            Verif = False
        End If
        If gestionderreur(TxtTremieLy) = True Then
            T_Ly = CDbl(TxtTremieLy.Text)
        Else
            msg = msg & Environment.NewLine & "Dimension Ly de la trémie n°" & j.ToString & " de la dalle n°" & i.ToString & " non renseignée."
            Verif = False
        End If
        If ChkbCloisonBordureTremie.Checked = True Then Cloison = True Else Cloison = False
        If ChkbChevetre.Checked = True Then chevetre = 1 Else chevetre = 0
        If Verif = False Then Exit Sub
        'entrée des données dans la collection
        j = CInt(LblTremieNum2.Text)
        Tr_Xa(i, j) = xA : Tr_Ya(i, j) = yA : Tr_Lx(i, j) = T_Lx : Tr_Ly(i, j) = T_Ly : Tr_Cloison(i, j) = Cloison : Tr_Chevetre(i, j) = chevetre
    End Sub
    ''' <summary>Affichage_Onglet de la Tremie i se trouvant dans la travée j - Cette trémie a déjà été intégré dans la classe plancher</summary>
    ''' <param name="j">n° de travée</param>
    ''' <param name="i">n° de trémie</param>
    Private Sub Affichage_Onglet_Tremie_validé(ByVal j As Integer, ByVal i As Integer)
        With PlanCont.Item(j - 1)._Tremie.Item(i - 1)
            TxtXA.Text = ._xA.ToString("#0.00")
            TxtYA.Text = ._yA.ToString("#0.00")
            TxtTremieLx.Text = ._Lx.ToString("#0.00")
            TxtTremieLy.Text = ._Ly.ToString("#0.00")
            If ._Cloison = True Then ChkbCloisonBordureTremie.Checked = True Else ChkbCloisonBordureTremie.Checked = False
            If ._type_chevetre = 1 Then ChkbChevetre.Checked = True Else ChkbChevetre.Checked = False
        End With
    End Sub
    ''' <summary>Affichage_Onglet de la Tremie i se trouvant dans la travée j - Cette trémie n'a pas encore été intégré dans la classe plancher</summary>
    ''' <param name="j">n° de travée</param>
    ''' <param name="i">n° de trémie</param>
    Private Sub Affichage_Onglet_Tremie(ByVal j As Integer, ByVal i As Integer)
        TxtXA.Text = Tr_Xa(j, i).ToString("#0.00")
        TxtYA.Text = Tr_Ya(j, i).ToString("#0.00")
        TxtTremieLx.Text = Tr_Lx(j, i).ToString("#0.00")
        TxtTremieLy.Text = Tr_Ly(j, i).ToString("#0.00")
        If Tr_Cloison(j, i) = True Then ChkbCloisonBordureTremie.Checked = True Else ChkbCloisonBordureTremie.Checked = False
        If Tr_Chevetre(j, i) = 1 Then ChkbChevetre.Checked = True Else ChkbChevetre.Checked = False
    End Sub
    ''' <summary>Affichage initial des champs de texte </summary>
    Private Sub Affichage_Onglet_Tremie_Neutre()
        TxtXA.Text = String.Empty
        TxtYA.Text = String.Empty
        TxtTremieLx.Text = String.Empty
        TxtTremieLy.Text = String.Empty
        ChkbCloisonBordureTremie.Checked = False
        ChkbChevetre.Checked = False
    End Sub
    ''' <summary>Suppression de toutes les trémies se trouvant dans la travée i </summary>
    ''' <param name="i">n° de travée</param>
    Private Sub Erase_Tremie(ByVal i As Integer)
        If PlanCont.Count >= 1 Then
            With PlanCont.Item(i - 1)
                ._Tremie.Clear()
            End With
        End If
        For j = 0 To 10 : Tr_Xa(i, j) = 0 : Tr_Ya(i, j) = 0 : Tr_Lx(i, j) = 0 : Tr_Ly(i, j) = 0 : Tr_Cloison(i, j) = False : Tr_Chevetre(i, j) = 2 : Next
    End Sub
#End Region

#Region "Gestion des textbox: pb point virgule, signe -, etc. ..."
    Private Sub TxtLx_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtLx.KeyPress
        Call Gestion_Keypress(e, TxtLx, True, False)
    End Sub
    Private Sub TxtLy_TextChanged(sender As Object, e As EventArgs) Handles TxtLy.TextChanged

    End Sub
    Private Sub TxtLy_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtLy.KeyPress
        Call Gestion_Keypress(e, TxtLy, True, False)
    End Sub
    Private Sub TxtEp_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtEp.KeyPress
        Call Gestion_Keypress(e, TxtEp, True, False)
    End Sub
    Private Sub TxtL_AppB_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtL_AppB.KeyPress
        Call Gestion_Keypress(e, TxtL_AppB, True, False)
    End Sub
    Private Sub TxtL_AppD_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtL_AppD.KeyPress
        Call Gestion_Keypress(e, TxtL_AppD, True, False)
    End Sub
    Private Sub TxtL_AppG_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtL_AppG.KeyPress
        Call Gestion_Keypress(e, TxtL_AppG, True, False)
    End Sub
    Private Sub TxtL_AppH_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtL_AppH.KeyPress
        Call Gestion_Keypress(e, TxtL_AppH, True, False)
    End Sub
    Private Sub TxtEpPredal_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtEpPredal.KeyPress
        Call Gestion_Keypress(e, TxtEpPredal, True, False)
    End Sub
    Private Sub Txt_Prefa_Esp_KeyPress(sender As Object, e As KeyPressEventArgs) Handles Txt_Prefa_Esp.KeyPress
        Call Gestion_Keypress(e, Txt_Prefa_Esp, True, False)
    End Sub
    Private Sub Txt_Prefa_L_KeyPress(sender As Object, e As KeyPressEventArgs) Handles Txt_Prefa_L.KeyPress
        Call Gestion_Keypress(e, Txt_Prefa_L, True, False)
    End Sub
    Private Sub txt_Prefa_Letai_KeyPress(sender As Object, e As KeyPressEventArgs) Handles txt_Prefa_Letai.KeyPress
        Call Gestion_Keypress(e, txt_Prefa_Letai, True, False)
    End Sub
    Private Sub TxtAvecLisse_RepDroit_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtAvecLisse_RepDroit.KeyPress
        Call Gestion_Keypress(e, TxtAvecLisse_RepDroit, True, False)
    End Sub
    Private Sub TxtAvecLisse_RepGauche_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtAvecLisse_RepGauche.KeyPress
        Call Gestion_Keypress(e, TxtAvecLisse_RepGauche, True, False)
    End Sub
    Private Sub TxtsansLisse_RepDroit_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtSansLisse_RepDroit.KeyPress
        Call Gestion_Keypress(e, TxtSansLisse_RepDroit, True, False)
    End Sub
    Private Sub TxtSansLisse_RepGauche_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtSansLisse_RepGauche.KeyPress
        Call Gestion_Keypress(e, TxtSansLisse_RepGauche, True, False)
    End Sub
    Private Sub TxtXA_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtXA.KeyPress
        Call Gestion_Keypress(e, TxtXA, True, False)
    End Sub
    Private Sub TxtYA_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtYA.KeyPress
        Call Gestion_Keypress(e, TxtYA, True, False)
    End Sub
    Private Sub TxtTremieLx_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtTremieLx.KeyPress
        Call Gestion_Keypress(e, TxtTremieLx, True, False)
    End Sub
    Private Sub TxtTremieLy_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtTremieLy.KeyPress
        Call Gestion_Keypress(e, TxtTremieLy, True, False)
    End Sub
#End Region

#Region "Fichier d'aide"
    Private Sub BtnHlpLx_Ly_Click(sender As Object, e As EventArgs) Handles BtnHlpLx_Ly.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 20
        frm1.Show()
    End Sub
    Private Sub BtnHlpAppui_Click(sender As Object, e As EventArgs) Handles BtnHlpAppui.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 19
        frm1.Show()
    End Sub
    Private Sub BtnHlpSensPortee_Click(sender As Object, e As EventArgs) Handles BtnHlpSensPortee.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 23
        frm1.Show()
    End Sub
    Private Sub BtnHlpTravIso_Click(sender As Object, e As EventArgs) Handles BtnHlpTravIso.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 25
        frm1.Show()
    End Sub
#Region "Onglet Predalle"
    Private Sub BtnHlpEpaisseurPredal_Click(sender As Object, e As EventArgs) Handles BtnHlpEpaisseurPredal.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 15
        frm1.Show()
    End Sub
    Private Sub BtnHlpPredlaLargeurPreferentielle_Click(sender As Object, e As EventArgs) Handles BtnHlpPredlaLargeurPreferentielle.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 16
        frm1.Show()
    End Sub
    Private Sub BtnHlpEspPredal_Click(sender As Object, e As EventArgs) Handles BtnHlpEspPredal.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 17
        frm1.Show()
    End Sub
    Private Sub BtnHlpEtaiement_Click(sender As Object, e As EventArgs) Handles BtnHlpEtaiement.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 11
        frm1.Show()
    End Sub
    Private Sub BtnHlpReposAppuiPorteur_Click(sender As Object, e As EventArgs) Handles BtnHlpReposAppuiPorteur.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 6
        frm1.Show()
    End Sub

    Private Sub Nud1_ValueChanged(sender As Object, e As EventArgs) Handles Nud1.TextChanged
        If Nud1.Value = 1 Then
            BtnMoins.Visible = False : BtnPlus.Visible = False
        Else
            If CInt(lblDalle.Text) < Nud1.Value Then BtnPlus.Visible = True

            'Select Case PlanCont.Count
            '    Case 0 'lors de l'initialisation du logiciel
            '        BtnPlus.Visible = True
            '    Case 1
            '        If CInt(lblDalle.Text) < PlanCont.Count Then BtnPlus.Visible = True
            '    Case Else
            '        If CInt(lblDalle.Text) < PlanCont.Count Then BtnPlus.Visible = True
            'End Select

            If CInt(lblDalle.Text) > 1 Then BtnMoins.Visible = True
        End If
    End Sub

    Private Sub BtnHlpRugosite_Click(sender As Object, e As EventArgs) Handles BtnHlpRugosite.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 12
        frm1.Show()
    End Sub
#End Region

    Private Sub BtnHlpTremie_Click(sender As Object, e As EventArgs) Handles BtnHlpTremie.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 18
        frm1.Show()
    End Sub

#End Region

    Private Sub Poubelle()

        ''dessin Appuis
        'P1 = 0
        'Select Case PlanCont.Count
        '    Case 0
        '        P1 = 0
        '        For j = 1 To 4
        '            Select Case j
        '                Case 1 'appui haut
        '                           '                    Or_x = 0 : Or_y = 0 : Lx = Dalle1.LappG + Dalle1.Lx + Dalle1.LappD : Dess_appui1.Ly = Dalle1.LappH
        '                    _Items1.Add(Dess_appui1)
        '                    Dess_appui1 = Nothing
        '                Case 2 'appui bas
        '                    Dess_appui2.Zoom = Dess_dalle.Zoom
        '                    Dess_appui2.Or_x = 0 : Dess_appui2.Or_y = Dalle1.LappH + Dalle1.Ly : Dess_appui2.Lx = Dalle1.LappG + Dalle1.Lx + Dalle1.LappD : Dess_appui2.Ly = Dalle1.LappB
        '                    _Items1.Add(Dess_appui2)
        '                    Dess_appui2 = Nothing
        '                Case 3 'appui gauche
        '                    Dess_appui3.Zoom = Dess_dalle.Zoom
        '                    Dess_appui3.Or_x = 0 : Dess_appui3.Or_y = Dalle1.LappH : Dess_appui3.Lx = Dalle1.LappG : Dess_appui3.Ly = Dalle1.Ly
        '                    _Items1.Add(Dess_appui3)
        '                    Dess_appui3 = Nothing
        '                Case 4 'appui droit
        '                    Dess_appui4.Zoom = Dess_dalle.Zoom
        '                    Dess_appui4.Or_x = Dalle1.LappG + Dalle1.Lx : Dess_appui4.Or_y = Dalle1.LappH : Dess_appui4.Lx = Dalle1.LappD : Dess_appui4.Ly = Dalle1.Ly
        '                    _Items1.Add(Dess_appui4)
        '                    Dess_appui4 = Nothing
        '            End Select
        '        Next
        '    Case Else
        '        For Each i In PlanCont
        '            P1 = P1 + i.LappG + i.Lx
        '        Next
        '        P1 = P1 + Dalle1.LappG
        '        For j = 1 To 3
        '            Select Case j
        '                Case 1 'appui haut
        '                    Dess_appui1.Zoom = Dess_dalle.Zoom
        '                    Dess_appui1.Or_x = P1 : Dess_appui1.Or_y = 0 : Dess_appui1.Lx = Dalle1.Lx + Dalle1.LappD : Dess_appui1.Ly = Dalle1.LappH
        '                    _Items1.Add(Dess_appui1)
        '                    Dess_appui1 = Nothing
        '                Case 2 'appui bas
        '                    Dess_appui2.Zoom = Dess_dalle.Zoom
        '                    Dess_appui2.Or_x = P1 : Dess_appui2.Or_y = Dalle1.LappH + Dalle1.Ly : Dess_appui2.Lx = Dalle1.Lx + Dalle1.LappD : Dess_appui2.Ly = Dalle1.LappB
        '                    _Items1.Add(Dess_appui2)
        '                    Dess_appui2 = Nothing
        '                Case 3 'appui droit
        '                    Dess_appui3.Zoom = Dess_dalle.Zoom
        '                    Dess_appui3.Or_x = P1 + Dalle1.Lx : Dess_appui3.Or_y = Dalle1.LappH : Dess_appui3.Lx = Dalle1.LappD : Dess_appui3.Ly = Dalle1.Ly
        '                    _Items1.Add(Dess_appui3)
        '                    Dess_appui3 = Nothing
        '            End Select
        '        Next
        '         Or_x = P1 :  Or_y = 0  
        '        '_Items1.Add(Dess_appui)
        'End Select
        'Private Sub Adaptation_Support_Dessin(ByRef d_Ox As Integer, ByRef d_Oy As Integer, ByRef d_Lx As Integer, ByRef d_Ly As Integer)


        ' Dim _DallCont As New List(Of Plancher)
        'Dim _Items As New List(Of Dessin_Dalle)
        'Dim _Items1 As New List(Of Dessin_Appui)

        '        Private Sub Lecture_Données(ByRef Verif As Boolean)
        '    Dim Dalle1 As New Plancher
        '    Dim Dess_dalle As New Dessin_Dalle
        '    Dim Dess_appui1 As New Dessin_Appui
        '    Dim Dess_appui2 As New Dessin_Appui
        '    Dim Dess_appui3 As New Dessin_Appui
        '    Dim Dess_appui4 As New Dessin_Appui
        '    Dim P1, P2 As Double
        '    Dim msg As String = String.Empty
        '    Dim i1 As Integer
        '    Dim j As Integer
        '    i1 = CInt(lblDalle.Text)
        '    If TxtNom.Text <> "" Then
        '        Dalle1.Nom = TxtNom.Text : Dess_dalle.Nom = TxtNom.Text
        '        EP1.SetError(TxtNom, "") ' Clear the error.
        '    Else
        '        EP1.SetError(TxtNom, "le champ n'a pas été renseigné!!")
        '        msg = msg & vbCrLf & "Nom de la dalle n°" & i1.ToString & " non renseigné." : Verif = False
        '    End If
        '    If ChkbIsostatique.Checked = True Then
        '        Dalle1.Isostatique = True
        '    Else
        '        Dalle1.Isostatique = False : Dalle1.EncastPartiel = False
        '    End If
        '    If gestionderreur(TxtLx) = True Then
        '        Dalle1.Lx = CDbl(TxtLx.Text) : Dess_dalle.Lx = CDbl(TxtLx.Text)  'Dess_appui.Lx = CDbl(TxtLx.Text)
        '    Else
        '        msg = msg & vbCrLf & "Dimension suivant x la dalle n°" & i1.ToString & " non renseignée."
        '        Verif = False
        '    End If
        '    If gestionderreur(TxtLy) = True Then
        '        Dalle1.Ly = CDbl(TxtLy.Text) : Dess_dalle.Ly = CDbl(TxtLy.Text) ' Dess_appui.Ly = CDbl(TxtLy.Text)
        '    Else
        '        msg = msg & vbCrLf & "Dimension suivant y la dalle n°" & i1.ToString & " non renseignée."
        '        Verif = False
        '    End If
        '    If gestionderreur(TxtEp) = True Then
        '        Dalle1.h = CDbl(TxtEp.Text) / 100
        '    Else
        '        msg = msg & vbCrLf & "Hauteur de la dalle n°" & i1.ToString & " non renseignée."
        '        Verif = False
        '    End If
        '    If TxtEpPredal.Text = "" Then TxtEpPredal.Text = "0"
        '    If gestionderreur(TxtEpPredal) = True And gestionderreur(txtLxPredal) = True Then
        '        Dalle1.Prefa_h = CDbl(TxtEpPredal.Text) / 100
        '        If Dalle1.Prefa_h > 0.035 Then
        '            Dalle1.Prefa = True
        '            Dalle1.Prefa_Lx = CDbl(txtLxPredal.Text)
        '        Else
        '            Dalle1.Prefa = False
        '        End If
        '    Else
        '        msg = msg & vbCrLf & "Hauteur de la prédalle n°" & i1.ToString & " non renseignée."
        '        Verif = False
        '    End If
        '    'appuis
        '    If gestionderreur(TxtL_AppH) = True Then
        '        Dalle1.LappH = CDbl(TxtL_AppH.Text) / 100 ': Dess_appui.LappH = CDbl(TxtL_AppH.Text) / 100
        '    Else
        '        msg = msg & vbCrLf & "Largeur d'appui haut de la dalle n°" & i1.ToString & " non renseignée."
        '        Verif = False
        '    End If
        '    If gestionderreur(TxtL_AppB) = True Then
        '        Dalle1.LappB = CDbl(TxtL_AppB.Text) / 100 ': Dess_appui.LappB = CDbl(TxtL_AppB.Text) / 100
        '        ' Dalle1.AppGMonolithe = False
        '    Else
        '        msg = msg & vbCrLf & "Largeur d'appui bas de la dalle n°" & i1.ToString & " non renseignée."
        '        Verif = False
        '    End If
        '    If gestionderreur(TxtL_AppD) = True Then
        '        Dalle1.LappD = CDbl(TxtL_AppD.Text) / 100 ': Dess_appui.LappD = CDbl(TxtL_AppD.Text) / 100
        '    Else
        '        msg = msg & vbCrLf & "Largeur d'appui droit de la dalle n°" & i1.ToString & " non renseignée."
        '        Verif = False
        '    End If
        '    If gestionderreur(TxtL_AppG) = True Then
        '        Dalle1.LappG = CDbl(TxtL_AppG.Text) / 100 ': Dess_appui.LappG = CDbl(TxtL_AppG.Text) / 100
        '    Else
        '        msg = msg & vbCrLf & "Largeur d'appui gauche de la dalle n°" & i1.ToString & " non renseignée."
        '        Verif = False
        '    End If
        '    If ChkbAppgMonolithe.Checked = True Then Dalle1.AppGMonolithe = True Else Dalle1.AppGMonolithe = False
        '    If ChkbAppDMonolithe.Checked = True Then Dalle1.AppDMonolithe = True Else Dalle1.AppDMonolithe = False
        '    If ChkbEncastrementPartiel.Checked = True Then Dalle1.EncastPartiel = True Else Dalle1.EncastPartiel = False
        '    If ChkbAffichePredal.Checked = True Then Aff.Affich_Predal = True Else Aff.Affich_Predal = False
        '    If Verif = False Then
        '        MessageBox.Show(msg, "Géométrie", MessageBoxButtons.OK, MessageBoxIcon.Error)
        '        Exit Sub
        '    End If
        '    'détermination du zoom
        '    Dim h As Integer
        '    Dim w As Integer
        '    h = Pb.Height : w = Pb.Width
        '    P2 = Dalle1.LappH + Dalle1.Ly + Dalle1.LappB
        '    P1 = 0
        '    Dim i As New Plancher
        '    Select Case PlanCont.Count
        '        Case 0
        '            P1 = Dalle1.LappG
        '        Case Else
        '            For Each i In PlanCont
        '                P1 = P1 + i.LappG + i.Lx
        '            Next
        '            P1 = P1 + Dalle1.LappG
        '    End Select
        '    Dess_dalle.Zoom = (w - 200) / (P1 + Dalle1.Lx)
        '    If Dess_dalle.Zoom * P2 > (h - 200) Then
        '        Dess_dalle.Zoom = (h - 200) / P2
        '    End If
        '    Dess_dalle.Or_x = P1 : Dess_dalle.Or_y = Dalle1.LappH
        '    _Items.Add(Dess_dalle)
        '    'dessin Appuis
        '    P1 = 0
        '    Select Case PlanCont.Count
        '        Case 0
        '            P1 = 0
        '            For j = 1 To 4
        '                Select Case j
        '                    Case 1 'appui haut
        '                        Dess_appui1.Zoom = Dess_dalle.Zoom
        '                        Dess_appui1.Or_x = 0 : Dess_appui1.Or_y = 0 : Dess_appui1.Lx = Dalle1.LappG + Dalle1.Lx + Dalle1.LappD : Dess_appui1.Ly = Dalle1.LappH
        '                        _Items1.Add(Dess_appui1)
        '                        Dess_appui1 = Nothing
        '                    Case 2 'appui bas
        '                        Dess_appui2.Zoom = Dess_dalle.Zoom
        '                        Dess_appui2.Or_x = 0 : Dess_appui2.Or_y = Dalle1.LappH + Dalle1.Ly : Dess_appui2.Lx = Dalle1.LappG + Dalle1.Lx + Dalle1.LappD : Dess_appui2.Ly = Dalle1.LappB
        '                        _Items1.Add(Dess_appui2)
        '                        Dess_appui2 = Nothing
        '                    Case 3 'appui gauche
        '                        Dess_appui3.Zoom = Dess_dalle.Zoom
        '                        Dess_appui3.Or_x = 0 : Dess_appui3.Or_y = Dalle1.LappH : Dess_appui3.Lx = Dalle1.LappG : Dess_appui3.Ly = Dalle1.Ly
        '                        _Items1.Add(Dess_appui3)
        '                        Dess_appui3 = Nothing
        '                    Case 4 'appui droit
        '                        Dess_appui4.Zoom = Dess_dalle.Zoom
        '                        Dess_appui4.Or_x = Dalle1.LappG + Dalle1.Lx : Dess_appui4.Or_y = Dalle1.LappH : Dess_appui4.Lx = Dalle1.LappD : Dess_appui4.Ly = Dalle1.Ly
        '                        _Items1.Add(Dess_appui4)
        '                        Dess_appui4 = Nothing
        '                End Select
        '            Next
        '        Case Else
        '            For Each i In PlanCont
        '                P1 = P1 + i.LappG + i.Lx
        '            Next
        '            P1 = P1 + Dalle1.LappG
        '            For j = 1 To 3
        '                Select Case j
        '                    Case 1 'appui haut
        '                        Dess_appui1.Zoom = Dess_dalle.Zoom
        '                        Dess_appui1.Or_x = P1 : Dess_appui1.Or_y = 0 : Dess_appui1.Lx = Dalle1.Lx + Dalle1.LappD : Dess_appui1.Ly = Dalle1.LappH
        '                        _Items1.Add(Dess_appui1)
        '                        Dess_appui1 = Nothing
        '                    Case 2 'appui bas
        '                        Dess_appui2.Zoom = Dess_dalle.Zoom
        '                        Dess_appui2.Or_x = P1 : Dess_appui2.Or_y = Dalle1.LappH + Dalle1.Ly : Dess_appui2.Lx = Dalle1.Lx + Dalle1.LappD : Dess_appui2.Ly = Dalle1.LappB
        '                        _Items1.Add(Dess_appui2)
        '                        Dess_appui2 = Nothing
        '                    Case 3 'appui droit
        '                        Dess_appui3.Zoom = Dess_dalle.Zoom
        '                        Dess_appui3.Or_x = P1 + Dalle1.Lx : Dess_appui3.Or_y = Dalle1.LappH : Dess_appui3.Lx = Dalle1.LappD : Dess_appui3.Ly = Dalle1.Ly
        '                        _Items1.Add(Dess_appui3)
        '                        Dess_appui3 = Nothing
        '                End Select
        '            Next
        '            'Dess_appui.Or_x = P1 : Dess_appui.Or_y = 0 : Dess_appui.Zoom = Dess_dalle.Zoom
        '            '_Items1.Add(Dess_appui)
        '    End Select

        '    Pb.Invalidate()
        '    'Ajout à la collection dalle
        '    PlanCont.Add(Dalle1)
        '    Dalle1 = Nothing : Dess_dalle = Nothing : i = Nothing ': Dess_appui = Nothing
        'End Sub

        'Private Sub Pb_MouseClick(sender As Object, e As MouseEventArgs) Handles Pb.MouseClick

        '    ' Apply OfType(Of String)() to the ArrayList to filter out non-string items.
        '    Dim query1 As IEnumerable(Of ICliquable) = _Items.OfType(Of ICliquable)
        '    Dim i As Dessin_Dalle
        '    For Each i In query1
        '        ' If toto = 2 Then i.Clicked()
        '        If i.Clicked(New Point(e.X, e.Y)) = True Then '
        '            My.Forms.Form2.Show()
        '            '   ... affichage de donnees....             
        '            Exit For
        '        End If

        '    Next
        '    'For Each i In _Items.OfType(ICliquable)
        '    '    If [hittest en fonction des coodonnées] Then i.Click
        '    'Next
        'End Sub
    End Sub


End Class
