﻿Imports System.Windows.Forms
Imports System.IO
Public Class frmPlancher
    Private Fichier_NotedeCalcul As String = String.Empty
    Private M(,,), Mmax(,,), Mmin(,,), m1d(,,), m2d(,,), m3d(,,), Mur(,,,), V(,,), ΔM(,) As Double 'Rdm Poutre
    Private x1MAX(,) As Integer
    ' Dim Tab_Num_Predal(,) As Integer
    Private NumTrav As Integer = 0
    Private NumPredal As Integer = 0
    Public NumTrav1 As Integer = 0
    Public NumPredal1 As Integer = 0
    Private Parcours As Integer = 0
    Dim frmdessin1 As frmDessin
    Public Niveau As Integer = 0
    Public Titre As String = String.Empty

#Region "Gestion des menus"

#Region " Gestion des menus texte"
    '-------------------> Menu fichier y compris les boutons s'y rapportant
    Private Sub ShowNewForm(ByVal sender As Object, ByVal e As EventArgs) Handles NewToolStripMenuItem.Click, btnNouveauProjet.Click
        Dim Verif As Boolean = True
        Dim filename As String = String.Empty
        Fichier_NotedeCalcul = String.Empty
        NumTrav = 0
        NumPredal = 0
        frmdessin1 = New frmDessin
        Niveau = 0
        Erase M, Mmax, Mmin, m1d, m2d, m3d, Mur, V, ΔM, x1MAX
        'Affichage des valeurs en cours
        Try
            Call Variables_generales() 'lecture variables par defaut
            filename = Directory.GetCurrentDirectory.ToString() & "\cfg_PlancherBA_EC2.ini"
            If File.Exists(filename) = False Then Verif = False
            If Verif = True Then Lecture_fichier_Ini(filename, Verif) 'Initialisation du logiciel avec les préférences de l'utilisateur
            If Verif = False Then
                Call Variables_generales() 'appel aux variables générales inscrites en dur dans le logiciel
                MessageBox.Show("Appel à la configuration par défaut", "Module démarrage", MessageBoxButtons.OK, MessageBoxIcon.Information)
            End If
        Catch exc As Exception
            MessageBox.Show("Erreur lors du chargement du logiciel:" + Environment.NewLine + "Exception: " + exc.Message, "Module général", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Call Variables_generales() 'appel aux variables générales inscrites en dur dans le logiciel
            MessageBox.Show("Appel à la configuration par défaut", "Module démarrage", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End Try
        If PlanCont.Count >= 1 Then
            'remise à zero générale
            PlanCont = New List(Of Plancher)
            Combinaisons = New List(Of Combinaison)
            Aciers = New List(Of Acier)
            bet = New Beton
            aci = New Acier
            Aff = New clsAffaire
            det_Ndc = New Detail_Ndc
        End If
        Me.Text = "Plancher en béton armé : [ aucun fichier chargé ]"
        'Pour affichage
        CType(Me.ActiveMdiChild, frmDonnees).Affichage_Données()
        CType(Me.ActiveMdiChild, frmDonnees).Affichage_Charges()
        CType(Me.ActiveMdiChild, frmDonnees).Pb1.Refresh()
    End Sub
    Private Sub OpenFile(ByVal sender As Object, ByVal e As EventArgs) Handles OpenToolStripMenuItem.Click, btnProjetExistant.Click
        Dim OpenFileDialog1 As New OpenFileDialog

        Try

            With OpenFileDialog1
                If Aff.msgData <> String.Empty Then
                    .InitialDirectory = Aff.msgData 'pour démarrer toujours sur le bon répertoire
                Else
                    .InitialDirectory = My.Computer.FileSystem.SpecialDirectories.MyDocuments
                End If
                .FileName = "" 'pour éviter tout affichage initial dans la boite de dialogue
                .CheckFileExists = True ' Vérifie que le fichier sélectionné existe. Sinon, la boîte de dialogue affiche un avertissement.
                .CheckPathExists = True ' Vérifie que le chemin sélectionné existe. Sinon, la boîte de dialogue affiche un avertissement.
                .DefaultExt = "txt" ' Obtient ou définit une extension par défaut. N'inclut pas le "." de début.
                ' Retourne le fichier référencé par un lien ? Si la valeur de retour est False, retourne simplement le fichier de liaison
                ' sélectionné. Si elle est True, retourne le fichier lié au fichier LNK.
                .DereferenceLinks = True
                .Title = "Ouvrir le projet"
                ' .InitialDirectory = Directory.GetParent(Directory.GetCurrentDirectory).ToString() & "\data"
                .FilterIndex = 1
                .Filter = "Fichiers textes (*.txt)|*.txt|Tous les fichiers (*.*)|*.*"
                .Multiselect = False
                .RestoreDirectory = True
                .ShowHelp = True ' Affiche le bouton Aide et la case à cocher Lecture seule ?
                .ShowReadOnly = False
                ' Commence avec la case à cocher Lecture seule activée ? Ceci n'est justifié que si ShowReadOnly a la valeur True.
                .ReadOnlyChecked = False
                If (.ShowDialog(Me) = System.Windows.Forms.DialogResult.OK) Then
                    If PlanCont.Count >= 1 Then
                        'remise à zero générale
                        PlanCont = New List(Of Plancher)
                        Combinaisons = New List(Of Combinaison)
                        Aciers = New List(Of Acier)
                        bet = New Beton
                        aci = New Acier
                        Aff = New clsAffaire
                        det_Ndc = New Detail_Ndc
                    End If
                    Aff.FileName = .FileName
                    Dim toto As String = Aff.FileName
                    Dim Racine As String = String.Empty
                    Dim Verif As Boolean = True
                    Call Lecture_chaine(toto, Racine, Verif)

                    If Verif = True Then
                        Call DeSerializeData(Racine, Verif)
                        Me.Text = "Plancher en béton armé : [" & toto & " ]"
                        'Pour affichage
                        CType(Me.ActiveMdiChild, frmDonnees).Affichage_Données()
                        CType(Me.ActiveMdiChild, frmDonnees).Affichage_Charges()
                        CType(Me.ActiveMdiChild, frmDonnees).Pb1.Refresh()
                    Else
                        If PlanCont.Count = 0 Then Me.Text = "Plancher en béton armé : [ aucun fichier de données ]"
                    End If
                End If
            End With
        Catch ex As Exception
            Me.Text = "Plancher en béton armé : [aucun fichier chargé ]"
            MessageBox.Show("Erreur lors de la lecture du fichier: " + Environment.NewLine + ex.Message & ex.StackTrace, "Ouverture de fichier data: " & Aff.FileName, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub
    Private Sub Lecture_chaine(ByRef toto As String, ByRef Racine As String, ByRef Verif As Boolean)
        'Traitement de la chaine de caractère pour pouvoir être lu par le logiciel
        Try
            Dim i, i1, position As Integer
            Dim tutu As String = String.Empty
            toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
            i = Len(toto)     'indique la longueur totale de la chaine
            i1 = i
            position = InStrRev(toto, "\")
            i = i - position
            tutu = toto
            i1 = i1 - i
            toto = Microsoft.VisualBasic.Right(toto, i)
            Racine = Microsoft.VisualBasic.Left(tutu, i1)
        Catch ex As Exception
            MessageBox.Show("Erreur lors de la lecture du la chaine " & toto.ToString & Environment.NewLine + ex.Message & ex.StackTrace, "Module Lecture_Chaine", MessageBoxButtons.OK, MessageBoxIcon.Asterisk, MessageBoxDefaultButton.Button1)
            Verif = False
        End Try

    End Sub
    Private Sub SaveToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles SaveToolStripMenuItem.Click
        Try
            If Aff.FileName = String.Empty Then
                Dim message, title, defaultValue As String
                message = "Validez le nom de l'affaire"   ' Set prompt.
                title = "Plancher en béton armé"   ' Set title.
                defaultValue = "Exemple 1"   ' Set default value.
                Aff.FileName = InputBox(message, title, defaultValue)
                Aff.FileName = Aff.msgData & "\" & Aff.FileName & ".txt"
            End If
            Call SerializeData()
        Catch ex As Exception
            MessageBox.Show("Erreur:" & Environment.NewLine & ex.Message & Environment.NewLine & ex.StackTrace, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1)
        End Try
    End Sub
    Private Sub SaveAsToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles SaveAsToolStripMenuItem.Click

        Try
            Dim SaveFileDialog As New SaveFileDialog
            SaveFileDialog.Title = "Enregistrer le projet sous ..."
            If Aff.msgData <> String.Empty Then
                SaveFileDialog.InitialDirectory = Aff.msgData
            Else
                SaveFileDialog.InitialDirectory = My.Computer.FileSystem.SpecialDirectories.MyDocuments
            End If
            SaveFileDialog.Filter = "Fichiers texte (*.txt)|*.txt|Tous les fichiers (*.*)|*.*"
            SaveFileDialog.FilterIndex = 1
            SaveFileDialog.RestoreDirectory = True
            SaveFileDialog.ShowDialog()
            If (SaveFileDialog.ShowDialog(Me) = DialogResult.OK) Then
                Aff.FileName = SaveFileDialog.FileName
                Call SerializeData()
            End If
        Catch ex As Exception
            MessageBox.Show("Erreur:" & Environment.NewLine & ex.Message & Environment.NewLine & ex.StackTrace, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1)
        End Try
    End Sub
    Private Sub PrintToolStripButton_Click(sender As Object, e As EventArgs) Handles btnImprimer.Click ', PrintToolStripMenuItem.Click'
        'Pour déclencher l'impression
        Try
            'Dim pd As New PrintDocument()

            PrintDialog1.Document = frmDessin.Pdoc
            If PrintDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
                frmDessin.Pdoc.Print()
            End If
            'AddHandler frmDessin.pdoc.PrintPage, AddressOf frmDessin.pdoc_PrintPage

        Catch ex As Exception
            MessageBox.Show("Erreur lors de l'impression:" & Environment.NewLine & ex.Message & Environment.NewLine & ex.StackTrace, "Impression ...", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1)
        End Try
    End Sub
    Private Sub PrintPreviewToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles btnVisualiser.Click 'PrintPreviewToolStripMenuItem.Click,

        'Pour déclencher l'impression
        Try
            'Dim pd As New PrintDocument()
            AddHandler frmDessin.Pdoc.PrintPage, AddressOf frmDessin.pdoc_PrintPage
            Dim dllg As New PrintPreviewDialog
            dllg.Document = frmDessin.Pdoc
            dllg.Document.DefaultPageSettings.Landscape = True
            dllg.ShowDialog()
        Catch ex As Exception
            MessageBox.Show("Erreur lors de la visualisation avant impression:" & Environment.NewLine & ex.Message & Environment.NewLine & ex.StackTrace, "Impression ...", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1)
        End Try

    End Sub
#Region " Configuration de l'impression"
    Private Sub PrintSetupToolStripMenuItem_Click(sender As Object, e As EventArgs) 'Handles PrintSetupToolStripMenuItem.Click

    End Sub
#End Region
    Private Sub ExitToolsStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles ExitToolStripMenuItem.Click, QuitterToolStripMenuItem.Click '
        Me.Close()
    End Sub
#End Region

#Region "Entrées de données"
    '-------------------> Entrées de données: géométrie, charges, matériaux, ferraillage, modélisation, environnement, 
    Private Sub GéométrieToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles mnuGeometrie.Click
        'code pour éviter l'affichage de plusieurs formulaires identiques
        'My.Forms.frmGeodalle.MdiParent = Me
        'My.Forms.frmGeodalle.Height = My.Forms.frmGeodalle.MdiParent.Height - 115
        'My.Forms.frmGeodalle.Width = My.Forms.frmGeodalle.MdiParent.Width - 25
        My.Forms.frmGeodalle.Close() 'pour éviter d'ouvrir plusieurs formulaires identiques
        My.Forms.frmGeodalle.Show()
        '    My.Forms.frmGeodalle.TopMost = True
    End Sub
    Private Sub ChargesToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles mnuCharge.Click
        'code pour éviter l'affichage de plusieurs formulaires identiques
        '  My.Forms.frmCharge.MdiParent = Me
        If PlanCont.Count = 0 Then
            MessageBox.Show("Vous devez d'abord renseigner la géométrie du plancher pour pouvoir accéder aux autres menus.", "Entrée des données", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Else
            Try
                'Select Case PlanCont.Item(0).modele_calcul
                '    Case 1 '2 Appuis
                My.Forms.frmCharge.Close() 'pour éviter d'ouvrir plusieurs formulaires identiques
                My.Forms.frmCharge.Show()
                '   My.Forms.frmCharge.TopMost = True
                '    Case 2
                '        My.Forms.frmCharge4appuis.Show()
                'End Select
            Catch ex As Exception
                MessageBox.Show("Affichage formulaire Charge impossible!" & Environment.NewLine & "Définitions manquantes.", "Affichage formulaire Charges", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End Try
        End If

    End Sub
    Private Sub MatériauxToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles mnuMateriaux.Click
        If PlanCont.Count = 0 Then
            MessageBox.Show("Vous devez d'abord renseigner la géométrie du plancher pour pouvoir accéder aux autres menus.", "Entrée des données", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Else
            Try
                My.Forms.frmMateriaux.Close()
                My.Forms.frmMateriaux.Show()
                ' My.Forms.frmMateriaux.TopMost = True
            Catch ex As Exception
                MessageBox.Show("Affichage formulaire Matériaux impossible!" & Environment.NewLine & "Définitions manquantes.", "Affichage formulaire Matériaux", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End Try
        End If
    End Sub
    Private Sub FerraillageToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles mnuFerraillage.Click
        If PlanCont.Count = 0 Then
            MessageBox.Show("Vous devez d'abord renseigner la géométrie du plancher pour pouvoir accéder aux autres menus.", "Entrée des données", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Else
            Try
                My.Forms.frmFerraillage.Close()
                My.Forms.frmFerraillage.Show()
            Catch ex As Exception
                MessageBox.Show("Affichage formulaire Ferraillage impossible!" & Environment.NewLine & "Définitions manquantes.", "Affichage formulaire Ferraillage", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End Try
        End If
    End Sub
    Private Sub EnvironnementToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles mnuModelisation.Click
        If PlanCont.Count = 0 Then
            MessageBox.Show("Vous devez d'abord renseigner la géométrie du plancher pour pouvoir accéder aux autres menus.", "Entrée des données", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Else
            Try
                My.Forms.frmEnvironnement.Close()
                My.Forms.frmEnvironnement.Show()
            Catch ex As Exception
                MessageBox.Show("Affichage formulaire Environnement impossible!" & Environment.NewLine & "Définitions manquantes.", "Affichage formulaire Environnement", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End Try
        End If
    End Sub
#End Region

    '_________________________________________________________________________________________________________________________________________________________________________________
    '
    '-------------------> Calculs
    Private Sub CalculToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles mnuCalcul.Click
        Dim Verif As Boolean = True
        mnuResultat.Enabled = False
        If PlanCont.Count = 0 Then Exit Sub
        'Affichage du découpage de prédalles
        If PlanCont.Item(0).Prefa = True Then
            Call Decoupage_Predalles() 'appel au module de découpage de la travée en prédalles
            If Aff.Affich_Predal = True Then
                Dim frm1 As New frmPredalDecoup
                frm1.ShowDialog()
                If frm1.Annuler = True Then Exit Sub
            End If
        End If

        Call Vérification_Cohérence_données(Verif)
        If Verif = False Then Exit Sub
        Aff.msg_Avertiss.Clear() 'remise à zéro de tous les avertissements

        '  Call Modele_Calcul_Plancher()
        '---------------------------------------------------------------------------------------------------
        'Attention: partie provisoire en attendant de voir comment alterner les différents sens de portée
        '---------------------------------------------------------------------------------------------------

        'Les valeurs de limites indiquées ci-dessous sont hypothétiques, elles seront modifiées dans le module Rdm. 
        'Ces limites arbitraires évitent de créer un avertissement dans le compilateur
        Dim NbApp As Integer 'nbre appuis
        Dim Ry(1, 1) As Double   'Réaction d'appuis
        Dim EIf(1, 1, 1) As Double 'flèche de la dalle pour toutes les combinaisons
        Dim IMmin(1, 1) As Integer '???????????????????????????????????
        Dim Miso(1, 1, 1) As Double 'moment isostatique en considérant la travée comme unique

        Dim sw As New System.IO.StringWriter
        'crée un writer de RTF avec une police par défaut
        Dim rtf As New To_Rtf.RtfAnsiTextWriter(sw, New Font(FontFamily.GenericSerif, 12, FontStyle.Regular))
        Dim rtff, Note_de_Calcul As String

        ' Dim dalle As New Plancher
        'For Each dalle In PlanCont 'provisoire
        '    If dalle.Modele <> type_modele Then
        '        MessageBox.Show("type de portée differents entre dalles! - modèle n°" & type_modele.ToString & " retenu.")
        '        dalle.Modele = type_modele : Exit For
        '    End If
        'Next
        Select Case PlanCont.Item(0).modele_calcul
            Case 1 'calcul portée sur 2 appuis
                Call Ecriture_Hypothese_Note_de_calcul(rtf)
                'calcul Rdm
                Try
                    Calcul_RdM_Poutre(M, Mmax, Mmin, m1d, m2d, m3d, Mur, x1MAX, V, ΔM, IMmin, EIf, Miso, NbApp, Ry, Verif) 'rtf,
                    If Verif = False Then
                        Me.btnImprimer.Visible = False 'outil imprimante
                        Me.btnVisualiser.Visible = False 'outil prévisualisation imprimante
                        Me.btnFerInf.Visible = False
                        Me.btnFerSup.Visible = False
                        Me.btnCalepinagePredal.Visible = False
                        Me.BtnPredal.Visible = False
                        Me.btnPredalPrecedent.Visible = False
                        Me.btnPredalSuivant.Visible = False
                    End If
                Catch ex As Exception
                    MessageBox.Show("Calcul arrêté." & Environment.NewLine & ex.Message & Environment.NewLine & ex.StackTrace, "Module Calcul RdM", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Exit Sub
                End Try
                'Calcul BA
                Try
                    Calcul_EC2_2_Appuis(Mmax, Mmin, EIf, NbApp, Ry, M, V, IMmin, Miso, m1d, m2d, m3d, Mur, x1MAX, ΔM, rtf, Verif)
                    If Verif = False Then
                        mnuResultat.Enabled = False
                        Me.btnImprimer.Visible = False 'outil imprimante
                        Me.btnVisualiser.Visible = False 'outil prévisualisation imprimante
                        Me.btnFerInf.Visible = False
                        Me.btnFerSup.Visible = False
                        Me.btnCalepinagePredal.Visible = False
                        Me.BtnPredal.Visible = False
                        Me.btnPredalPrecedent.Visible = False
                        Me.btnPredalSuivant.Visible = False
                    End If
                Catch ex As Exception
                    Me.btnImprimer.Visible = False 'outil imprimante
                    Me.btnVisualiser.Visible = False 'outil prévisualisation imprimante
                    Me.btnFerInf.Visible = False
                    Me.btnFerSup.Visible = False
                    Me.btnCalepinagePredal.Visible = False
                    Me.BtnPredal.Visible = False
                    Me.btnPredalPrecedent.Visible = False
                    Me.btnPredalSuivant.Visible = False
                    MessageBox.Show("Calcul arrêté." & Environment.NewLine & ex.Message & Environment.NewLine & ex.StackTrace, "Module Calcul EC2", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Exit Sub
                End Try

            Case 2 'calcul portée sur 4 appuis
                'Ecriture de l'entrée des données dans la note de calcul - Récupération d'une partie des variables constantes
                Call Plaque_Ecriture_Entree_Donnees(rtf)
                'Calcul Rdm - BA
                Try
                    Calcul_Lagrange_Navier(rtf) '     Calcul_RdM_Plaque()
                    calcul_EC2_4_Appuis(rtf, Verif)
                    If Verif = False Then

                    End If
                Catch ex As Exception
                    Me.btnImprimer.Visible = False 'outil imprimante
                    Me.btnVisualiser.Visible = False 'outil prévisualisation imprimante
                    Me.btnFerInf.Visible = False
                    Me.btnFerSup.Visible = False
                    Me.btnCalepinagePredal.Visible = False
                    Me.BtnPredal.Visible = False
                    Me.btnPredalPrecedent.Visible = False
                    Me.btnPredalSuivant.Visible = False
                    MessageBox.Show("Calcul arrêté." & Environment.NewLine & ex.Message & Environment.NewLine & ex.StackTrace, "Module Calcul Lagrange", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Exit Sub
                End Try
                'Calcul BA

        End Select
        'génère le RTF complet
        Note_de_Calcul = "Plancher_BA_" & Mise_en_Forme_date(CStr(DateTime.Now)) & ".rtf"
        Fichier_NotedeCalcul = Aff.msgResult & "\" & Note_de_Calcul
        rtf.Generate() : rtff = sw.ToString : File.WriteAllText(Fichier_NotedeCalcul, rtff)
        'Affichage des boutons complémentaires
        If Verif = True Then
            mnuResultat.Enabled = True

            Me.btnImprimer.Visible = True 'outil imprimante
            Me.btnVisualiser.Visible = True 'outil prévisualisation imprimante
            Me.btnFerInf.Visible = True
            Me.btnFerSup.Visible = True
            If PlanCont.Item(0).Prefa = True Then
                'gestion des affichages du menu Résultats
                PlanFerraillageHautToolStripMenuItem.Visible = False
                PlanFerraillageBasToolStripMenuItem.Visible = False
                PlanCalepinagePrédallesToolStripMenuItem.Visible = True
                PrédallesToolStripMenuItem.Visible = True
                PlanArmaturesSurPrédallesToolStripMenuItem.Visible = True
                PlanFerraillageSupérieurSurPrédallesToolStripMenuItem.Visible = True
                btnFerInf.ToolTipText = "Cliquez pour faire afficher les aciers complémentaires sur prédalles"
                btnFerSup.ToolTipText = "Cliquez pour faire afficher le plan de ferraillage supérieur sur prédalles"
                Me.btnCalepinagePredal.Visible = True
                Me.BtnPredal.Visible = True
                btnPredalPrecedent.Visible = False
                btnPredalSuivant.Visible = False
                NumTrav = 1 : NumPredal = 1

            Else
                'gestion des affichages du menu Résultats
                PlanFerraillageHautToolStripMenuItem.Visible = True
                PlanFerraillageBasToolStripMenuItem.Visible = True
                PlanCalepinagePrédallesToolStripMenuItem.Visible = False
                PrédallesToolStripMenuItem.Visible = False
                PlanArmaturesSurPrédallesToolStripMenuItem.Visible = False
                PlanFerraillageSupérieurSurPrédallesToolStripMenuItem.Visible = False
                btnFerInf.ToolTipText = "Cliquez pour faire afficher le plan de Ferraillage des armatures  Inférieures"
                btnFerSup.ToolTipText = "Cliquez pour faire afficher le plan de Ferraillage des armatures supérieures"
                Me.btnCalepinagePredal.Visible = False
                Me.BtnPredal.Visible = False
                btnPredalPrecedent.Visible = False
                btnPredalSuivant.Visible = False
            End If
            Try
                Dim test As Boolean = False
                For Each f As Form In Application.OpenForms
                    If f.Name = "frmDessin" Then test = True : Exit Sub
                Next
                If test = False Then
                    frmdessin1 = New frmDessin()
                    frmdessin1.MdiParent = Me
                    frmdessin1.WindowState = FormWindowState.Maximized
                End If
                If PlanCont.Item(0).Prefa = True Then
                    Niveau = 3 ' frmdessin1.Affichage_Calepinage_Predalle()
                Else
                    'Programme identique pour affichage aciers inférieurs en barres HA ou en TS
                    'frmdessin1.Affichage_Ferraillage_Inferieur()
                    Niveau = 1
                End If
                frmdessin1.Show()
            Catch ex As Exception
                MessageBox.Show("Problème affichage support: " + Environment.NewLine + ex.Message & ex.StackTrace, "appel au module Dessin", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try
        End If

        If Aff.msg_Avertiss.Count = 0 Then
            MessageBox.Show("Calcul terminé !" & Environment.NewLine & Environment.NewLine & "Aucun avertissement.", "Plancher BA EC2", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Else
            MessageBox.Show("Calcul terminé !" & Environment.NewLine & "Attention: voir les avertissements.", "Plancher BA EC2", MessageBoxButtons.OK, MessageBoxIcon.Warning)
        End If
    End Sub
    '_________________________________________________________________________________________________________________________________________________________________________________
    '
    '-------------------> Sorties des résultats
    Private Sub NoteDeCalculToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles NoteDeCalculToolStripMenuItem.Click
        Try
            Select Case Aff.Editeur
                Case 1 'Editeur Interne
                    Dim frm1 As New Editeur.frmEdit
                    frm1.Affichage_frmEdit(Fichier_NotedeCalcul)
                Case 2 'éditeur WordPad
                    Dim KEY As Microsoft.Win32.RegistryKey = My.Computer.Registry.ClassesRoot.OpenSubKey("wordpad.exe")
                    If KEY Is Nothing Then
                        MessageBox.Show("WordPad inaccessible!" & Environment.NewLine & "Impossible d'afficher la note de calcul", Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                        Exit Sub
                    End If
                    Dim SousDossier1 As String = My.Application.Info.DirectoryPath 'répertoire dans lequel se trouve le logiciel Poutre BA
                    Dim startInfo As New ProcessStartInfo("wordpad.exe") '("word.exe")
                    startInfo.WindowStyle = ProcessWindowStyle.Normal
                    startInfo.Arguments = Fichier_NotedeCalcul
                    Process.Start(startInfo.Arguments)
                Case 3 'éditeur Word
                    Dim KEY As Microsoft.Win32.RegistryKey = My.Computer.Registry.ClassesRoot.OpenSubKey("word.application")
                    If KEY Is Nothing Then
                        MessageBox.Show("Word inaccessible!" & Environment.NewLine & "Impossible d'afficher la note de calcul", Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                        Exit Sub
                    End If
                    Dim SousDossier1 As String = My.Application.Info.DirectoryPath 'répertoire dans lequel se trouve le logiciel Poutre BA
                    Dim startInfo As New ProcessStartInfo("word.exe") '("word.exe")
                    startInfo.WindowStyle = ProcessWindowStyle.Normal
                    startInfo.Arguments = Fichier_NotedeCalcul
                    Process.Start(startInfo.Arguments)
            End Select
        Catch ex As Exception
            Dim msg As String
            msg = "Impossible d'afficher la note de calcul" & Environment.NewLine + "Exception: " + ex.Message & ex.StackTrace
            MessageBox.Show(msg, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub
    Private Sub CourbesDesMomentsToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles CourbesDesMomentsToolStripMenuItem.Click
        Try
            Me.btnImprimer.Visible = True 'outil imprimante
            Me.btnVisualiser.Visible = True 'outil prévisualisation imprimante
            Dim frmcourbe1 As FrmCourbe
            'Affichage_Effort = 1
            frmcourbe1 = New FrmCourbe(1, M, Mmax, Mmin, m1d, m2d, m3d, Mur, x1MAX, ΔM)
            frmcourbe1.MdiParent = Me
            frmcourbe1.Show()
        Catch ex As Exception
            Me.btnImprimer.Visible = False 'outil imprimante
            Me.btnVisualiser.Visible = False 'outil prévisualisation imprimante
            MessageBox.Show("Erreur lors de l'affichage des courbes de Moments " + Environment.NewLine + ex.Message & ex.StackTrace, "appel au module Dessin", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub
    Private Sub PlanFerraillageHautToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles PlanFerraillageHautToolStripMenuItem.Click, btnFerSup.Click
        Try

            Niveau = 2 'frmdessin1.Affichage_Ferraillage_Superieur() - Identique que ce soit des prédalles ou des planchers coulés en place
            Dim test As Boolean = False
            For Each f As Form In Application.OpenForms
                If f.Name = "frmDessin" Then test = True
            Next
            If test = True Then
                frmdessin1.Refresh()
            Else
                frmdessin1 = New frmDessin()
                frmdessin1.MdiParent = Me
                frmdessin1.WindowState = FormWindowState.Maximized
                frmdessin1.Show()
            End If
        Catch ex As Exception
            Me.btnImprimer.Visible = False 'outil imprimante
            Me.btnVisualiser.Visible = False 'outil prévisualisation imprimante
            Me.btnFerInf.Visible = False : Me.btnFerSup.Visible = False
            Me.BtnPredal.Visible = False
            Me.btnPredalPrecedent.Visible = False : Me.btnPredalSuivant.Visible = False
            MessageBox.Show("Erreur lors de l'affichage du dessin de coffrage ferraillage " + Environment.NewLine + ex.Message & ex.StackTrace, "appel au module Dessin", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
    Private Sub PlanFerraillageBasToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles PlanFerraillageBasToolStripMenuItem.Click, btnFerInf.Click
        Try
            If PlanCont.Item(0).Prefa = True Then
                Niveau = 5 'frmdessin1.Affichage_Ferraillage_Inferieur_complemantaire_predalle()
            Else
                Niveau = 1 'frmdessin1.Affichage_Ferraillage_Inferieur()
            End If
            Dim test As Boolean = False
            For Each f As Form In Application.OpenForms
                If f.Name = "frmDessin" Then test = True
            Next
            If test = True Then
                frmdessin1.Refresh()
            Else
                frmdessin1 = New frmDessin()
                frmdessin1.MdiParent = Me
                frmdessin1.WindowState = FormWindowState.Maximized
                frmdessin1.Show()
            End If
        Catch ex As Exception
            Me.btnImprimer.Visible = False 'outil imprimante
            Me.btnVisualiser.Visible = False 'outil prévisualisation imprimante
            Me.btnFerInf.Visible = False : Me.btnFerSup.Visible = False
            Me.BtnPredal.Visible = False
            Me.btnPredalPrecedent.Visible = False : Me.btnPredalSuivant.Visible = False
            MessageBox.Show("Erreur lors de l'affichage du dessin de coffrage ferraillage " + Environment.NewLine + ex.Message & ex.StackTrace, "appel au module Dessin", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
    Private Sub PlanCalepinagePrédallesToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles PlanCalepinagePrédallesToolStripMenuItem.Click, btnCalepinagePredal.Click
        Try
            Niveau = 3 'frmdessin1.Affichage_Calepinage_Predalle() '
            btnPredalPrecedent.Visible = False : btnPredalSuivant.Visible = False
            Dim test As Boolean = False
            For Each f As Form In Application.OpenForms
                If f.Name = "frmDessin" Then test = True
            Next
            If test = True Then
                frmdessin1.Refresh()
            Else
                frmdessin1 = New frmDessin()
                frmdessin1.MdiParent = Me
                frmdessin1.WindowState = FormWindowState.Maximized
                frmdessin1.Show()
            End If
        Catch ex As Exception
            MessageBox.Show("Erreur pour l'affichage du dessin de calepinage " + Environment.NewLine + ex.Message & ex.StackTrace, "appel au module Dessin", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
    Private Sub PrédallesToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles PrédallesToolStripMenuItem.Click, BtnPredal.Click
        Try
            Dim i As Integer
            Titre = String.Empty
            NumPredal = 1 : NumTrav = 1 : NumPredal1 = 1 : NumTrav1 = 1
            Call Parcours_Predalle(True)
            With PlanCont.Item(NumTrav1 - 1)
                For i = 1 To .Prefa_nb
                    If i = NumPredal1 Then Continue For
                    If .Prefa_modele.Item(i - 1) = .Prefa_modele.Item(NumPredal1 - 1) Then Titre = Titre & " - " & (NumTrav1 * 10 + i).ToString("#")
                Next
            End With
            If Titre = String.Empty Then
                Titre = "Prédalle n°" & (NumTrav1 * 10 + NumPredal1).ToString("#")
            Else
                Titre = "Prédalles n°" & (NumTrav1 * 10 + NumPredal1).ToString("#") & Titre
            End If
            btnPredalPrecedent.Visible = False : btnPredalSuivant.Visible = True
            Niveau = 4 ' frmdessin1.Affichage_Predalle(NumTrav, NumPredal, msg)
            Dim test As Boolean = False
            For Each f As Form In Application.OpenForms
                If f.Name = "frmDessin" Then test = True
            Next
            If test = True Then
                frmdessin1.Refresh()
            Else
                frmdessin1 = New frmDessin()
                frmdessin1.MdiParent = Me
                frmdessin1.WindowState = FormWindowState.Maximized
                frmdessin1.Show()
            End If
        Catch ex As Exception
            MessageBox.Show("Erreur pour l'affichage du dessin de prédalle " + Environment.NewLine + ex.Message & ex.StackTrace, "appel au module Dessin", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
    '''<summary>Détermination du sens suivant ou précédent de la prédalle</summary>
    ''' <param name="sens">true = sens montant / False = sens descendant</param>
    Private Sub Parcours_Predalle(ByVal Sens As Boolean)
        Dim i, j As Integer
        Dim Modele_identique As Boolean = True

        'sens montant
        If Sens = True Then
            NumPredal = NumPredal + Parcours
            If NumPredal > PlanCont.Item(NumTrav - 1).Prefa_nb Then
                NumPredal = 1 : NumTrav += 1
                If NumTrav > PlanCont.Count Then NumTrav = 1 'affichage circulaire
            End If
            If NumTrav1 <> NumTrav Then NumTrav1 = NumTrav
            With PlanCont.Item(NumTrav - 1)
                For i = NumPredal + 1 To .Prefa_nb
                    If .Prefa_modele.Item(i - 1) = .Prefa_modele.Item(NumPredal - 1) Then
                        Continue For 'on passe à la prédalle suivante
                    Else
                        'on vérifie qu'elle n'a pas été affiché dans les prédalles précédentes
                        Modele_identique = False
                        For j = i - 1 To 1 Step -1
                            If .Prefa_modele.Item(j - 1) = .Prefa_modele.Item(i - 1) Then Modele_identique = True : Exit For
                        Next
                        If Modele_identique = False Then
                            NumPredal1 = NumPredal : NumPredal = i : Exit For 'nouveau modèle de prédalle trouvé   
                        Else
                            Continue For 'modèle de prédalle identique trouvé, on passe à la prédalle suivante
                        End If
                    End If
                Next
                If i > .Prefa_nb Then
                    NumPredal1 = NumPredal : NumPredal = 1 '    
                    NumTrav1 = NumTrav : NumTrav = NumTrav + 1 'Passage à la prédalle 1 de la travée suivante  
                End If
            End With
            If NumTrav > PlanCont.Count Then NumTrav = 1 'affichage circulaire
            Parcours = 0
            Exit Sub 'on revient au prog appelant
        End If
        'sens descendant
        If Sens = False Then
            Parcours = 1
            NumTrav = NumTrav1 : NumPredal = NumPredal1
            With PlanCont.Item(NumTrav - 1)
                For i = NumPredal - 1 To 1 Step -1
                    If .Prefa_modele.Item(i - 1) = .Prefa_modele.Item(NumPredal - 1) Then
                        Continue For 'prédalle identique, on passe à la prédalle précédente
                    Else
                        NumPredal = i : NumPredal1 = NumPredal : Exit For '
                    End If
                Next
                If i = 0 Then
                    'cas ou toutes les prédalles précédentes sont identiques
                    If NumPredal > 1 Then NumPredal -= 1 Else NumPredal = 1
                    NumTrav -= 1
                    If NumTrav = 0 Then NumTrav = 1
                    NumTrav1 = NumTrav : NumPredal1 = NumPredal
                End If

            End With
        End If
    End Sub
    Private Sub PlanArmaturesSurPrédallesToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles PlanArmaturesSurPrédallesToolStripMenuItem.Click
        Try

            Niveau = 5 'frmdessin1.Affichage_Ferraillage_Inferieur_complemantaire_predalle()
            Dim test As Boolean = False
            For Each f As Form In Application.OpenForms
                If f.Name = "frmDessin" Then test = True
            Next
            If test = True Then
                frmdessin1.Refresh()
            Else
                frmdessin1 = New frmDessin()
                frmdessin1.MdiParent = Me
                frmdessin1.WindowState = FormWindowState.Maximized
                frmdessin1.Show()
            End If
        Catch ex As Exception
            Me.btnImprimer.Visible = False 'outil imprimante
            Me.btnVisualiser.Visible = False 'outil prévisualisation imprimante
            Me.btnFerInf.Visible = False : Me.btnFerSup.Visible = False
            Me.BtnPredal.Visible = False
            Me.btnPredalPrecedent.Visible = False : Me.btnPredalSuivant.Visible = False
            MessageBox.Show("Erreur lors de l'affichage du dessin de coffrage ferraillage " + Environment.NewLine + ex.Message & ex.StackTrace, "appel au module Dessin", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
    Private Sub PlanFerraillageSupérieurSurPrédallesToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles PlanFerraillageSupérieurSurPrédallesToolStripMenuItem.Click
        Try

            Niveau = 2 'frmdessin1.Affichage_Ferraillage_Superieur()  ' niveau = 2
            Dim test As Boolean = False
            For Each f As Form In Application.OpenForms
                If f.Name = "frmDessin" Then test = True
            Next
            If test = True Then
                frmdessin1.Refresh()
            Else
                frmdessin1 = New frmDessin()
                frmdessin1.MdiParent = Me
                frmdessin1.WindowState = FormWindowState.Maximized
                frmdessin1.Show()
            End If
        Catch ex As Exception
            Me.btnImprimer.Visible = False 'outil imprimante
            Me.btnVisualiser.Visible = False 'outil prévisualisation imprimante
            Me.btnFerInf.Visible = False : Me.btnFerSup.Visible = False
            Me.BtnPredal.Visible = False
            Me.btnPredalPrecedent.Visible = False : Me.btnPredalSuivant.Visible = False
            MessageBox.Show("Erreur lors de l'affichage du dessin de coffrage ferraillage " + Environment.NewLine + ex.Message & ex.StackTrace, "appel au module Dessin", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End Try
        Me.Refresh()
    End Sub
    Private Sub CalculatriceToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles mnu1CalculatriceW.Click, BtnCalcW.Click
        Try
            Dim startInfo As New ProcessStartInfo("calc.exe")
            Process.Start(startInfo)
            startInfo.WindowStyle = ProcessWindowStyle.Normal
        Catch ex As Exception
            MessageBox.Show("Problème d'accés à la calculatrice" & Environment.NewLine & "Exception: " + ex.Message, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub
    Private Sub Comb_BarHA_Click(sender As Object, e As EventArgs) Handles mnu1Comb_BarHA.Click
        Try
            Dim KEY As Microsoft.Win32.RegistryKey = My.Computer.Registry.ClassesRoot.OpenSubKey("acroPDF.PDF")
            If KEY Is Nothing Then
                MessageBox.Show("Impossible d'accèder à Acrobat Reader!" & Environment.NewLine & "Lecture fiche combinaisons HA abandonnée.", Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Exit Sub
            End If
            Dim startInfo As New ProcessStartInfo("AcroRd32.exe")
            startInfo.WindowStyle = ProcessWindowStyle.Normal
            startInfo.Arguments = "BA_combinaisons_de_sections_armatures_HA.pdf"
            Process.Start(startInfo)
        Catch ex As Exception
            MessageBox.Show("Problème d'accés au logiciel Adobe Reader" & Environment.NewLine & "Exception: " + ex.Message, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub
    Private Sub Car_TS_ADETS_Click(sender As Object, e As EventArgs) Handles mnu1Car_TS_ADETS.Click
        Dim PDFExe As String = String.Empty
        PDFExe = CType(Microsoft.Win32.Registry.GetValue("HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.pdf\OpenWithList", "a", ""), String)   'récupère le reader par défaut

        'Dim FichierPDF = "C:\Users\Moi\Desktop\test.pdf"
        'Dim Exec As System.Diagnostics.Process
        'Exec = System.Diagnostics.Process.Start(PDFExe, "/p " & FichierPDF)
        'Exec.WaitForExit(10000)     'Attend 10s la fin du process (reader) &#61664; A adapter
        'Try
        '    Exec.Kill()
        'Catch
        'End Try


        Try
            Dim KEY As Microsoft.Win32.RegistryKey = My.Computer.Registry.ClassesRoot.OpenSubKey("acroPDF.PDF")
            If KEY Is Nothing Then
                MessageBox.Show("Impossible d'accèder à Acrobat Reader!" & Environment.NewLine & "Lecture fiche treillis abandonnée.", Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Exit Sub
            End If
            Dim startInfo As New ProcessStartInfo("AcroRd32.exe")
            startInfo.WindowStyle = ProcessWindowStyle.Normal
            startInfo.Arguments = "Treillis.pdf"
            Process.Start(startInfo)
        Catch ex As Exception
            MessageBox.Show("Problème d'accés au logiciel Adobe Reader" & Environment.NewLine & "Exception: " + ex.Message, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub
    Private Sub Calculette_BarHA_TS_Click(sender As Object, e As EventArgs) Handles mnu1Calculette_BarHA_TS.Click
        Try
            Dim frm1 As New Section_Acier.frmSectionAcier
            frm1.Show()
        Catch ex As Exception
            Dim msg As String
            msg = "Impossible d'afficher la calculette de section d'armatures!" & Environment.NewLine + "Exception: " + ex.Message & ex.StackTrace
            MessageBox.Show(msg, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try

    End Sub
    Private Sub ConfigurationDuLogicielToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ConfigurationDuLogicielToolStripMenuItem.Click
        Try
            My.Forms.frmConfig.Show()
        Catch ex As Exception
            MessageBox.Show("Affichage formulaire Configuration Logiciel impossible!" + Environment.NewLine + ex.Message & ex.StackTrace, "Affichage Configuration Logiciel", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub
    Private Sub Config_Ndc_ToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles Config_Ndc_ToolStripMenuItem.Click
        Try
            My.Forms.frmDetailNdc.Show()
            My.Forms.frmDetailNdc.TopMost = True
        Catch ex As Exception
            MessageBox.Show("Affichage formulaire Configuration de la Note de Calcul impossible!" + Environment.NewLine + ex.Message & ex.StackTrace, "Affichage Configuration Note de calcul", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub
    Private Sub MnuConfiguration_Click(sender As Object, e As EventArgs) Handles MnuConfiguration.Click
        Try
            My.Forms.frmConfig.Close()
            My.Forms.frmConfig.Show()

        Catch ex As Exception
            MessageBox.Show("Affichage formulaire Configuration impossible!" & Environment.NewLine & "Erreur:" & Environment.NewLine & ex.ToString, "Affichage formulaire Configuration", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub
    Private Sub Manuel_Click(sender As Object, e As EventArgs) Handles Manuel.Click, btnAide.Click
        Try
            Dim KEY As Microsoft.Win32.RegistryKey = My.Computer.Registry.ClassesRoot.OpenSubKey("acroPDF.PDF")
            If KEY Is Nothing Then
                MessageBox.Show("Impossible d'accèder à Acrobat Reader!" & Environment.NewLine & "Lecture manuel d'utilisation abandonnée.", Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Exit Sub
            End If
            Dim SousDossier1 As String = My.Application.Info.DirectoryPath 'répertoire dans lequel se trouve le logiciel Poutre BA
            Dim startInfo As New ProcessStartInfo("AcroRd32.exe") '("word.exe")
            startInfo.WindowStyle = ProcessWindowStyle.Normal
            startInfo.Arguments = SousDossier1 & "\Aide_Plancher_BA.pdf"
            Process.Start(startInfo.Arguments)
        Catch ex As Exception
            Dim msg As String = String.Empty
            msg = "Impossible d'afficher le manuel d'utilisation" & Environment.NewLine & "Exception: " + ex.Message
            MessageBox.Show(msg, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub
    Private Sub AboutToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles AboutToolStripMenuItem.Click
        Try
            My.Forms.frmSplash.Close()
            'Dim ADUpdateAsync As Deployment.Application.ApplicationDeployment
            'ADUpdateAsync = Deployment.Application.ApplicationDeployment.CurrentDeployment
            'Dim version As String = ADUpdateAsync.CurrentVersion.ToString()
            My.Forms.frmSplash.Width = 432 : My.Forms.frmSplash.Height = 277
            My.Forms.frmSplash.StartPosition = FormStartPosition.CenterScreen
            'My.Forms.frmSplash.LblVersion.Text = "Version " & Version
            My.Forms.frmSplash.Show()
        Catch ex As Exception
            MessageBox.Show("Affichage Version logicielle impossible!" & Environment.NewLine & "Erreur:" & Environment.NewLine & ex.ToString, "Affichage version logicielle", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            My.Forms.frmSplash.Width = 432 : My.Forms.frmSplash.Height = 277
            My.Forms.frmSplash.StartPosition = FormStartPosition.CenterScreen
            My.Forms.frmSplash.LblVersion.Text = "Version non identifiable"
            My.Forms.frmSplash.Show()
        End Try

    End Sub


#Region "A conserver au cas ou"
    Private Sub CutToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs)
        ' Utilisez My.Computer.Clipboard pour insérer les images ou le texte sélectionné dans le Presse-papiers
    End Sub

    Private Sub CopyToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs)
        ' Utilisez My.Computer.Clipboard pour insérer les images ou le texte sélectionné dans le Presse-papiers
    End Sub

    Private Sub PasteToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs)
        'Utilisez My.Computer.Clipboard.GetText() ou My.Computer.Clipboard.GetData pour extraire les informations du Presse-papiers.
    End Sub

    Private Sub ToolBarToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles ToolBarToolStripMenuItem.Click
        Me.ToolStrip.Visible = Me.ToolBarToolStripMenuItem.Checked
    End Sub



    Private Sub StatusBarToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles StatusBarToolStripMenuItem.Click
        Me.StatusStrip.Visible = Me.StatusBarToolStripMenuItem.Checked
    End Sub

    Private Sub CascadeToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.LayoutMdi(MdiLayout.Cascade)
    End Sub

    Private Sub TileVerticalToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.LayoutMdi(MdiLayout.TileVertical)
    End Sub

    Private Sub TileHorizontalToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.LayoutMdi(MdiLayout.TileHorizontal)
    End Sub



    Private Sub ArrangeIconsToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.LayoutMdi(MdiLayout.ArrangeIcons)
    End Sub



    Private Sub CloseAllToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs)
        ' Fermez tous les formulaires enfants du parent.
        For Each ChildForm As Form In Me.MdiChildren
            ChildForm.Close()
        Next
    End Sub

    Private m_ChildFormNumber As Integer
#End Region
#End Region

#Region "Gestion des boutons de la barre de taches"
    Private Sub BtnPredal_Click(sender As Object, e As EventArgs)
        Dim i As Integer
        Titre = String.Empty
        NumPredal = 1 : NumTrav = 1 : NumPredal1 = 1 : NumTrav1 = 1
        Call Parcours_Predalle(True)
        With PlanCont.Item(NumTrav1 - 1)
            For i = 1 To .Prefa_nb
                If i = NumPredal1 Then Continue For
                If .Prefa_modele.Item(i - 1) = .Prefa_modele.Item(NumPredal1 - 1) Then Titre = Titre & " - " & (NumTrav1 * 10 + i).ToString("#")
            Next
        End With
        If Titre = String.Empty Then
            Titre = "Prédalle n°" & (NumTrav1 * 10 + NumPredal1).ToString("#")
        Else
            Titre = "Prédalles n°" & (NumTrav1 * 10 + NumPredal1).ToString("#") & Titre
        End If

        ' frmdessin1.Affichage_Predalle(NumTrav, NumPredal, msg)
        btnPredalPrecedent.Visible = False : btnPredalSuivant.Visible = True
        Niveau = 4
        Me.Refresh()
    End Sub
    Private Sub PredalPrecedent_Click(sender As Object, e As EventArgs) Handles btnPredalPrecedent.Click
        Dim i As Integer
        Titre = String.Empty
        Call Parcours_Predalle(False)
        With PlanCont.Item(NumTrav - 1)
            For i = 1 To .Prefa_nb
                If i = NumPredal1 Then Continue For
                If .Prefa_modele.Item(i - 1) = .Prefa_modele.Item(NumPredal1 - 1) Then Titre = Titre & " - " & (NumTrav1 * 10 + i).ToString("#")
            Next
        End With
        If Titre = String.Empty Then
            Titre = "Prédalle n°" & (NumTrav1 * 10 + NumPredal1).ToString("#")
        Else
            Titre = "Prédalles n°" & (NumTrav1 * 10 + NumPredal1).ToString("#") & Titre
        End If
        If NumTrav1 = 1 And NumPredal1 = 1 Then btnPredalPrecedent.Visible = False
        ' frmdessin1.Affichage_Predalle(NumTrav, NumPredal, msg)
        Niveau = 4
        Me.Refresh()
    End Sub

    Private Sub PredalSuivant_Click(sender As Object, e As EventArgs) Handles btnPredalSuivant.Click
        Dim i As Integer
        Titre = String.Empty
        Call Parcours_Predalle(True)
        With PlanCont.Item(NumTrav1 - 1)
            For i = 1 To .Prefa_nb
                If i = NumPredal1 Then Continue For
                If .Prefa_modele.Item(i - 1) = .Prefa_modele.Item(NumPredal1 - 1) Then Titre = Titre & " - " & (NumTrav1 * 10 + i).ToString("#")
            Next
        End With
        If Titre = String.Empty Then
            Titre = "Prédalle n°" & (NumTrav1 * 10 + NumPredal1).ToString("#")
        Else
            Titre = "Prédalles n°" & (NumTrav1 * 10 + NumPredal1).ToString("#") & Titre
        End If
        btnPredalPrecedent.Visible = True
        Niveau = 4 'frmdessin1.Affichage_Predalle(NumTrav, NumPredal, msg)
        Me.Refresh()
        ' NumPredal += 1 'augmentation d'une unité
    End Sub
    Private Sub btnCalepinagePredal_Click(sender As Object, e As EventArgs)
        'Dim test As Boolean = False
        'For Each f As Form In Application.OpenForms
        '    If f.Name = "frmDessin" Then test = True : Exit Sub
        'Next
        'If test = False Then
        '    frmdessin1 = New frmDessin()
        '    frmdessin1.MdiParent = Me
        '    frmdessin1.WindowState = FormWindowState.Maximized
        '    '  frmdessin1.Affichage_Calepinage_Predalle() ' 
        '    Niveau = 3
        '    Me.Show()
        'Else
        ' frmdessin1.Affichage_Calepinage_Predalle() ' 
        btnPredalPrecedent.Visible = False : btnPredalSuivant.Visible = False
        Niveau = 3
        Me.Refresh()
        'End If
    End Sub

#End Region

    Private Sub Vérification_Cohérence_données(ByRef Verif As Boolean)
        Dim msg As String = ""
        'Dim L_min, L_Max As Double
        Dim nb_avert As Integer 'i,j,k,
        'verification géométrie
        'toute la vérification de la cohérence des données de géométrie ont été faites dans le formulaire géométrie. Il n'y a donc pas de répétition ici, à ce niveau.
        'le seul test restant valable est de vérifier qu'un calcul ne soit lancé alors qu'aucune poutre n'a été renseignée!
        'Après je ne vérifie pas que le projeteur n'a pas bidouillé le fichier data mais quand on est con ....
        '
        'Charges - Combinaisons
        Aff.Combinaison_ELU_ELS() 'détermination du nombre de combinaisons pour chaque Etat Limite
        If Aff.ELU = 0 Then
            msg = msg & "Aucune combinaison à l'Etat Limite Ultime n'a été renseignée. Pas de calcul possible" & Environment.NewLine
            Verif = False
            nb_avert = nb_avert + 1
        End If
        '
        'Ferraillage
        For Each dalle As Plancher In PlanCont
            If dalle.Type_Acier_Travée = 0 Then
                msg = msg & "Le type d'acier (TS ou barres HA) n'a pas été renseigné!" & Environment.NewLine
                Verif = False
                nb_avert = nb_avert + 1
            End If
            If dalle.Type_Acier_Travée = 2 Then 'pour barres HA uniquement
                If dalle.Choix_Esp = 0 Then
                    msg = msg & "Le type d'espacement maximun entre barres n'a pas été renseigné." & Environment.NewLine
                    Verif = False
                    nb_avert = nb_avert + 1
                End If
                If dalle.Choix_Esp = 3 And dalle.EspMax < 0.1 Then
                    msg = msg & "Aucune valeur numérique n'a été renseignée pour ce type d'espacement maximun entre barres." & Environment.NewLine
                    Verif = False
                    nb_avert = nb_avert + 1
                End If
                If dalle.Espmin < 0.049 Then
                    msg = msg & "Aucune valeur numérique n'a été renseignée pour l'espacement minimum entre barres." & Environment.NewLine
                    Verif = False
                    nb_avert = nb_avert + 1
                End If
            End If
            If nb_avert >= 1 Then
                msg = msg & "Vous devez revenir dans le Formulaire Ferraillage pour renseigner cette donnée." & Environment.NewLine
                Exit For 'Pour éviter de répéter le même avertissement pour chaque dalle
            End If
        Next


        'If Aff.Redistrib_limit = True Then
        '    If PoutCont.Item(0).LappG < 0.05 Then
        '        j = 3 : L_min = PoutCont.Item(1).L : L_Max = PoutCont.Item(1).L
        '    Else
        '        j = 2 : L_min = PoutCont.Item(0).L : L_Max = PoutCont.Item(0).L
        '    End If
        '    If PoutCont.Item(PoutCont.Count - 1).LappD < 0.05 Then
        '        k = PoutCont.Count - 1
        '    Else
        '        k = PoutCont.Count
        '    End If
        '    For i = j To k
        '        With PoutCont.Item(i - 1)
        '            If .L < L_min Then L_min = .L
        '            If .L > L_Max Then L_Max = .L
        '        End With
        '    Next
        '    If L_Max > 2 * L_min Then
        '        msg = msg & "Rapport entre portées supérieur à 2: redistribution limitée non autorisée" &  Environment.NewLine
        '        nb_avert = nb_avert + 1
        '    End If
        'End If
        If nb_avert >= 1 Then
            MessageBox.Show(msg, "Vérification cohérence données", MessageBoxButtons.OK, MessageBoxIcon.Warning)
        End If
        If Verif = False Then
            msg = msg & Environment.NewLine & "Veuillez corriger les données pour continuer le calcul."
        End If
    End Sub

    Private Sub FrmPlancher_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim Verif As Boolean = True
        'barre d'état invisible - A voir plus tard si on veut en faire quelque chose
        Me.StatusStrip.Visible = False
        Me.btnImprimer.Visible = False 'outil imprimante
        Me.btnVisualiser.Visible = False 'outil prévisualisation imprimante
        Me.btnCalepinagePredal.Visible = False
        Me.btnFerInf.Visible = False
        Me.btnFerSup.Visible = False
        Me.BtnPredal.Visible = False
        Me.btnPredalPrecedent.Visible = False
        Me.btnPredalSuivant.Visible = False
        mnuResultat.Enabled = False
        Dim Verif1 As Boolean = True
        Dim filename As String = String.Empty
        'Lecteur_Pdf = "acroRd32.exe" 'Acrobat reader provisoire
        'MnuNoteDeCalcul.Enabled = False : MnuGrapDef.Enabled = False

        Try
            Me.Text = "Plancher en béton armé : [aucun fichier chargé ]"
            '--> création des répertoires data et note de calcul si n'existe pas
            If My.Computer.FileSystem.DirectoryExists(Directory.GetCurrentDirectory.ToString() & "\Data") = False Then
                My.Computer.FileSystem.CreateDirectory(Directory.GetCurrentDirectory.ToString() & "\Data")
            End If
            If My.Computer.FileSystem.DirectoryExists(Directory.GetCurrentDirectory.ToString() & "\Note_de_calcul") = False Then
                My.Computer.FileSystem.CreateDirectory(Directory.GetCurrentDirectory.ToString() & "\Note_de_calcul")
            End If
            '--> création des répertoires Aide si n'existe pas
            'ce qui est le cas lors de l'installation du logiciel
            If My.Computer.FileSystem.DirectoryExists(Directory.GetCurrentDirectory.ToString() & "\Aide") = False Then
                Try
                    '  Dim startPath As String = Directory.GetCurrentDirectory.ToString() ' & ".\start"
                    Dim zipPath As String = Directory.GetCurrentDirectory.ToString() & "\Aide.zip"
                    My.Computer.FileSystem.CreateDirectory(Directory.GetCurrentDirectory.ToString() & "\Aide")
                    Dim extractPath As String = Directory.GetCurrentDirectory.ToString() & "\Aide"
                    '   System.IO.Compression.ZipFile.CreateFromDirectory(startPath, zipPath)
                    System.IO.Compression.ZipFile.ExtractToDirectory(zipPath, extractPath)

                Catch ex As Exception
                    MessageBox.Show("Problème de décompression du fichier Aide.zip" & Environment.NewLine & "Exception: " + ex.Message, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                End Try
            End If

            '--> création du fichier ini si n'existe pas
            filename = Directory.GetCurrentDirectory.ToString() & "\cfg_PlancherBA_EC2.ini"
            If File.Exists(filename) = False Then
                Call Variables_generales() 'appel au modules contenant les variables par defaut
                frmConfig.Ecriture_fichier_Cfg_Ini(filename) 'creation du fichier lors de l'installation du logiciel
            Else

                'Affichage des valeurs en cours
                Try
                    Call Variables_generales() 'lecture variables par defaut
                    Lecture_fichier_Ini(filename, Verif) 'Initialisation du logiciel avec les préférences de l'utilisateur
                    If Verif = False Then
                        Call Variables_generales() 'appel aux variables générales inscrites en dur dans le logiciel
                        MessageBox.Show("Appel à la configuration par défaut", "Module démarrage", MessageBoxButtons.OK, MessageBoxIcon.Information)
                    End If
                Catch exc As Exception
                    MessageBox.Show("Erreur lors du chargement du logiciel:" + Environment.NewLine + "Exception: " + exc.Message, "Module général", MessageBoxButtons.OK, MessageBoxIcon.Information)
                    Call Variables_generales() 'appel aux variables générales inscrites en dur dans le logiciel
                    MessageBox.Show("Appel à la configuration par défaut", "Module démarrage", MessageBoxButtons.OK, MessageBoxIcon.Information)
                End Try
            End If

            ''If i_data = 1 Then
            ''    msgData = "C:\Users\fux\Documents\Visual Studio 2010\Dallage\Dallage\bin\Debug\Data"
            ''End If
            ''If i_result = 1 Then
            ''    msgResult = "C:\Users\fux\Documents\Visual Studio 2010\Dallage\Dallage\bin"
            ''End If
            Dim frm1 As frmDonnees
            frm1 = New frmDonnees
            frm1.MdiParent = Me
            'frm1.Height = frm1.MdiParent.Height - 95
            'frm1.Width = frm1.MdiParent.Width - 20

            frm1.SpC1.SplitterDistance = CInt(frm1.Width / 8)

            frm1.Show()
            frm1.MdiParent.LayoutMdi(MdiLayout.TileVertical)
            frm1.WindowState = FormWindowState.Maximized
            frm1.ControlBox = False
        Catch ex As Exception
            MessageBox.Show("Erreur lors de la lecture du fichier de configuration: " & Environment.NewLine & ex.Message & Environment.NewLine & ex.StackTrace, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1)
        End Try
    End Sub

    Private Sub frmPlancher_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        Dim r As DialogResult
        r = MessageBox.Show("Voulez-vous quitter l'application ?", "Plancher béton armé", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1)
        If r = Windows.Forms.DialogResult.Yes Then
            e.Cancel = False
            'End
        Else
            e.Cancel = True
        End If
    End Sub
End Class
