﻿Public Class frmPredalDecoup
    Public Annuler As Boolean
    Private Sub BtnPlus_Click(sender As Object, e As EventArgs) Handles BtnPlus.Click
        Dim i As Integer
        ' Dim msg As String = String.Empty
        Dim Verif As Boolean = True
        i = CInt(LblnbTrav.Text)
        Lecture_Tableau(i, Verif)
        If Verif = False Then Exit Sub
        i = i + 1
        If i > PlanCont.Count Then Exit Sub
        LblnbTrav.Text = i.ToString
        Affichage_Tableau(i)
        Pb.Refresh()
    End Sub
    Private Sub BtnMoins_Click(sender As Object, e As EventArgs) Handles BtnMoins.Click
        Dim i As Integer
        Dim Verif As Boolean = True
        Dim msg As String = String.Empty
        i = CInt(LblnbTrav.Text)
        If i = 1 Then Exit Sub 'on ne fait rien
        'sinon on lit les charges renseignées
        Lecture_Tableau(i, Verif)
        If Verif = False Then Exit Sub
        i = i - 1
        LblnbTrav.Text = i.ToString
        Affichage_Tableau(i)
        Pb.Refresh()
    End Sub
    Private Sub FrmPredalDecoup_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Call Affichage_Tableau(1)
        BtnMoins.Visible = False
        '  Pb.Refresh()
    End Sub
    ''' <summary>affichage des données géométriques du tableau de prédalles </summary>
    ''' <param name="i">n° de travée, commence donc à 1 et non à 0</param>
    Private Sub Affichage_Tableau(ByVal i As Integer)
        Dim j As Integer = -1
        Dim i1 As Integer
        Try
            If i = 1 Then BtnMoins.Visible = False Else BtnMoins.Visible = True
            If i = PlanCont.Count Then BtnPlus.Visible = False Else BtnPlus.Visible = True
            With PlanCont.Item(i - 1)
                DgvPredal.RowCount = .Prefa_nb  ' k + 1
                For i1 = 1 To .Prefa_nb
                    j = j + 1
                    DgvPredal.Item(0, j).Value = .Prefa_Num.Item(i1 - 1).ToString("#0")  'n° de prédalle
                    DgvPredal.Item(1, j).Value = .Prefa_Ly.Item(i1 - 1).ToString("#0.00")  'j'affecte au iière travée la largeur préférentielle
                    DgvPredal.Item(2, j).Value = .Prefa_Lx.Item(i1 - 1).ToString("#0.00")  'longueur prédalle
                Next
            End With
        Catch ex As Exception
            MessageBox.Show("Erreur lors de l'écriture du tableau:" & Environment.NewLine & ex.Message, "Affichage géométrie prédalles", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
    Private Sub Lecture_Tableau(ByVal i As Integer, ByRef Verif As Boolean)
        Dim i1, j, k As Integer
        'Dim index_initial, index_final, tour As Integer
        Dim Ly, Lx As Double
        'j = ligne (row)
        'k = colonne (column)
        Try
            ' tour = 0
            For j = 0 To PlanCont.Item(i - 1).Prefa_nb - 1 'lignes
                With PlanCont.Item(i - 1) 'initialisation de dalle à chaque ligne
                    For k = 0 To 2 'colonnes
                        With DgvPredal
                            Select Case k
                                Case 0
                                    i1 = CInt(.Item(k, j).Value) 'n° de prédalle - i1 = j
                                Case 1 'largeur de la prédalle
                                    Ly = CDbl(.Item(k, j).Value)  ' dalle.Prefa_Ly.Item(i1 - 1) 
                                Case 2 'longueur de la prédalle
                                    Lx = CDbl(.Item(k, j).Value)
                            End Select
                        End With
                    Next
                    .Prefa_Num.Item(j) = i1 : .Prefa_Ly.Item(j) = Ly : .Prefa_Lx.Item(j) = Lx 'base 0 !!!
                End With
                'If tour = 0 Then
                '    index_initial = PlanCont.Item(i - 1).Chge.LastIndexOf(Ch1)
                'Else
                '    index_final = PlanCont.Item(i - 1).Chge.LastIndexOf(Ch1)
                'End If
                ' tour = tour + 1
            Next
        Catch ex As Exception
            Verif = False
            MessageBox.Show("Erreur lors de la lecture du tableau:" & vbCrLf & ex.Message, "Affichage géométrie prédalles", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

        'j = 0
        ''gestion des prédalles ajoutées
        'If index_initial = 0 Then
        '    Exit Sub
        'Else
        '    'comparaison
        '    With PlanCont.Item(i - 1).Chge
        '        For i1 = 1 To .Count - tour
        '            For k = index_initial To index_final - j
        '                If .Item(i1 - 1).Num = .Item(k).Num Then 'si même travée et même n° de cas alors remplacement
        '                    .Item(i1 - 1).Nature = .Item(k).Nature
        '                    .Item(i1 - 1).schem = .Item(k).schem
        '                    .Item(i1 - 1).d = .Item(k).d
        '                    .RemoveAt(k) : j = j + 1 : Exit For
        '                End If
        '            Next
        '        Next
        '    End With

        'End If
    End Sub
    Private Sub Pb_Paint(sender As Object, e As PaintEventArgs) Handles Pb.Paint
        Dim g As Graphics = e.Graphics
        Dim hauteur_restante As Double
        Dim i, j, i_tot As Integer
        Dim X, Y, X1, Y1, X2, Y2, oriX, oriY As Single
        Dim msg As String ', F_m1MAX, F_Mmin, F_X
        Dim w As SizeF
        Dim myPen As New Pen(Color.Black, 1)
        'Dim myPen3 As New Pen(Color.Black, 3)
        'Dim myPen2 As New Pen(Color.Black, 2)
        Dim myFont As New Font("Times New Roman", 9, FontStyle.Regular)
        Dim myBrush As New SolidBrush(Color.Black)
        Dim largeur, hauteur As Integer
        largeur = Pb.Width : hauteur = Pb.Height
        'détermination  origine
        Dim L_tot, H_tot, red As Double
        L_tot = PlanCont(0).LappG
        For Each dalle As Plancher In PlanCont
            L_tot = L_tot + dalle.Lx + dalle.LappD
            If H_tot < dalle.Ly Then H_tot = dalle.Ly
        Next
        'détermination des coefficient de réduction:  
        red = (largeur * 0.8) / L_tot
        If H_tot * red > 0.8 * hauteur Then red = (0.8 * hauteur) / H_tot
        oriX = CSng(0.05 * largeur)
        hauteur_restante = hauteur - red * H_tot
        oriY = CSng(hauteur_restante / 2)
        'murs
        'exterieurs horizontal
        X = CSng(oriX) : Y = CSng(oriY)
        X1 = CSng(oriX + red * (PlanCont(0).LappG + PlanCont(0).Lx + PlanCont(0).LappD))
        g.DrawLine(myPen, X, Y, X1, Y)
        Y1 = CSng(oriY + red * (PlanCont(0).LappH + PlanCont(0).Ly + PlanCont(0).LappB))
        g.DrawLine(myPen, X, Y1, X1, Y1)
        For i = 1 To PlanCont.Count - 1
            X = CSng(X1 + red * (PlanCont(i).Lx + PlanCont(i).LappD))
            g.DrawLine(myPen, X1, Y, X, Y) : g.DrawLine(myPen, X1, Y1, X, Y1)
            X1 = X
        Next
        g.DrawLine(myPen, oriX, oriY, oriX, Y1)
        g.DrawLine(myPen, X1, oriY, X1, Y1)
        'interieurs horizontal et vertical
        X = CSng(oriX + red * PlanCont(0).LappG) : Y = CSng(oriY + red * PlanCont(0).LappH)
        X1 = CSng(oriX + red * (PlanCont(0).LappG + PlanCont(0).Lx))
        Y1 = CSng(oriY + red * (PlanCont(0).LappH + PlanCont(0).Ly))
        g.DrawLine(myPen, X, Y, X1, Y) : g.DrawLine(myPen, X, Y1, X1, Y1)
        g.DrawLine(myPen, X, Y, X, Y1) : g.DrawLine(myPen, X1, Y, X1, Y1)
        For i = 1 To PlanCont.Count - 1
            X1 = CSng(X1 + red * (PlanCont(i - 1).LappD))
            X = CSng(X1 + red * PlanCont(i).Lx)
            g.DrawLine(myPen, X1, Y, X, Y) : g.DrawLine(myPen, X1, Y1, X, Y1)
            g.DrawLine(myPen, X1, Y, X1, Y1) : g.DrawLine(myPen, X, Y, X, Y1)
            X1 = X
        Next
        'Découpage des prédalles
        Dim myPen2 As New Pen(Color.Red, 1)
        myPen2.DashStyle = Drawing2D.DashStyle.Dash
        X = CSng(oriX + red * (PlanCont(0).LappG - PlanCont(0).Prefa_ReposG))
        X1 = CSng(oriX + red * (PlanCont(0).LappG + PlanCont(0).Lx + PlanCont(0).Prefa_ReposD))
        For j = 0 To PlanCont.Count - 1
            Y = CSng(oriY + red * (PlanCont(j).LappH))
            For i = 0 To PlanCont(j).Prefa_nb - 1
                Y1 = CSng(Y + red * PlanCont(j).Prefa_Ly(i))
                g.DrawLine(myPen2, X, Y, X1, Y) : g.DrawLine(myPen2, X, Y1, X1, Y1) 'lignes verticales
                g.DrawLine(myPen2, X, Y, X, Y1) : g.DrawLine(myPen2, X1, Y, X1, Y1) 'lignes horizontales
                'indication du n° de prédalle
                X2 = CSng((X + X1) / 2) : Y2 = CSng((Y + Y1) / 2) 'centre du cercle
                g.FillEllipse(Brushes.White, X2 - 10, Y2 - 10, 20, 20) 'je peint en Blanc et efface tout ce qui se trouve dessous
                g.DrawEllipse(myPen, X2 - 10, Y2 - 10, 20, 20)
                i_tot = ((j + 1) * 10 + (i + 1))
                msg = i_tot.ToString("#")
                w = g.MeasureString(msg, myFont)
                g.DrawString(msg, myFont, myBrush, X2 - w.Width / 2, Y2 - w.Height / 2)
                Y = CSng(Y1 + red * PlanCont(j).Prefa_esp)
            Next
            If j = PlanCont.Count - 1 Then Exit For 'pour éviter le plantage
            X = CSng(X1 + red * (PlanCont(j).LappD - PlanCont(j + 1).Prefa_ReposG))
            X1 = CSng(X + red * (PlanCont(j + 1).Lx + PlanCont(j + 1).Prefa_ReposD))
        Next


    End Sub

    Private Sub BtnOK_Click(sender As Object, e As EventArgs) Handles BtnOK.Click
        Annuler = False
        Me.Close()
        Me.Dispose()
        Me.Finalize()
    End Sub

    Private Sub BtnAnnuler_Click(sender As Object, e As EventArgs) Handles BtnAnnuler.Click
        Annuler = True
        Me.Close()
        Me.Dispose()
        Me.Finalize()
    End Sub


End Class