Imports System.Math
Imports System.IO
Public Class frmSectionAcier
    Public Poids, Somme, Somme1 As Double
    ' Dim xl As New Microsoft.Office.Interop.Excel.Application '= fichier des profils
    Private Sub frmSectionAcier_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Somme = 0 : Poids = 0 : Somme1 = 0
        'Chargement en mmoire du fichier Excel contenant les caractristiques gomtriques des profils
        'Cela permet un affichage plus rapide des autres formulaires
        Try
            '  xl.Workbooks.Open(Directory.GetCurrentDirectory.ToString() & "\Catalogue_profils_mtalliques.xls")
        Catch exc As Exception
            Dim msg As String
            msg = "Erreur: " & exc.Message & vbCrLf & "Problme d'accs au fichier des profils"
            MsgBox(msg, MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly, "Calculette Mtal")
            Exit Sub
        End Try
    End Sub

    Public Function CheckAscii(ByVal KeyAscii As Integer) As Integer
        'Ne permettre que la saisie de chiffres, ignorer
        'tout le reste
        CheckAscii = Abs(KeyAscii)
        If KeyAscii < 0 Then
            'Si KeyAscii est transmis sous forme ngative  la routine de vrification, la virgule
            'est galement permise
            If Abs(KeyAscii) = 44 Then
                Exit Function
            End If
        End If
        If Abs(KeyAscii) = 8 Then Exit Function ' touche <-- (del) utilisable
        If Abs(KeyAscii) = 44 Then Exit Function
        If Abs(KeyAscii) < 48 Or Abs(KeyAscii) > 57 Then CheckAscii = 0
    End Function
    Public Sub Gestion_Keypress(ByRef ee As System.Windows.Forms.KeyPressEventArgs, ByVal text1 As System.Windows.Forms.TextBox)
        Dim keyAscii, i As Integer
        keyAscii = Asc(ee.KeyChar)
        If text1.SelectionLength = text1.Text.Length Then
            text1.Clear()
        End If
        If keyAscii = Asc(".") Then
            text1.Text = text1.Text + ","
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        'Pour la gestion des chiffres pour les claviers sans pav numrique comme les portables par exemple
        If keyAscii = Asc("&") Then
            text1.Text = text1.Text + "1"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("") Then
            text1.Text = text1.Text + "2"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = 34 Then ' code "
            text1.Text = text1.Text + "3"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("'") Then
            text1.Text = text1.Text + "4"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("(") Then
            text1.Text = text1.Text + "5"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("-") Then
            text1.Text = text1.Text + "6"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("") Then
            text1.Text = text1.Text + "7"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("_") Then
            text1.Text = text1.Text + "8"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("") Then
            text1.Text = text1.Text + "9"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("") Then
            text1.Text = text1.Text + "0"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        keyAscii = CheckAscii(keyAscii)
        If keyAscii = 0 Then ee.Handled = True
    End Sub

#Region "Gestion des textbox HA"
    Private Sub TextHA6_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextHA6.Enter
        TextHA6.SelectionStart = 0
        TextHA6.SelectionLength = TextHA6.Text.Length
    End Sub
    Private Sub TextHA6_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextHA6.KeyPress
        Call Gestion_Keypress(e, TextHA6)
    End Sub
    Private Sub TextHA6_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextHA6.TextChanged
        Call Calcul_somme()
    End Sub
    Private Sub TextHA8_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextHA8.Enter
        TextHA8.SelectionStart = 0
        TextHA8.SelectionLength = TextHA8.Text.Length
    End Sub
    Private Sub TextHA8_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextHA8.KeyPress
        Call Gestion_Keypress(e, TextHA8)
    End Sub
    Private Sub TextHA8_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextHA8.TextChanged
        Call Calcul_somme()
    End Sub
    Private Sub TextHA10_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextHA10.Enter
        TextHA10.SelectionStart = 0
        TextHA10.SelectionLength = TextHA10.Text.Length
    End Sub
    Private Sub TextHA10_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextHA10.KeyPress
        Call Gestion_Keypress(e, TextHA10)
    End Sub
    Private Sub TextHA10_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextHA10.TextChanged
        Call Calcul_somme()
    End Sub
    Private Sub TextHA12_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextHA12.Enter
        TextHA12.SelectionStart = 0
        TextHA12.SelectionLength = TextHA12.Text.Length
    End Sub
    Private Sub TextHA12_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextHA12.KeyPress
        Call Gestion_Keypress(e, TextHA12)
    End Sub
    Private Sub TextHA12_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextHA12.TextChanged
        Call Calcul_somme()
    End Sub
    Private Sub TextHA14_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextHA14.Enter
        TextHA14.SelectionStart = 0
        TextHA14.SelectionLength = TextHA14.Text.Length
    End Sub
    Private Sub TextHA14_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextHA14.KeyPress
        Call Gestion_Keypress(e, TextHA14)
    End Sub
    Private Sub TextHA14_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextHA14.TextChanged
        Call Calcul_somme()
    End Sub
    Private Sub TextHA16_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextHA16.Enter
        TextHA16.SelectionStart = 0
        TextHA16.SelectionLength = TextHA16.Text.Length
    End Sub
    Private Sub TextHA16_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextHA16.KeyPress
        Call Gestion_Keypress(e, TextHA16)
    End Sub
    Private Sub TextHA16_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextHA16.TextChanged
        Call Calcul_somme()
    End Sub
    Private Sub TextHA20_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextHA20.Enter
        TextHA20.SelectionStart = 0
        TextHA20.SelectionLength = TextHA20.Text.Length
    End Sub
    Private Sub TextHA20_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextHA20.KeyPress
        Call Gestion_Keypress(e, TextHA20)
    End Sub
    Private Sub TextHA20_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextHA20.TextChanged
        Call Calcul_somme()
    End Sub
    Private Sub TextHA25_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextHA25.Enter
        TextHA25.SelectionStart = 0
        TextHA25.SelectionLength = TextHA25.Text.Length
    End Sub
    Private Sub TextHA25_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextHA25.KeyPress
        Call Gestion_Keypress(e, TextHA25)
    End Sub
    Private Sub TextHA25_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextHA25.TextChanged
        Call Calcul_somme()
    End Sub
    Private Sub TextHA32_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextHA32.Enter
        TextHA32.SelectionStart = 0
        TextHA32.SelectionLength = TextHA32.Text.Length
    End Sub
    Private Sub TextHA32_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextHA32.KeyPress
        Call Gestion_Keypress(e, TextHA32)
    End Sub
    Private Sub TextHA32_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextHA32.TextChanged
        Call Calcul_somme()
    End Sub
    Private Sub TextHA40_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextHA40.Enter
        TextHA40.SelectionStart = 0
        TextHA40.SelectionLength = TextHA40.Text.Length
    End Sub
    Private Sub TextHA40_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextHA40.KeyPress
        Call Gestion_Keypress(e, TextHA40)
    End Sub
    Private Sub TextHA40_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextHA40.TextChanged
        Call Calcul_somme()
    End Sub
#End Region

#Region "Gestion des Textbox TS longitudinaux"
    Private Sub TextST10L_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextST10L.Enter
        TextST10L.SelectionStart = 0
        TextST10L.SelectionLength = TextST10L.Text.Length
    End Sub
    Private Sub TextST10L_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextST10L.KeyPress
        Call Gestion_Keypress(e, TextST10L)
    End Sub
    Private Sub TextST10L_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextST10L.TextChanged
        Call Calcul_somme()
    End Sub
    Private Sub TextST20L_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextST20L.Enter
        TextST20L.SelectionStart = 0
        TextST20L.SelectionLength = TextST20L.Text.Length
    End Sub
    Private Sub TextST20L_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextST20L.KeyPress
        Call Gestion_Keypress(e, TextST20L)
    End Sub
    Private Sub TextST20L_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextST20L.TextChanged
        Call Calcul_somme()
    End Sub
    Private Sub TextST25L_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextST25L.Enter
        TextST25L.SelectionStart = 0
        TextST25L.SelectionLength = TextST25L.Text.Length
    End Sub
    Private Sub TextST25L_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextST25L.KeyPress
        Call Gestion_Keypress(e, TextST25L)
    End Sub
    Private Sub TextST25L_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextST25L.TextChanged
        Call Calcul_somme()
    End Sub
    Private Sub TextST30L_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextST30L.Enter
        TextST30L.SelectionStart = 0
        TextST30L.SelectionLength = TextST30L.Text.Length
    End Sub
    Private Sub TextST30L_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextST30L.KeyPress
        Call Gestion_Keypress(e, TextST30L)
    End Sub
    Private Sub TextST30L_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextST30L.TextChanged
        Call Calcul_somme()
    End Sub
    Private Sub TextST35L_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextST35L.Enter
        TextST35L.SelectionStart = 0
        TextST35L.SelectionLength = TextST35L.Text.Length
    End Sub
    Private Sub TextST35L_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextST35L.KeyPress
        Call Gestion_Keypress(e, TextST35L)
    End Sub
    Private Sub TextST35L_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextST35L.TextChanged
        Call Calcul_somme()
    End Sub
    Private Sub TextST50L_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextST50L.Enter
        TextST50L.SelectionStart = 0
        TextST50L.SelectionLength = TextST50L.Text.Length
    End Sub
    Private Sub TextST50L_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextST50L.KeyPress
        Call Gestion_Keypress(e, TextST50L)
    End Sub
    Private Sub TextST50L_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextST50L.TextChanged
        Call Calcul_somme()
    End Sub
    Private Sub TextST60L_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextST60L.Enter
        TextST60L.SelectionStart = 0
        TextST60L.SelectionLength = TextST60L.Text.Length
    End Sub
    Private Sub TextST60L_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextST60L.KeyPress
        Call Gestion_Keypress(e, TextST60L)
    End Sub
    Private Sub TextST60L_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextST60L.TextChanged
        Call Calcul_somme()
    End Sub
    Private Sub TextST15CL_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextST15CL.Enter
        TextST15CL.SelectionStart = 0
        TextST15CL.SelectionLength = TextST15CL.Text.Length
    End Sub
    Private Sub TextST15CL_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextST15CL.KeyPress
        Call Gestion_Keypress(e, TextST15CL)
    End Sub
    Private Sub TextST15CL_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextST15CL.TextChanged
        Call Calcul_somme()
    End Sub
    Private Sub TextST25CL_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextST25CL.Enter
        TextST25CL.SelectionStart = 0
        TextST25CL.SelectionLength = TextST25CL.Text.Length
    End Sub
    Private Sub TextST25CL_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextST25CL.KeyPress
        Call Gestion_Keypress(e, TextST25CL)
    End Sub
    Private Sub TextST25CL_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextST25CL.TextChanged
        Call Calcul_somme()
    End Sub
    Private Sub TextST40CL_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextST40CL.Enter
        TextST40CL.SelectionStart = 0
        TextST40CL.SelectionLength = TextST40CL.Text.Length
    End Sub
    Private Sub TextST40CL_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextST40CL.KeyPress
        Call Gestion_Keypress(e, TextST40CL)
    End Sub
    Private Sub TextST40CL_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextST40CL.TextChanged
        Call Calcul_somme()
    End Sub
    Private Sub TextST50CL_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextST50CL.Enter
        TextST50CL.SelectionStart = 0
        TextST50CL.SelectionLength = TextST50CL.Text.Length
    End Sub
    Private Sub TextST50CL_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextST50CL.KeyPress
        Call Gestion_Keypress(e, TextST50CL)
    End Sub
    Private Sub TextST50CL_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextST50CL.TextChanged
        Call Calcul_somme()
    End Sub
    Private Sub TextST65CL_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextST65CL.Enter
        TextST65CL.SelectionStart = 0
        TextST65CL.SelectionLength = TextST65CL.Text.Length
    End Sub
    Private Sub TextST65CL_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextST65CL.KeyPress
        Call Gestion_Keypress(e, TextST65CL)
    End Sub
    Private Sub TextST65CL_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextST65CL.TextChanged
        Call Calcul_somme()
    End Sub
#End Region

#Region "Gestion des Textbox TS transversaux"
    Private Sub TextST10T_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextST10T.Enter
        TextST10T.SelectionStart = 0
        TextST10T.SelectionLength = TextST10T.Text.Length
    End Sub
    Private Sub TextST10T_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextST10T.KeyPress
        Call Gestion_Keypress(e, TextST10T)
    End Sub
    Private Sub TextST10T_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextST10T.TextChanged
        Call Calcul_somme()
    End Sub
    Private Sub TextST20T_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextST20T.Enter
        TextST20T.SelectionStart = 0
        TextST20T.SelectionLength = TextST20T.Text.Length
    End Sub
    Private Sub TextST20T_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextST20T.KeyPress
        Call Gestion_Keypress(e, TextST20T)
    End Sub
    Private Sub TextST20T_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextST20T.TextChanged
        Call Calcul_somme()
    End Sub
    Private Sub TextST25T_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextST25T.Enter
        TextST25T.SelectionStart = 0
        TextST25T.SelectionLength = TextST25T.Text.Length
    End Sub
    Private Sub TextST25T_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextST25T.KeyPress
        Call Gestion_Keypress(e, TextST25T)
    End Sub
    Private Sub TextST25T_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextST25T.TextChanged
        Call Calcul_somme()
    End Sub
    Private Sub TextST30T_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextST30T.Enter
        TextST30T.SelectionStart = 0
        TextST30T.SelectionLength = TextST30T.Text.Length
    End Sub
    Private Sub TextST30T_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextST30T.KeyPress
        Call Gestion_Keypress(e, TextST30T)
    End Sub
    Private Sub TextST30T_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextST30T.TextChanged
        Call Calcul_somme()
    End Sub
    Private Sub TextST35T_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextST35T.Enter
        TextST35T.SelectionStart = 0
        TextST35T.SelectionLength = TextST35T.Text.Length
    End Sub
    Private Sub TextST35T_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextST35T.KeyPress
        Call Gestion_Keypress(e, TextST35T)
    End Sub
    Private Sub TextST35T_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextST35T.TextChanged
        Call Calcul_somme()
    End Sub
    Private Sub TextST50T_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextST50T.Enter
        TextST50T.SelectionStart = 0
        TextST50T.SelectionLength = TextST50T.Text.Length
    End Sub
    Private Sub TextST50T_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextST50T.KeyPress
        Call Gestion_Keypress(e, TextST50T)
    End Sub
    Private Sub TextST50T_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextST50T.TextChanged
        Call Calcul_somme()
    End Sub
    Private Sub TextST60T_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextST60T.Enter
        TextST60T.SelectionStart = 0
        TextST60T.SelectionLength = TextST60T.Text.Length
    End Sub
    Private Sub TextST60T_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextST60T.KeyPress
        Call Gestion_Keypress(e, TextST60T)
    End Sub
    Private Sub TextST60T_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextST60T.TextChanged
        Call Calcul_somme()
    End Sub
    Private Sub TextST15CT_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextST15CT.Enter
        TextST15CT.SelectionStart = 0
        TextST15CT.SelectionLength = TextST15CT.Text.Length
    End Sub
    Private Sub TextST15CT_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextST15CT.KeyPress
        Call Gestion_Keypress(e, TextST15CT)
    End Sub
    Private Sub TextST15CT_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextST15CT.TextChanged
        Call Calcul_somme()
    End Sub
    Private Sub TextST25CT_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextST25CT.Enter
        TextST25CT.SelectionStart = 0
        TextST25CT.SelectionLength = TextST25CT.Text.Length
    End Sub
    Private Sub TextST25CT_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextST25CT.KeyPress
        Call Gestion_Keypress(e, TextST25CT)
    End Sub
    Private Sub TextST25CT_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextST25CT.TextChanged
        Call Calcul_somme()
    End Sub
    Private Sub TextST40CT_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextST40CT.Enter
        TextST40CT.SelectionStart = 0
        TextST40CT.SelectionLength = TextST40CT.Text.Length
    End Sub
    Private Sub TextST40CT_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextST40CT.KeyPress
        Call Gestion_Keypress(e, TextST40CT)
    End Sub
    Private Sub TextST40CT_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextST40CT.TextChanged
        Call Calcul_somme()
    End Sub
    Private Sub TextST50CT_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextST50CT.Enter
        TextST50CT.SelectionStart = 0
        TextST50CT.SelectionLength = TextST50CT.Text.Length
    End Sub
    Private Sub TextST50CT_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextST50CT.KeyPress
        Call Gestion_Keypress(e, TextST50CT)
    End Sub
    Private Sub TextST50CT_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextST50CT.TextChanged
        Call Calcul_somme()
    End Sub
    Private Sub TextST65CT_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextST65CT.Enter
        TextST65CL.SelectionStart = 0
        TextST65CL.SelectionLength = TextST65CL.Text.Length
    End Sub
    Private Sub TextST65CT_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextST65CT.KeyPress
        Call Gestion_Keypress(e, TextST65CT)
    End Sub
    Private Sub TextST65CT_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextST65CT.TextChanged
        Call Calcul_somme()
    End Sub
#End Region

    Private Sub Calcul_somme() '(ByVal i As Integer, ByVal i1 As Integer, ByVal i2 As Integer, ByVal i3 As Integer)

        Call Lecture()
        Dim F1, f2 As String
        F1 = Format(Somme * 10000, "##0.00") : f2 = Format(Poids, "##0.00")
        TextAsL.Text = F1
        TextPoids.Text = f2
        If Somme1 <> 0 Then
            Dim F3 As String
            F3 = Format(Somme1 * 10000, "##0.00")
            TextAsT.Text = F3
        Else
            TextAsT.Text = "0.00"
        End If

    End Sub
    Private Sub Lecture()
        Dim i As Integer
        Dim S, S1, P As Double
        Somme = 0 : Somme1 = 0 : Poids = 0
        If TextHA6.Text <> "" Then
            i = CInt(TextHA6.Text)
            Call Diam_Poids(1, 1, S, S1, P)
            Somme = Somme + i * S : Poids = Poids + i * P
        End If
        If TextHA8.Text <> "" Then
            i = CInt(TextHA8.Text)
            Call Diam_Poids(1, 2, S, S1, P)
            Somme = Somme + i * S : Poids = Poids + i * P
        End If
        If TextHA10.Text <> "" Then
            i = CInt(TextHA10.Text)
            Call Diam_Poids(1, 3, S, S1, P)
            Somme = Somme + i * S : Poids = Poids + i * P
        End If
        If TextHA12.Text <> "" Then
            i = CInt(TextHA12.Text)
            Call Diam_Poids(1, 4, S, S1, P)
            Somme = Somme + i * S : Poids = Poids + i * P
        End If
        If TextHA14.Text <> "" Then
            i = CInt(TextHA14.Text)
            Call Diam_Poids(1, 5, S, S1, P)
            Somme = Somme + i * S : Poids = Poids + i * P
        End If
        If TextHA16.Text <> "" Then
            i = CInt(TextHA16.Text)
            Call Diam_Poids(1, 6, S, S1, P)
            Somme = Somme + i * S : Poids = Poids + i * P
        End If
        If TextHA20.Text <> "" Then
            i = CInt(TextHA20.Text)
            Call Diam_Poids(1, 7, S, S1, P)
            Somme = Somme + i * S : Poids = Poids + i * P
        End If
        If TextHA25.Text <> "" Then
            i = CInt(TextHA25.Text)
            Call Diam_Poids(1, 8, S, S1, P)
            Somme = Somme + i * S : Poids = Poids + i * P
        End If
        If TextHA32.Text <> "" Then
            i = CInt(TextHA32.Text)
            Call Diam_Poids(1, 9, S, S1, P)
            Somme = Somme + i * S : Poids = Poids + i * P
        End If
        If TextHA40.Text <> "" Then
            i = CInt(TextHA40.Text)
            Call Diam_Poids(1, 10, S, S1, P)
            Somme = Somme + i * S : Poids = Poids + i * P
        End If
        If TextST10L.Text <> "" Then
            i = CInt(TextST10L.Text)
            Call Diam_Poids(2, 1, S, S1, P)
            Somme = Somme + i * S : Somme1 = Somme1 + i * S1 : Poids = Poids + i * P
        End If
        If TextST20L.Text <> "" Then
            i = CInt(TextST20L.Text)
            Call Diam_Poids(2, 2, S, S1, P)
            Somme = Somme + i * S : Somme1 = Somme1 + i * S1 : Poids = Poids + i * P
        End If
        If TextST25L.Text <> "" Then
            i = CInt(TextST25L.Text)
            Call Diam_Poids(2, 3, S, S1, P)
            Somme = Somme + i * S : Somme1 = Somme1 + i * S1 : Poids = Poids + i * P
        End If
        If TextST30L.Text <> "" Then
            i = CInt(TextST30L.Text)
            Call Diam_Poids(2, 4, S, S1, P)
            Somme = Somme + i * S : Somme1 = Somme1 + i * S1 : Poids = Poids + i * P
        End If
        If TextST35L.Text <> "" Then
            i = CInt(TextST35L.Text)
            Call Diam_Poids(2, 5, S, S1, P)
            Somme = Somme + i * S : Somme1 = Somme1 + i * S1 : Poids = Poids + i * P
        End If
        If TextST50L.Text <> "" Then
            i = CInt(TextST50L.Text)
            Call Diam_Poids(2, 6, S, S1, P)
            Somme = Somme + i * S : Somme1 = Somme1 + i * S1 : Poids = Poids + i * P
        End If
        If TextST60L.Text <> "" Then
            i = CInt(TextST60L.Text)
            Call Diam_Poids(2, 7, S, S1, P)
            Somme = Somme + i * S : Somme1 = Somme1 + i * S1 : Poids = Poids + i * P
        End If
        If TextST15CL.Text <> "" Then
            i = CInt(TextST15CL.Text)
            Call Diam_Poids(2, 8, S, S1, P)
            Somme = Somme + i * S : Somme1 = Somme1 + i * S1 : Poids = Poids + i * P
        End If
        If TextST25CL.Text <> "" Then
            i = CInt(TextST25CL.Text)
            Call Diam_Poids(2, 9, S, S1, P)
            Somme = Somme + i * S : Somme1 = Somme1 + i * S1 : Poids = Poids + i * P
        End If
        If TextST40CL.Text <> "" Then
            i = CInt(TextST40CL.Text)
            Call Diam_Poids(2, 10, S, S1, P)
            Somme = Somme + i * S : Somme1 = Somme1 + i * S1 : Poids = Poids + i * P
        End If
        If TextST50CL.Text <> "" Then
            i = CInt(TextST50CL.Text)
            Call Diam_Poids(2, 11, S, S1, P)
            Somme = Somme + i * S : Somme1 = Somme1 + i * S1 : Poids = Poids + i * P
        End If
        If TextST65CL.Text <> "" Then
            i = CInt(TextST65CL.Text)
            Call Diam_Poids(2, 12, S, S1, P)
            Somme = Somme + i * S : Somme1 = Somme1 + i * S1 : Poids = Poids + i * P
        End If
        If TextST10T.Text <> "" Then
            i = CInt(TextST10T.Text)
            Call Diam_Poids(3, 1, S, S1, P)
            Somme = Somme + i * S : Somme1 = Somme1 + i * S1 : Poids = Poids + i * P
        End If
        If TextST20T.Text <> "" Then
            i = CInt(TextST20T.Text)
            Call Diam_Poids(3, 2, S, S1, P)
            Somme = Somme + i * S : Somme1 = Somme1 + i * S1 : Poids = Poids + i * P
        End If
        If TextST25T.Text <> "" Then
            i = CInt(TextST25T.Text)
            Call Diam_Poids(3, 3, S, S1, P)
            Somme = Somme + i * S : Somme1 = Somme1 + i * S1 : Poids = Poids + i * P
        End If
        If TextST30T.Text <> "" Then
            i = CInt(TextST30T.Text)
            Call Diam_Poids(3, 4, S, S1, P)
            Somme = Somme + i * S : Somme1 = Somme1 + i * S1 : Poids = Poids + i * P
        End If
        If TextST35T.Text <> "" Then
            i = CInt(TextST35T.Text)
            Call Diam_Poids(3, 5, S, S1, P)
            Somme = Somme + i * S : Somme1 = Somme1 + i * S1 : Poids = Poids + i * P
        End If
        If TextST50T.Text <> "" Then
            i = CInt(TextST50T.Text)
            Call Diam_Poids(3, 6, S, S1, P)
            Somme = Somme + i * S : Somme1 = Somme1 + i * S1 : Poids = Poids + i * P
        End If
        If TextST60T.Text <> "" Then
            i = CInt(TextST60T.Text)
            Call Diam_Poids(3, 7, S, S1, P)
            Somme = Somme + i * S : Somme1 = Somme1 + i * S1 : Poids = Poids + i * P
        End If
        If TextST15CT.Text <> "" Then
            i = CInt(TextST15CT.Text)
            Call Diam_Poids(3, 8, S, S1, P)
            Somme = Somme + i * S : Somme1 = Somme1 + i * S1 : Poids = Poids + i * P
        End If
        If TextST25CT.Text <> "" Then
            i = CInt(TextST25CT.Text)
            Call Diam_Poids(3, 9, S, S1, P)
            Somme = Somme + i * S : Somme1 = Somme1 + i * S1 : Poids = Poids + i * P
        End If
        If TextST40CT.Text <> "" Then
            i = CInt(TextST40CT.Text)
            Call Diam_Poids(3, 10, S, S1, P)
            Somme = Somme + i * S : Somme1 = Somme1 + i * S1 : Poids = Poids + i * P
        End If
        If TextST50CT.Text <> "" Then
            i = CInt(TextST50CT.Text)
            Call Diam_Poids(3, 11, S, S1, P)
            Somme = Somme + i * S : Somme1 = Somme1 + i * S1 : Poids = Poids + i * P
        End If
        If TextST65CT.Text <> "" Then
            i = CInt(TextST65CT.Text)
            Call Diam_Poids(3, 12, S, S1, P)
            Somme = Somme + i * S : Somme1 = Somme1 + i * S1 : Poids = Poids + i * P
        End If
    End Sub
    Private Sub Diam_Poids(ByVal i As Integer, ByVal i1 As Integer, ByRef S As Double, ByRef S1 As Double, _
                            ByRef P As Double)
        Dim d As Double

        Select Case i
            Case 1 'barres HA
                If i1 < 7 Then
                    d = i1 * 0.002 + 0.004
                ElseIf i1 = 7 Then
                    d = 0.02
                ElseIf i1 = 8 Then
                    d = 0.025
                ElseIf i1 = 9 Then
                    d = 0.032
                Else
                    d = 0.04
                End If
                S = PI * d ^ 2 / 4
                P = 7850 * S
            Case 2 'TS section longitudinale
                Select Case i1
                    Case 1 'st10
                        S = 0.000119 : S1 = 0.000119 : P = 1.87
                    Case 2 'st20
                        S = 0.000189 : S1 = 0.000128 : P = 2.487
                    Case 3 'st25
                        S = 0.000257 : S1 = 0.000128 : P = 3.02
                    Case 4 'ST30
                        S = 0.000283 : S1 = 0.000128 : P = 3.226
                    Case 5 'ST35
                        S = 0.000385 : S1 = 0.000128 : P = 4.026
                    Case 6 'ST50
                        S = 0.000503 : S1 = 0.000168 : P = 5.267
                    Case 7 'ST60
                        S = 0.000636 : S1 = 0.000252 : P = 6.965
                    Case 8 'ST15C
                        S = 0.000142 : S1 = 0.000142 : P = 2.22
                    Case 9 'ST25C
                        S = 0.000257 : S1 = 0.000257 : P = 4.026
                    Case 10 'ST40C
                        S = 0.000385 : S1 = 0.000385 : P = 6.04
                    Case 11 'ST50C
                        S = 0.000503 : S1 = 0.000503 : P = 7.9
                    Case 12 'ST65C
                        S = 0.000636 : S1 = 0.000636 : P = 9.98
                End Select
            Case 3 'TS section transversale
                Select Case i1
                    Case 1 'st10
                        S = 0.000119 : S1 = 0.000119 : P = 1.87
                    Case 2 'st20
                        S = 0.000128 : S1 = 0.000189 : P = 2.487
                    Case 3 'st25
                        S = 0.000128 : S1 = 0.000257 : P = 3.02
                    Case 4 'ST30
                        S = 0.000128 : S1 = 0.000283 : P = 3.226
                    Case 5 'ST35
                        S = 0.000128 : S1 = 0.000385 : P = 4.026
                    Case 6 'ST50
                        S = 0.000168 : S1 = 0.000503 : P = 5.267
                    Case 7 'ST60
                        S = 0.000252 : S1 = 0.000636 : P = 6.965
                    Case 8 'ST15C
                        S = 0.000142 : S1 = 0.000142 : P = 2.22
                    Case 9 'ST25C
                        S = 0.000257 : S1 = 0.000257 : P = 4.026
                    Case 10 'ST40C
                        S = 0.000385 : S1 = 0.000385 : P = 6.04
                    Case 11 'ST50C
                        S = 0.000503 : S1 = 0.000503 : P = 7.9
                    Case 12 'ST65C
                        S = 0.000636 : S1 = 0.000636 : P = 9.98
                End Select
        End Select
    End Sub

    Private Sub BtnApropos_Click(sender As Object, e As EventArgs) Handles BtnApropos.Click
        Dim frmsplash1 As frmApropos
        frmsplash1 = New frmApropos
        frmsplash1.ShowDialog()
    End Sub

    Private Sub BtnZero_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnZero.Click
        Somme = 0 : Poids = 0 : Somme1 = 0
        TextHA6.Text = "" : TextHA8.Text = "" : TextHA10.Text = "" : TextHA12.Text = "" : TextHA14.Text = ""
        TextHA16.Text = "" : TextHA20.Text = "" : TextHA25.Text = "" : TextHA32.Text = "" : TextHA40.Text = ""
        TextST10L.Text = "" : TextST20L.Text = "" : TextST25L.Text = "" : TextST30L.Text = "" : TextST35L.Text = "" : TextST50L.Text = "" : TextST60L.Text = "" : TextST15CL.Text = "" : TextST25CL.Text = "" : TextST40CL.Text = "" : TextST50CL.Text = "" : TextST65CL.Text = ""
        TextST10T.Text = "" : TextST20T.Text = "" : TextST25T.Text = "" : TextST30T.Text = "" : TextST35T.Text = "" : TextST50T.Text = "" : TextST60T.Text = "" : TextST15CT.Text = "" : TextST25CT.Text = "" : TextST40CT.Text = "" : TextST50CT.Text = "" : TextST65CT.Text = ""

    End Sub

    Private Sub Poubelle()
        'Variables:
        'i= nbre de barres HA ou de TS
        'i1 = indice de l'acier dans la colonne n1
        'i2 = indice de l'acier dans la colonne n2
        'i3 = indice de l'acier dans la colonne n3
        'Dim S, P, P1, S1, S2, Som, Som1, Po1 As Double
        'Dim i4 As Integer

        'If i1 > 0 Then 'barres HA
        '    Call Diam_Poids(1, i1, S, P)
        '    i4 = 1 'colonne 1
        'ElseIf i2 > 0 Then 'TS longitudinal
        '    Call Diam_Poids(2, i1, S, P)
        '    i4 = 2 'colonne 2
        'Else 'TS transversal
        '    Call Diam_Poids(3, i1, S, P)
        '    i4 = 3 'colonne 3
        'End If
        'If ic = i4 Then
        '    Select Case i4
        '        Case 1
        '            If Inum = i1 Then
        '                'mme type d'acier et indice prcdent identique  l'indice actuellement transmis
        '                If ChkbHA.Checked = True Or ChkbTSL.Checked = True Then Som = Somme + i * S - S1
        '                If ChkbTST.Checked = True Then Som1 = Somme1 + i * S - S2
        '                Po1 = Poids + i * P - P1
        '                S1 = Som - Somme : S2 = Som1 - Somme1 : P1 = Po1 - Poids
        '                Somme = Som : Somme1 = Som1 : Poids = Po1
        '            Else
        '                'mme type d'acier MAIS indice prcdent diffrent de l'indice actuellement transmis
        '                If ChkbHA.Checked = True Or ChkbTSL.Checked = True Then Som1 = Somme + i * S
        '                If ChkbTST.Checked = True Then Somme1 = Somme1 + i * S
        '                Poids = Poids + i * P

        '            End If
        '            Inum = i1
        '        Case 2
        '            If Inum = i2 Then

        '            Else
        '                If ChkbHA.Checked = True Or ChkbTSL.Checked = True Then Somme = Somme + i * S
        '                If ChkbTST.Checked = True Then Somme1 = Somme1 + i * S
        '                Poids = Poids + i * P
        '            End If
        '            Inum = i2
        '        Case 3
        '            If Inum = i3 Then

        '            Else
        '                If ChkbHA.Checked = True Or ChkbTSL.Checked = True Then Somme = Somme + i * S
        '                If ChkbTST.Checked = True Then Somme1 = Somme1 + i * S
        '                Poids = Poids + i * P
        '            End If
        '            Inum = i3
        '    End Select
        'Else
        '    If ChkbHA.Checked = True Or ChkbTSL.Checked = True Then Somme = Somme + i * S
        '    If ChkbTST.Checked = True Then Somme1 = Somme1 + i * S
        '    Poids = Poids + i * P
        '    Select Case i4
        '        Case 1
        '            Inum = i1
        '        Case 2
        '            Inum = i2
        '        Case 3
        '            Inum = i3
        '    End Select
        'End If
        'ic = i4
    End Sub

End Class
